unit CNCSettings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, DeskWinApi, DeskWinCNC, UiTypes, Vcl.Mask;

type
  TFormCNCSettings = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxCNCSettings: TGroupBox;
    EditMaximumZ: TLabeledEdit;
    EditMinimumZ: TLabeledEdit;
    EditMaximumY: TLabeledEdit;
    EditMinimumY: TLabeledEdit;
    EditMaximumX: TLabeledEdit;
    EditMinimumX: TLabeledEdit;
    EditZStepsPerMM: TLabeledEdit;
    EditAStepsPerRev: TLabeledEdit;
    EditYStepsPerMM: TLabeledEdit;
    EditXStepsPerMM: TLabeledEdit;
    EditJogSpeed: TLabeledEdit;
    EditCNCAcceleration: TLabeledEdit;
    EditCNCMaxStepsPerSecond: TLabeledEdit;
    EditCNCStartStepsPerSecond: TLabeledEdit;
    EditCNCScale: TLabeledEdit;
    EditCNCComPort: TLabeledEdit;
    GroupBoxControlTest: TGroupBox;
    ButtonHome: TButton;
    CheckBoxDualYAxis: TCheckBox;
    GroupBoxActuatorSettings: TGroupBox;
    EditPickDelay: TLabeledEdit;
    EditPlaceDelay: TLabeledEdit;
    EditActuatorOnDelay: TLabeledEdit;
    EditBlowDelay: TLabeledEdit;
    EditFastPlaceSpeed: TLabeledEdit;
    EditSlowPlaceSpeed: TLabeledEdit;
    ButtonDispenser: TButton;
    ButtonVacuum: TButton;
    ButtonBlow: TButton;
    ButtonFeeder: TButton;
    ButtonReset: TButton;
    EditHomeZ: TLabeledEdit;
    EditPickRetryCount: TLabeledEdit;
    GroupBoxJogControl: TGroupBox;
    ButtonJogAMinus: TButton;
    ButtonJogAPlus: TButton;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonAMinus1: TButton;
    ButtonAPlus1: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonAMinus10: TButton;
    ButtonAPlus10: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    EditActuatorOffDelay: TLabeledEdit;
    EditPlaceZPush: TLabeledEdit;
    EditMediumPlaceSpeed: TLabeledEdit;
    CheckBoxVisualHome: TCheckBox;
    procedure ButtonInitialiseClick(Sender: TObject);
    procedure ButtonHomeClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditMinimumXChange(Sender: TObject);
    procedure EditMaximumXChange(Sender: TObject);
    procedure EditMinimumYChange(Sender: TObject);
    procedure EditMinimumZChange(Sender: TObject);
    procedure EditMaximumYChange(Sender: TObject);
    procedure EditMaximumZChange(Sender: TObject);
    procedure EditXStepsPerMMChange(Sender: TObject);
    procedure EditYStepsPerMMChange(Sender: TObject);
    procedure EditZStepsPerMMChange(Sender: TObject);
    procedure EditAStepsPerRevChange(Sender: TObject);
    procedure EditCNCComPortChange(Sender: TObject);
    procedure EditCNCAccelerationChange(Sender: TObject);
    procedure EditCNCScaleChange(Sender: TObject);
    procedure EditCNCMaxStepsPerSecondChange(Sender: TObject);
    procedure EditCNCStartStepsPerSecondChange(Sender: TObject);
    procedure EditJogSpeedChange(Sender: TObject);
    procedure CheckBoxDualYAxisClick(Sender: TObject);
    procedure EditPickDelayChange(Sender: TObject);
    procedure EditPlaceDelayChange(Sender: TObject);
    procedure EditActuatorOnDelayChange(Sender: TObject);
    procedure EditBlowDelayChange(Sender: TObject);
    procedure ButtonFeederMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonFeederMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonBlowMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonBlowMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonDispenserMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonDispenserMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonVacuumMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonVacuumMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonSetHome1Click(Sender: TObject);
    procedure ButtonSetHome2Click(Sender: TObject);
    procedure EditHomeZChange(Sender: TObject);
    procedure EditFastPlaceSpeedChange(Sender: TObject);
    procedure EditSlowPlaceSpeedChange(Sender: TObject);
    procedure EditPickRetryCountChange(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonAPlus10Click(Sender: TObject);
    procedure ButtonAPlus1Click(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure ButtonJogAMinusClick(Sender: TObject);
    procedure ButtonAMinus1Click(Sender: TObject);
    procedure ButtonAMinus10Click(Sender: TObject);
    procedure EditActuatorOffDelayChange(Sender: TObject);
    procedure EditPlaceZPushChange(Sender: TObject);
    procedure EditMediumPlaceSpeedChange(Sender: TObject);
    procedure CheckBoxVisualHomeClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    Enabled: boolean;
    procedure UpdateButtons;
    procedure UpdateValues;
  public
    { Public declarations }
  end;

var
  FormCNCSettings: TFormCNCSettings;

implementation

{$R *.dfm}

uses
  Main, Settings, VisionSettings, NozzleChanger;

procedure TFormCNCSettings.UpdateValues;
begin
  Enabled := false; // disable settings validation

  // ******************************************************************************

  EditJogSpeed.Text := IntToStr(CNCJogSpeed);

  EditCNCComPort.Text := IntToStr(CNCComPort);

  CheckBoxDualYAxis.Checked := CNCDualYAxis;
  CheckBoxVisualHome.Checked := CNCVisualHome;

  EditMinimumX.Text := FloatToStrF(CNCMinX, ffFixed, 10, 3);
  EditMaximumX.Text := FloatToStrF(CNCMaxX, ffFixed, 10, 3);
  EditMinimumY.Text := FloatToStrF(CNCMinY, ffFixed, 10, 3);
  EditMaximumY.Text := FloatToStrF(CNCMaxY, ffFixed, 10, 3);
  EditMinimumZ.Text := FloatToStrF(CNCMinZ, ffFixed, 10, 3);
  EditMaximumZ.Text := FloatToStrF(CNCMaxZ, ffFixed, 10, 3);

  EditXStepsPerMM.Text := FloatToStrF(CNCXStepsPerMM, ffFixed, 10, 8);
  EditYStepsPerMM.Text := FloatToStrF(CNCYStepsPerMM, ffFixed, 10, 8);
  EditZStepsPerMM.Text := FloatToStrF(CNCZStepsPerMM, ffFixed, 10, 8);
  EditAStepsPerRev.Text := FloatToStrF(CNCAStepsPerRev, ffFixed, 10, 6);

  EditCNCAcceleration.Text := IntToStr(CNCAcceleration);
  EditCNCMaxStepsPerSecond.Text := IntToStr(CNCMaxStepsPerSecond);
  EditCNCStartStepsPerSecond.Text := IntToStr(CNCStartStepsPerSecond);
  EditCNCScale.Text := IntToStr(CNCScale);

  EditHomeZ.Text := FloatToStrF(CNCHomeZ, ffFixed, 10, 3);

  EditPlaceZPush.Text := FloatToStrF(PlaceZPush, ffFixed, 10, 3);
  EditPickDelay.Text := FloatToStrF(PickDelay, ffFixed, 10, 3);
  EditPlaceDelay.Text := FloatToStrF(PlaceDelay, ffFixed, 10, 3);
  EditActuatorOnDelay.Text := FloatToStrF(ActuatorOnDelay, ffFixed, 10, 3);
  EditActuatorOffDelay.Text := FloatToStrF(ActuatorOffDelay, ffFixed, 10, 3);
  EditBlowDelay.Text := FloatToStrF(BlowDelay, ffFixed, 10, 3);

  EditFastPlaceSpeed.Text := IntToStr(FastPlaceSpeed);
  EditMediumPlaceSpeed.Text := IntToStr(MediumPlaceSpeed);
  EditSlowPlaceSpeed.Text := IntToStr(SlowPlaceSpeed);

  EditPickRetryCount.Text := IntToStr(PickRetryCount);

  // ******************************************************************************

  Enabled := true; // enable settings validation
end;

procedure TFormCNCSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings; // ensure the settings are saved first
end;

procedure TFormCNCSettings.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateValues;
  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormCNCSettings.UpdateButtons;
begin
  ButtonReset.Enabled := not(CNCControllerFound and CNCInitialised);
  ButtonHome.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonFeeder.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonBlow.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonVacuum.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonDispenser.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  CheckBoxDualYAxis.Enabled := CNCVisualHome;
end;

procedure TFormCNCSettings.ButtonBlowMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputBlow(true);
end;

procedure TFormCNCSettings.ButtonBlowMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputBlow(false);
end;

procedure TFormCNCSettings.ButtonDispenserMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputDispenser(true);
end;

procedure TFormCNCSettings.ButtonDispenserMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputDispenser(false);
end;

procedure TFormCNCSettings.ButtonFeederMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputFeeder(true);
end;

procedure TFormCNCSettings.ButtonFeederMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputFeeder(false);
end;

procedure TFormCNCSettings.ButtonHomeClick(Sender: TObject);
begin
  FormMain.Home;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.ButtonInitialiseClick(Sender: TObject);
begin
  CNCEmergencyStop := false;
  FormMain.UpdateStatus;
  Application.ProcessMessages;

  if FormMain.Initialise then
  begin
    FormMain.UpdateStatus;
    Application.ProcessMessages;

    FormMain.Home;
  end
  else
  begin
    FormMain.Speak('FAILED TO INITIALISE CNC CONTROLLER');
    MessageDlg('FAILED TO INITIALISE CNC CONTROLLER!', mtError, [mbCancel], 0, mbCancel);
  end;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.ButtonSetHome1Click(Sender: TObject);
begin
  CNCHome1X := CNCXPos;
  CNCHome1Y := CNCYPos;
  UpdateValues;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.ButtonSetHome2Click(Sender: TObject);
begin
  CNCHome2X := CNCXPos;
  CNCHome2Y := CNCYPos;
  UpdateValues;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.ButtonVacuumMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputVacuum(true);
end;

procedure TFormCNCSettings.ButtonVacuumMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  SetOutputVacuum(false);
end;

procedure TFormCNCSettings.CheckBoxDualYAxisClick(Sender: TObject);
begin
  if Enabled then
  begin
    CNCDualYAxis := CheckBoxDualYAxis.Checked;
    CNCInitialised := false; // invalidate controller
    UpdateValues;
  end;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.CheckBoxVisualHomeClick(Sender: TObject);
begin
  if Enabled then
  begin
    CNCVisualHome := CheckBoxVisualHome.Checked;
    CNCInitialised := false; // invalidate controller
    UpdateValues;
  end;

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditActuatorOffDelayChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditActuatorOffDelay.Text);
      if (V > 0) and (V < 2) then // restrict range
      begin
        ActuatorOffDelay := V;
        EditActuatorOffDelay.Color := clWindow; // normal colour
      end
      else
        EditActuatorOffDelay.Color := clRed; // error colour
    except
      EditActuatorOffDelay.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditActuatorOnDelayChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditActuatorOnDelay.Text);
      if (V > 0) and (V < 2) then // restrict range
      begin
        ActuatorOnDelay := V;
        EditActuatorOnDelay.Color := clWindow; // normal colour
      end
      else
        EditActuatorOnDelay.Color := clRed; // error colour
    except
      EditActuatorOnDelay.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditAStepsPerRevChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditAStepsPerRev.Text);
      if (V > 0) and (V < 20000) then // restrict range
      begin
        CNCAStepsPerRev := V;
        EditAStepsPerRev.Color := clWindow; // normal colour
      end
      else
        EditAStepsPerRev.Color := clRed; // error colour
    except
      EditAStepsPerRev.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditBlowDelayChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditBlowDelay.Text);
      if (V > 0) and (V < 2) then // restrict range
      begin
        BlowDelay := V;
        EditBlowDelay.Color := clWindow; // normal colour
      end
      else
        EditBlowDelay.Color := clRed; // error colour
    except
      EditBlowDelay.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditCNCAccelerationChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditCNCAcceleration.Text);
      if (V > 1000) and (V < 100000000) then // restrict range
      begin
        CNCAcceleration := V;
        CNCInitialised := false; // invalidate controller
        EditCNCAcceleration.Color := clWindow; // normal colour
      end
      else
        EditCNCAcceleration.Color := clRed; // error colour
    except
      EditCNCAcceleration.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditCNCComPortChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditCNCComPort.Text);
      if (V > 0) and (V < 256) then // restrict range
      begin
        CNCComPort := V;
        CNCInitialised := false; // invalidate controller
        EditCNCComPort.Color := clWindow; // normal colour
      end
      else
        EditCNCComPort.Color := clRed; // error colour
    except
      EditCNCComPort.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditCNCMaxStepsPerSecondChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditCNCMaxStepsPerSecond.Text);
      if (V > 400) and (V < 1000000) then // restrict range
      begin
        CNCMaxStepsPerSecond := V;
        CNCInitialised := false; // invalidate controller
        EditCNCMaxStepsPerSecond.Color := clWindow; // normal colour
      end
      else
        EditCNCMaxStepsPerSecond.Color := clRed; // error colour
    except
      EditCNCMaxStepsPerSecond.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditCNCScaleChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditCNCScale.Text);
      if (V > 0) and (V < 256) then // restrict range
      begin
        CNCScale := V;
        CNCInitialised := false; // invalidate controller
        EditCNCScale.Color := clWindow; // normal colour
      end
      else
        EditCNCScale.Color := clRed; // error colour
    except
      EditCNCScale.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditCNCStartStepsPerSecondChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditCNCStartStepsPerSecond.Text);
      if (V > 100) and (V < 1000000) then // restrict range
      begin
        CNCStartStepsPerSecond := V;
        CNCInitialised := false; // invalidate controller
        EditCNCStartStepsPerSecond.Color := clWindow; // normal colour
      end
      else
        EditCNCStartStepsPerSecond.Color := clRed; // error colour
    except
      EditCNCStartStepsPerSecond.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditJogSpeedChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditJogSpeed.Text);
      if (V > 100) and (V < 1000000) then // restrict range
      begin
        CNCJogSpeed := V;
        EditJogSpeed.Color := clWindow; // normal colour
      end
      else
        EditJogSpeed.Color := clRed; // error colour
    except
      EditJogSpeed.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMaximumXChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMaximumX.Text);
      if (V > 0) and (V < 2000) then // restrict range
      begin
        CNCMaxX := V;
        EditMaximumX.Color := clWindow; // normal colour
      end
      else
        EditMaximumX.Color := clRed; // error colour
    except
      EditMaximumX.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMaximumYChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMaximumY.Text);
      if (V > 0) and (V < 2000) then // restrict range
      begin
        CNCMaxY := V;
        EditMaximumY.Color := clWindow; // normal colour
      end
      else
        EditMaximumY.Color := clRed; // error colour
    except
      EditMaximumY.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMaximumZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMaximumZ.Text);
      if (V > 0) and (V < 2000) then // restrict range
      begin
        CNCMaxZ := V;
        EditMaximumZ.Color := clWindow; // normal colour
      end
      else
        EditMaximumZ.Color := clRed; // error colour
    except
      EditMaximumZ.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMediumPlaceSpeedChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditMediumPlaceSpeed.Text);
      if (V > 0) and (V <= CNCMaxStepsPerSecond) then // restrict range
      begin
        MediumPlaceSpeed := V;
        EditMediumPlaceSpeed.Color := clWindow; // normal colour
      end
      else
        EditMediumPlaceSpeed.Color := clRed; // error colour
    except
      EditMediumPlaceSpeed.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMinimumXChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMinimumX.Text);
      if (V > -100) and (V < 2000) then // restrict range
      begin
        CNCMinX := V;
        EditMinimumX.Color := clWindow; // normal colour
      end
      else
        EditMinimumX.Color := clRed; // error colour
    except
      EditMinimumX.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMinimumYChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMinimumY.Text);
      if (V > -100) and (V < 2000) then // restrict range
      begin
        CNCMinY := V;
        EditMinimumY.Color := clWindow; // normal colour
      end
      else
        EditMinimumY.Color := clRed; // error colour
    except
      EditMinimumY.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditMinimumZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditMinimumZ.Text);
      if (V > -100) and (V < 2000) then // restrict range
      begin
        CNCMinZ := V;
        EditMinimumZ.Color := clWindow; // normal colour
      end
      else
        EditMinimumZ.Color := clRed; // error colour
    except
      EditMinimumZ.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditPickDelayChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPickDelay.Text);
      if (V > 0) and (V < 2) then // restrict range
      begin
        PickDelay := V;
        EditPickDelay.Color := clWindow; // normal colour
      end
      else
        EditPickDelay.Color := clRed; // error colour
    except
      EditPickDelay.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditPickRetryCountChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditPickRetryCount.Text);
      if (V > 0) and (V <= 10) then // restrict range
      begin
        PickRetryCount := V;
        EditPickRetryCount.Color := clWindow; // normal colour
      end
      else
        EditPickRetryCount.Color := clRed; // error colour
    except
      EditPickRetryCount.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditPlaceDelayChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPlaceDelay.Text);
      if (V > 0) and (V < 2) then // restrict range
      begin
        PlaceDelay := V;
        EditPlaceDelay.Color := clWindow; // normal colour
      end
      else
        EditPlaceDelay.Color := clRed; // error colour
    except
      EditPlaceDelay.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditFastPlaceSpeedChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditFastPlaceSpeed.Text);
      if (V > 0) and (V <= CNCMaxStepsPerSecond) then // restrict range
      begin
        FastPlaceSpeed := V;
        EditFastPlaceSpeed.Color := clWindow; // normal colour
      end
      else
        EditFastPlaceSpeed.Color := clRed; // error colour
    except
      EditFastPlaceSpeed.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditPlaceZPushChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPlaceZPush.Text);
      if (V >= 0) and (V < 3) then // restrict range
      begin
        PlaceZPush := V;
        EditPlaceZPush.Color := clWindow; // normal colour
      end
      else
        EditPlaceZPush.Color := clRed; // error colour
    except
      EditPlaceZPush.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditSlowPlaceSpeedChange(Sender: TObject);
var
  V: Integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditSlowPlaceSpeed.Text);
      if (V > 0) and (V <= CNCMaxStepsPerSecond) then // restrict range
      begin
        SlowPlaceSpeed := V;
        EditSlowPlaceSpeed.Color := clWindow; // normal colour
      end
      else
        EditSlowPlaceSpeed.Color := clRed; // error colour
    except
      EditSlowPlaceSpeed.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditXStepsPerMMChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditXStepsPerMM.Text);
      if (V > 0) and (V < 1000) then // restrict range
      begin
        CNCXStepsPerMM := V;
        EditXStepsPerMM.Color := clWindow; // normal colour
      end
      else
        EditXStepsPerMM.Color := clRed; // error colour
    except
      EditXStepsPerMM.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditYStepsPerMMChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditYStepsPerMM.Text);
      if (V > 0) and (V < 1000) then // restrict range
      begin
        CNCYStepsPerMM := V;
        EditYStepsPerMM.Color := clWindow; // normal colour
      end
      else
        EditYStepsPerMM.Color := clRed; // error colour
    except
      EditYStepsPerMM.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditZStepsPerMMChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditZStepsPerMM.Text);
      if (V > 0) and (V < 1000) then // restrict range
      begin
        CNCZStepsPerMM := V;
        EditZStepsPerMM.Color := clWindow; // normal colour
      end
      else
        EditZStepsPerMM.Color := clRed; // error colour
    except
      EditZStepsPerMM.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.EditHomeZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHomeZ.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then // restrict range
      begin
        CNCHomeZ := V;
        EditHomeZ.Color := clWindow; // normal colour
      end
      else
        EditHomeZ.Color := clRed; // error colour
    except
      EditHomeZ.Color := clRed; // error colour
    end;
  end;
  UpdateButtons;
end;

procedure TFormCNCSettings.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonAMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonAMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonAPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonAPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogAMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1 / CNCAStepsPerRev * 360;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1 / CNCAStepsPerRev * 360;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormCNCSettings.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
