unit CameraSettings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, LPComponent,
  SLComponentCollection, VLCommonDisplay, VLDSImageDisplay, VLDSCapture,
  VLSnapshot, VLCommonFilter, VLBasicGenericFilter, VLGenericFilter, VLImageDisplay,
  Image, ImageIO, ImageIOVideo, Settings, ExtCtrls;

type
  TFormCameraSettings = class(TForm)
    ButtonClose: TBitBtn;
    ButtonSetupUp: TButton;
    ButtonSetupDown: TButton;
    EditUplookingViewWidthInMM: TLabeledEdit;
    EditDownlookingViewWidthInMM: TLabeledEdit;
    procedure ButtonSetupDownClick(Sender: TObject);
    procedure ButtonSetupUpClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditDownlookingViewWidthInMMChange(Sender: TObject);
    procedure EditUplookingViewWidthInMMChange(Sender: TObject);
  private
    { Private declarations }
    OldViewSelection : integer;
  public
    { Public declarations }
  end;

var
  FormCameraSettings: TFormCameraSettings;

implementation

uses Main;

{$R *.dfm}

procedure TFormCameraSettings.ButtonSetupDownClick(Sender: TObject);
var
  D: TVLDSCaptureDialogs;
  S: string;
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateButtons;
  try
    S := FormMain.VLDSCaptureDown.VideoCaptureDevice.DeviceName;
    if FormMain.VLDSCaptureDown.VideoCaptureDevice.ShowDeviceSelctDialog then
    begin
      if S <> FormMain.VLDSCaptureDown.VideoCaptureDevice.DeviceName then
      begin
        S := FormMain.VLDSCaptureDown.VideoCaptureDevice.DeviceName;
        FormMain.VLDSCaptureDown.Stop;
        FormMain.VLDSCaptureDown.Start;
      end;
      try
        D := FormMain.VLDSCaptureDown.AvailableVideoDialogs;

        if cdVideoCapture in D then
          try
            FormMain.VLDSCaptureDown.ShowVideoDialog(cdVideoCapture);
          except

          end;
      except

      end;
    end;
  except

  end;
  DownLookingDeviceName := S;
end;

procedure TFormCameraSettings.ButtonSetupUpClick(Sender: TObject);
var
  D: TVLDSCaptureDialogs;
  S: string;
begin
  ViewSelection := 1; // uplooking camera
  FormMain.UpdateButtons;
  try
    S := FormMain.VLDSCaptureUp.VideoCaptureDevice.DeviceName;
    if FormMain.VLDSCaptureUp.VideoCaptureDevice.ShowDeviceSelctDialog then
    begin
      if S <> FormMain.VLDSCaptureUp.VideoCaptureDevice.DeviceName then
      begin
        S := FormMain.VLDSCaptureUp.VideoCaptureDevice.DeviceName;
        FormMain.VLDSCaptureUp.Stop;
        FormMain.VLDSCaptureUp.Start;
      end;
      try
        D := FormMain.VLDSCaptureUp.AvailableVideoDialogs;

        if cdVideoCapture in D then
          try
            FormMain.VLDSCaptureUp.ShowVideoDialog(cdVideoCapture);
          except

          end;
      except

      end;
    end;
  except

  end;
  UpLookingDeviceName := S;
end;

procedure TFormCameraSettings.EditDownlookingViewWidthInMMChange(
  Sender: TObject);
var
  V : integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditDownlookingViewWidthInMM.Text);
      if (V > 0) and (V < 100) then  // restrict range
      begin
        DownlookingViewWidthInMM := V;
        EditDownlookingViewWidthInMM.Color := clWindow; // normal colour
      end
      else
        EditDownlookingViewWidthInMM.Color := clRed; // error colour
    except
      EditDownlookingViewWidthInMM.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormCameraSettings.EditUplookingViewWidthInMMChange(Sender: TObject);
var
  V : integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditUplookingViewWidthInMM.Text);
      if (V > 0) and (V < 100) then  // restrict range
      begin
        UplookingViewWidthInMM := V;
        EditUplookingViewWidthInMM.Color := clWindow; // normal colour
      end
      else
        EditUplookingViewWidthInMM.Color := clRed; // error colour
    except
      EditUplookingViewWidthInMM.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormCameraSettings.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ViewSelection := OldViewSelection;  // restore view
  FormMain.UpdateButtons;
end;

procedure TFormCameraSettings.FormShow(Sender: TObject);
begin
  OldViewSelection := ViewSelection;  // preserve view
  EditUplookingViewWidthInMM.Text := IntToStr(UplookingViewWidthInMM);
  EditDownlookingViewWidthInMM.Text := IntToStr(DownlookingViewWidthInMM);
end;

end.
