unit CreateSnap;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, FilterWindow, ImageIOVideo, Image;

type
  TFormCreateSnap = class(TForm)
    PanelReference: TPanel;
    ImageMain: TImage;
    PanelReferenceBoxLeft: TPanel;
    PanelReferenceBoxRight: TPanel;
    PanelReferenceBoxTop: TPanel;
    PanelReferenceBoxBottom: TPanel;
    PanelReferenceCrosshairX: TPanel;
    PanelReferenceCrosshairY: TPanel;
    ButtonOk: TBitBtn;
    ButtonCancel: TBitBtn;
    FileSaveDialog1: TSaveDialog;
    PanelH1: TPanel;
    PanelH10: TPanel;
    PanelH11: TPanel;
    PanelH12: TPanel;
    PanelH13: TPanel;
    PanelH14: TPanel;
    PanelH15: TPanel;
    PanelH16: TPanel;
    PanelH17: TPanel;
    PanelH18: TPanel;
    PanelH19: TPanel;
    PanelH2: TPanel;
    PanelH20: TPanel;
    PanelH21: TPanel;
    PanelH22: TPanel;
    PanelH23: TPanel;
    PanelH24: TPanel;
    PanelH25: TPanel;
    PanelH26: TPanel;
    PanelH27: TPanel;
    PanelH28: TPanel;
    PanelH29: TPanel;
    PanelH3: TPanel;
    PanelH30: TPanel;
    PanelH4: TPanel;
    PanelH5: TPanel;
    PanelH6: TPanel;
    PanelH7: TPanel;
    PanelH8: TPanel;
    PanelH9: TPanel;
    PanelV1: TPanel;
    PanelV10: TPanel;
    PanelV11: TPanel;
    PanelV12: TPanel;
    PanelV13: TPanel;
    PanelV14: TPanel;
    PanelV15: TPanel;
    PanelV16: TPanel;
    PanelV17: TPanel;
    PanelV18: TPanel;
    PanelV19: TPanel;
    PanelV2: TPanel;
    PanelV20: TPanel;
    PanelV21: TPanel;
    PanelV22: TPanel;
    PanelV23: TPanel;
    PanelV24: TPanel;
    PanelV25: TPanel;
    PanelV26: TPanel;
    PanelV27: TPanel;
    PanelV28: TPanel;
    PanelV29: TPanel;
    PanelV3: TPanel;
    PanelV30: TPanel;
    PanelV4: TPanel;
    PanelV5: TPanel;
    PanelV6: TPanel;
    PanelV7: TPanel;
    PanelV8: TPanel;
    PanelV9: TPanel;
    PanelVideoCrossHairXSmall: TPanel;
    PanelVideoCrossHairYSmall: TPanel;
    procedure FormShow(Sender: TObject);
    procedure ImageMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonOkClick(Sender: TObject);
  private
    { Private declarations }
    SpecialMode, SystemMode, ActionResult: boolean;
    SpecialFilename: string;
    ImageSnap: PBitmap32;
    CentreX, CentreY, Width, Height: Integer;
    WindowTop, WindowBottom, WindowLeft, WindowRight: Integer;
    procedure UpdateVideoGridRulers;
  public
    { Public declarations }
    FileName: String;
    function CreateProjectSnap(const ImageIn: PBitmap32): boolean;
    function CreateSystemSnap(const ImageIn: PBitmap32): boolean;
    function CreateSpecialSnap(const ImageIn: PBitmap32; SnapName: string): boolean;
  end;

var
  FormCreateSnap: TFormCreateSnap;

implementation

{$R *.dfm}

uses
  Main, Settings, Math;

function TFormCreateSnap.CreateProjectSnap(const ImageIn: PBitmap32): boolean;
begin
  SpecialMode := false; // normal mode
  SystemMode := false; // not system path

  ImageSnap := CreateImageFromImage(ImageIn); // create image to manipulate

  ShowImage(ImageSnap, ImageMain); // show the image
  ShowModal;
  Result := ActionResult; // return status

  FreeImage(ImageSnap); // dispose of image
end;

function TFormCreateSnap.CreateSystemSnap(const ImageIn: PBitmap32): boolean;
begin
  SpecialMode := false; // normal mode
  SystemMode := true; // system path

  ImageSnap := CreateImageFromImage(ImageIn); // create image to manipulate

  ShowImage(ImageSnap, ImageMain); // show the image
  ShowModal;
  Result := ActionResult; // return status

  FreeImage(ImageSnap); // dispose of image
end;

function TFormCreateSnap.CreateSpecialSnap(const ImageIn: PBitmap32; SnapName: string): boolean;
begin
  SpecialMode := true; // system mode
  SystemMode := false; // not system path

  SpecialFilename := SnapName; // use special filename
  ImageSnap := CreateImageFromImage(ImageIn); // create image to manipulate

  ShowImage(ImageSnap, ImageMain); // show the image
  ShowModal;
  Result := ActionResult; // return status

  FreeImage(ImageSnap); // dispose of image
end;

procedure TFormCreateSnap.ButtonOkClick(Sender: TObject);
var
  ImageSnapOut: PBitmap32;
  FilterWindow1: TFilterWindow;
  Desired_Path: String;
begin
  if SpecialMode then
  begin
    ImageSnapOut := CreateImageFromImage(ImageSnap); // create image to window

    // copy windowed region
    FilterWindow1 := TFilterWindow.Create;
    FilterWindow1.SetParameterImage('INIMAGE', ImageSnap);
    FilterWindow1.SetParameterImage('OUTIMAGE', ImageSnapOut);
    FilterWindow1.SetParameterInteger('TOP', WindowBottom);
    FilterWindow1.SetParameterInteger('BOTTOM', WindowTop);
    FilterWindow1.SetParameterInteger('LEFT', WindowLeft);
    FilterWindow1.SetParameterInteger('RIGHT', WindowRight);
    FilterWindow1.Run;
    FilterWindow1.Free;

    // save the file
    ShowImage(ImageSnapOut, ImageMain); // show the image
    ImageMain.Picture.Bitmap.SaveToFile(SpecialFilename);
    FreeImage(ImageSnapOut); // dispose of image

    // set result and close
    ActionResult := true;
    Close;
  end
  else
  begin
    if SystemMode then
      Desired_Path := Settings_Directory
    else
      Desired_Path := ProjectPath;
    FileSaveDialog1.InitialDir := Desired_Path;

    FileSaveDialog1.FileName := '';

    if FileSaveDialog1.Execute then
    begin
      ImageSnapOut := CreateImageFromImage(ImageSnap); // create image to window

      // copy windowed region
      FilterWindow1 := TFilterWindow.Create;
      FilterWindow1.SetParameterImage('INIMAGE', ImageSnap);
      FilterWindow1.SetParameterImage('OUTIMAGE', ImageSnapOut);
      FilterWindow1.SetParameterInteger('TOP', WindowBottom);
      FilterWindow1.SetParameterInteger('BOTTOM', WindowTop);
      FilterWindow1.SetParameterInteger('LEFT', WindowLeft);
      FilterWindow1.SetParameterInteger('RIGHT', WindowRight);
      FilterWindow1.Run;
      FilterWindow1.Free;

      // save the file
      ShowImage(ImageSnapOut, ImageMain); // show the image
      FileName := ChangeFileExt(ExtractFileName(FileSaveDialog1.FileName), '');
      ImageMain.Picture.Bitmap.SaveToFile(Desired_Path + FileName + '.Bmp');
      FreeImage(ImageSnapOut); // dispose of image
      // set result and close
      ActionResult := true;
      Close;
    end
    else
    begin
      // set result and close
      ActionResult := false;
      Close;
    end;
  end;
end;

procedure TFormCreateSnap.FormShow(Sender: TObject);
begin
  // show crosshairs centred on reference image
  PanelReferenceCrosshairX.Left := ImageMain.Left;
  PanelReferenceCrosshairX.Top := ImageMain.Top + (ImageMain.Height div 2);
  PanelReferenceCrosshairX.Width := ImageMain.Width;
  PanelReferenceCrosshairX.Height := 1;

  PanelReferenceCrosshairY.Top := ImageMain.Top;
  PanelReferenceCrosshairY.Left := ImageMain.Left + (ImageMain.Width div 2);
  PanelReferenceCrosshairY.Height := ImageMain.Height;
  PanelReferenceCrosshairY.Width := 1;

  PanelReferenceBoxLeft.Visible := false;
  PanelReferenceBoxRight.Visible := false;
  PanelReferenceBoxTop.Visible := false;
  PanelReferenceBoxBottom.Visible := false;

  // ******************************************************************************

  UpdateVideoGridRulers;
  ButtonOk.Enabled := false;
  ActionResult := false; // assume failure
end;

procedure TFormCreateSnap.ImageMainMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Top, Bottom, Left, Right: Integer;
  ScaleX, ScaleY: double;
begin
  ScaleX := 800 / ImageMain.Width; // scale as 800 x 600 image
  ScaleY := 600 / ImageMain.Height;

  // show box centred on reference image
  CentreX := ImageMain.Width div 2;
  CentreY := ImageMain.Height div 2;

  Width := Abs((X - CentreX) * 2);
  Height := Abs((Y - CentreY) * 2);

  if Height > ImageMain.Height then
    Height := ImageMain.Height;
  if Height > Round(ImageMain.Height * 0.90) then
    Height := Round(ImageMain.Height * 0.90);
  if Height < Round(ImageMain.Height * 0.05) then
    Height := Round(ImageMain.Height * 0.05);

  if Width > ImageMain.Width then
    Width := ImageMain.Width;
  if Width > Round(ImageMain.Width * 0.90) then
    Width := Round(ImageMain.Width * 0.90);
  if Width < Round(ImageMain.Width * 0.05) then
    Width := Round(ImageMain.Width * 0.05);

  if Width > Round(ImageMain.Height * 0.90) then
    // keep width within hirizontal maximum
    Width := Round(ImageMain.Height * 0.90);

  Top := Trunc(CentreY - (Height / 2));
  Bottom := Succ(Trunc(CentreY + (Height / 2)));
  Left := Trunc(CentreX - (Width / 2));
  Right := Succ(Trunc(CentreX + (Width / 2)));

  PanelReferenceBoxLeft.Left := Pred(Left);
  PanelReferenceBoxLeft.Width := 2;
  PanelReferenceBoxLeft.Top := Pred(Top);
  PanelReferenceBoxLeft.Height := Succ(Succ(Bottom) - Top);

  PanelReferenceBoxRight.Left := Succ(Right);
  PanelReferenceBoxRight.Width := 2;
  PanelReferenceBoxRight.Top := Top;
  PanelReferenceBoxRight.Height := Succ(Succ(Bottom) - Top);

  PanelReferenceBoxTop.Left := Pred(Left);
  PanelReferenceBoxTop.Width := Succ(Succ(Right) - Left);
  PanelReferenceBoxTop.Top := Pred(Top);
  PanelReferenceBoxTop.Height := 2;

  PanelReferenceBoxBottom.Left := Pred(Left);
  PanelReferenceBoxBottom.Width := Succ(Succ(Right) - Left);
  PanelReferenceBoxBottom.Top := Succ(Bottom);
  PanelReferenceBoxBottom.Height := 2;

  PanelReferenceBoxLeft.Visible := true;
  PanelReferenceBoxRight.Visible := true;
  PanelReferenceBoxTop.Visible := true;
  PanelReferenceBoxBottom.Visible := true;

  // set region for windowing

  WindowTop := Pred(Round(Top * ScaleY)); // scale as 800 x 600 image
  WindowBottom := Pred(Round(Bottom * ScaleY));
  WindowLeft := Pred(Round(Left * ScaleX));
  WindowRight := Pred(Round(Right * ScaleX));

  ButtonOk.Enabled := true;
end;

procedure TFormCreateSnap.UpdateVideoGridRulers;
const
  GridSpacing = 1;
  GridLineLength = 3;
  MajorGridLineLength = 5;
var
  PixelSize: double;
  GridSize, MajorGridSize: Integer;
begin
  // show crosshairs centred on reference image
  PanelReferenceCrosshairX.Left := ImageMain.Left;
  PanelReferenceCrosshairX.Top := ImageMain.Top + (ImageMain.Height div 2);
  PanelReferenceCrosshairX.Width := ImageMain.Width;
  PanelReferenceCrosshairX.Height := 1;

  PanelReferenceCrosshairY.Top := ImageMain.Top;
  PanelReferenceCrosshairY.Left := ImageMain.Left + (ImageMain.Width div 2);
  PanelReferenceCrosshairY.Height := ImageMain.Height;
  PanelReferenceCrosshairY.Width := 1;

  PanelReferenceBoxLeft.Visible := false;
  PanelReferenceBoxRight.Visible := false;
  PanelReferenceBoxTop.Visible := false;
  PanelReferenceBoxBottom.Visible := false;

  // ******************************************************************************

  try // set pixel size in mm
    if ViewSelection = 0 then
      PixelSize := DownlookingViewWidthInMM / ImageMain.Width
    else
      PixelSize := UplookingViewWidthInMM / ImageMain.Width
  except
    PixelSize := 0.0625; // default
  end;

  GridSize := Round(GridLineLength / PixelSize);
  MajorGridSize := Round(MajorGridLineLength / PixelSize);

  // ******************************************************************************
  PanelVideoCrossHairXSmall.Top := PanelReferenceCrosshairX.Top - (GridSize div 5);
  PanelVideoCrossHairXSmall.Height := 2 * (GridSize div 5);
  PanelVideoCrossHairXSmall.Left := PanelReferenceCrosshairY.Left - 2;
  PanelVideoCrossHairXSmall.Width := 5;

  PanelV1.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV1.Height := 2 * GridSize;
  PanelV1.Left := PanelReferenceCrosshairY.Left - Round(GridSpacing / PixelSize);
  PanelV1.Width := 1;

  PanelV2.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV2.Height := 2 * GridSize;
  PanelV2.Left := PanelReferenceCrosshairY.Left - Round(2 * GridSpacing / PixelSize);
  PanelV2.Width := 1;

  PanelV3.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV3.Height := 2 * GridSize;
  PanelV3.Left := PanelReferenceCrosshairY.Left - Round(3 * GridSpacing / PixelSize);
  PanelV3.Width := 1;

  PanelV4.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV4.Height := 2 * GridSize;
  PanelV4.Left := PanelReferenceCrosshairY.Left - Round(4 * GridSpacing / PixelSize);
  PanelV4.Width := 1;

  PanelV5.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV5.Height := 2 * MajorGridSize;
  PanelV5.Left := PanelReferenceCrosshairY.Left - Round(5 * GridSpacing / PixelSize);
  PanelV5.Width := 1;

  PanelV6.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV6.Height := 2 * GridSize;
  PanelV6.Left := PanelReferenceCrosshairY.Left - Round(6 * GridSpacing / PixelSize);
  PanelV6.Width := 1;

  PanelV7.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV7.Height := 2 * GridSize;
  PanelV7.Left := PanelReferenceCrosshairY.Left - Round(7 * GridSpacing / PixelSize);
  PanelV7.Width := 1;

  PanelV8.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV8.Height := 2 * GridSize;
  PanelV8.Left := PanelReferenceCrosshairY.Left - Round(8 * GridSpacing / PixelSize);
  PanelV8.Width := 1;

  PanelV9.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV9.Height := 2 * GridSize;
  PanelV9.Left := PanelReferenceCrosshairY.Left - Round(9 * GridSpacing / PixelSize);
  PanelV9.Width := 1;

  PanelV10.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV10.Height := 2 * MajorGridSize;
  PanelV10.Left := PanelReferenceCrosshairY.Left - Round(10 * GridSpacing / PixelSize);
  PanelV10.Width := 1;

  PanelV11.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV11.Height := 2 * GridSize;
  PanelV11.Left := PanelReferenceCrosshairY.Left - Round(11 * GridSpacing / PixelSize);
  PanelV11.Width := 1;

  PanelV12.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV12.Height := 2 * GridSize;
  PanelV12.Left := PanelReferenceCrosshairY.Left - Round(12 * GridSpacing / PixelSize);
  PanelV12.Width := 1;

  PanelV13.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV13.Height := 2 * GridSize;
  PanelV13.Left := PanelReferenceCrosshairY.Left - Round(13 * GridSpacing / PixelSize);
  PanelV13.Width := 1;

  PanelV14.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV14.Height := 2 * GridSize;
  PanelV14.Left := PanelReferenceCrosshairY.Left - Round(14 * GridSpacing / PixelSize);
  PanelV14.Width := 1;

  PanelV15.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV15.Height := 2 * MajorGridSize;
  PanelV15.Left := PanelReferenceCrosshairY.Left - Round(15 * GridSpacing / PixelSize);
  PanelV15.Width := 1;

  // ******************************************************************************

  PanelV16.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV16.Height := 2 * GridSize;
  PanelV16.Left := PanelReferenceCrosshairY.Left + Round(GridSpacing / PixelSize);
  PanelV16.Width := 1;

  PanelV17.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV17.Height := 2 * GridSize;
  PanelV17.Left := PanelReferenceCrosshairY.Left + Round(2 * GridSpacing / PixelSize);
  PanelV17.Width := 1;

  PanelV18.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV18.Height := 2 * GridSize;
  PanelV18.Left := PanelReferenceCrosshairY.Left + Round(3 * GridSpacing / PixelSize);
  PanelV18.Width := 1;

  PanelV19.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV19.Height := 2 * GridSize;
  PanelV19.Left := PanelReferenceCrosshairY.Left + Round(4 * GridSpacing / PixelSize);
  PanelV19.Width := 1;

  PanelV20.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV20.Height := 2 * MajorGridSize;
  PanelV20.Left := PanelReferenceCrosshairY.Left + Round(5 * GridSpacing / PixelSize);
  PanelV20.Width := 1;

  PanelV21.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV21.Height := 2 * GridSize;
  PanelV21.Left := PanelReferenceCrosshairY.Left + Round(6 * GridSpacing / PixelSize);
  PanelV21.Width := 1;

  PanelV22.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV22.Height := 2 * GridSize;
  PanelV22.Left := PanelReferenceCrosshairY.Left + Round(7 * GridSpacing / PixelSize);
  PanelV22.Width := 1;

  PanelV23.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV23.Height := 2 * GridSize;
  PanelV23.Left := PanelReferenceCrosshairY.Left + Round(8 * GridSpacing / PixelSize);
  PanelV23.Width := 1;

  PanelV24.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV24.Height := 2 * GridSize;
  PanelV24.Left := PanelReferenceCrosshairY.Left + Round(9 * GridSpacing / PixelSize);
  PanelV24.Width := 1;

  PanelV25.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV25.Height := 2 * MajorGridSize;
  PanelV25.Left := PanelReferenceCrosshairY.Left + Round(10 * GridSpacing / PixelSize);
  PanelV25.Width := 1;

  PanelV26.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV26.Height := 2 * GridSize;
  PanelV26.Left := PanelReferenceCrosshairY.Left + Round(11 * GridSpacing / PixelSize);
  PanelV26.Width := 1;

  PanelV27.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV27.Height := 2 * GridSize;
  PanelV27.Left := PanelReferenceCrosshairY.Left + Round(12 * GridSpacing / PixelSize);
  PanelV27.Width := 1;

  PanelV28.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV28.Height := 2 * GridSize;
  PanelV28.Left := PanelReferenceCrosshairY.Left + Round(13 * GridSpacing / PixelSize);
  PanelV28.Width := 1;

  PanelV29.Top := PanelReferenceCrosshairX.Top - GridSize;
  PanelV29.Height := 2 * GridSize;
  PanelV29.Left := PanelReferenceCrosshairY.Left + Round(14 * GridSpacing / PixelSize);
  PanelV29.Width := 1;

  PanelV30.Top := PanelReferenceCrosshairX.Top - MajorGridSize;
  PanelV30.Height := 2 * MajorGridSize;
  PanelV30.Left := PanelReferenceCrosshairY.Left + Round(15 * GridSpacing / PixelSize);
  PanelV30.Width := 1;

  // ******************************************************************************
  PanelVideoCrossHairYSmall.Top := PanelReferenceCrosshairX.Top - 2;
  PanelVideoCrossHairYSmall.Height := 5;
  PanelVideoCrossHairYSmall.Left := PanelReferenceCrosshairY.Left - (GridSize div 5);
  PanelVideoCrossHairYSmall.Width := 2 * (GridSize Div 5);

  PanelH1.Top := PanelReferenceCrosshairX.Top - Round(GridSpacing / PixelSize);
  PanelH1.Height := 1;
  PanelH1.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH1.Width := 2 * GridSize;

  PanelH2.Top := PanelReferenceCrosshairX.Top - Round(2 * GridSpacing / PixelSize);
  PanelH2.Height := 1;
  PanelH2.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH2.Width := 2 * GridSize;

  PanelH3.Top := PanelReferenceCrosshairX.Top - Round(3 * GridSpacing / PixelSize);
  PanelH3.Height := 1;
  PanelH3.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH3.Width := 2 * GridSize;

  PanelH4.Top := PanelReferenceCrosshairX.Top - Round(4 * GridSpacing / PixelSize);
  PanelH4.Height := 1;
  PanelH4.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH4.Width := 2 * GridSize;

  PanelH5.Top := PanelReferenceCrosshairX.Top - Round(5 * GridSpacing / PixelSize);
  PanelH5.Height := 1;
  PanelH5.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH5.Width := 2 * MajorGridSize;

  PanelH6.Top := PanelReferenceCrosshairX.Top - Round(6 * GridSpacing / PixelSize);
  PanelH6.Height := 1;
  PanelH6.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH6.Width := 2 * GridSize;

  PanelH7.Top := PanelReferenceCrosshairX.Top - Round(7 * GridSpacing / PixelSize);
  PanelH7.Height := 1;
  PanelH7.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH7.Width := 2 * GridSize;

  PanelH8.Top := PanelReferenceCrosshairX.Top - Round(8 * GridSpacing / PixelSize);
  PanelH8.Height := 1;
  PanelH8.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH8.Width := 2 * GridSize;

  PanelH9.Top := PanelReferenceCrosshairX.Top - Round(9 * GridSpacing / PixelSize);
  PanelH9.Height := 1;
  PanelH9.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH9.Width := 2 * GridSize;

  PanelH10.Top := PanelReferenceCrosshairX.Top - Round(10 * GridSpacing / PixelSize);
  PanelH10.Height := 1;
  PanelH10.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH10.Width := 2 * MajorGridSize;

  PanelH11.Top := PanelReferenceCrosshairX.Top - Round(11 * GridSpacing / PixelSize);
  PanelH11.Height := 1;
  PanelH11.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH11.Width := 2 * GridSize;

  PanelH12.Top := PanelReferenceCrosshairX.Top - Round(12 * GridSpacing / PixelSize);
  PanelH12.Height := 1;
  PanelH12.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH12.Width := 2 * GridSize;

  PanelH13.Top := PanelReferenceCrosshairX.Top - Round(13 * GridSpacing / PixelSize);
  PanelH13.Height := 1;
  PanelH13.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH13.Width := 2 * GridSize;

  PanelH14.Top := PanelReferenceCrosshairX.Top - Round(14 * GridSpacing / PixelSize);
  PanelH14.Height := 1;
  PanelH14.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH14.Width := 2 * GridSize;

  PanelH15.Top := PanelReferenceCrosshairX.Top - Round(15 * GridSpacing / PixelSize);
  PanelH15.Height := 1;
  PanelH15.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH15.Width := 2 * MajorGridSize;

  // ******************************************************************************

  PanelH16.Top := PanelReferenceCrosshairX.Top + Round(GridSpacing / PixelSize);
  PanelH16.Height := 1;
  PanelH16.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH16.Width := 2 * GridSize;

  PanelH17.Top := PanelReferenceCrosshairX.Top + Round(2 * GridSpacing / PixelSize);
  PanelH17.Height := 1;
  PanelH17.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH17.Width := 2 * GridSize;

  PanelH18.Top := PanelReferenceCrosshairX.Top + Round(3 * GridSpacing / PixelSize);
  PanelH18.Height := 1;
  PanelH18.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH18.Width := 2 * GridSize;

  PanelH19.Top := PanelReferenceCrosshairX.Top + Round(4 * GridSpacing / PixelSize);
  PanelH19.Height := 1;
  PanelH19.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH19.Width := 2 * GridSize;

  PanelH20.Top := PanelReferenceCrosshairX.Top + Round(5 * GridSpacing / PixelSize);
  PanelH20.Height := 1;
  PanelH20.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH20.Width := 2 * MajorGridSize;

  PanelH21.Top := PanelReferenceCrosshairX.Top + Round(6 * GridSpacing / PixelSize);
  PanelH21.Height := 1;
  PanelH21.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH21.Width := 2 * GridSize;

  PanelH22.Top := PanelReferenceCrosshairX.Top + Round(7 * GridSpacing / PixelSize);
  PanelH22.Height := 1;
  PanelH22.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH22.Width := 2 * GridSize;

  PanelH23.Top := PanelReferenceCrosshairX.Top + Round(8 * GridSpacing / PixelSize);
  PanelH23.Height := 1;
  PanelH23.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH23.Width := 2 * GridSize;

  PanelH24.Top := PanelReferenceCrosshairX.Top + Round(9 * GridSpacing / PixelSize);
  PanelH24.Height := 1;
  PanelH24.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH24.Width := 2 * GridSize;

  PanelH25.Top := PanelReferenceCrosshairX.Top + Round(10 * GridSpacing / PixelSize);
  PanelH25.Height := 1;
  PanelH25.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH25.Width := 2 * MajorGridSize;

  PanelH26.Top := PanelReferenceCrosshairX.Top + Round(11 * GridSpacing / PixelSize);
  PanelH26.Height := 1;
  PanelH26.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH26.Width := 2 * GridSize;

  PanelH27.Top := PanelReferenceCrosshairX.Top + Round(12 * GridSpacing / PixelSize);
  PanelH27.Height := 1;
  PanelH27.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH27.Width := 2 * GridSize;

  PanelH28.Top := PanelReferenceCrosshairX.Top + Round(13 * GridSpacing / PixelSize);
  PanelH28.Height := 1;
  PanelH28.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH28.Width := 2 * GridSize;

  PanelH29.Top := PanelReferenceCrosshairX.Top + Round(14 * GridSpacing / PixelSize);
  PanelH29.Height := 1;
  PanelH29.Left := PanelReferenceCrosshairY.Left - GridSize;
  PanelH29.Width := 2 * GridSize;

  PanelH30.Top := PanelReferenceCrosshairX.Top + Round(15 * GridSpacing / PixelSize);
  PanelH30.Height := 1;
  PanelH30.Left := PanelReferenceCrosshairY.Left - MajorGridSize;
  PanelH30.Width := 2 * MajorGridSize;
end;

end.
