unit Feeders;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ExtDlgs, UiTypes, Vcl.Mask;

type
  TFormFeeders = class(TForm)
    ButtonClose: TBitBtn;
    ListBoxFeederList: TListBox;
    GroupBoxFeederDetails: TGroupBox;
    ImagePartSnap: TImage;
    EditFeederPositionX: TLabeledEdit;
    EditFeederPositionY: TLabeledEdit;
    EditFeederPositionZ: TLabeledEdit;
    EditFeederDescription: TLabeledEdit;
    EditFeederSnapName: TLabeledEdit;
    EditPartHeight: TLabeledEdit;
    ButtonDeleteFeeder: TButton;
    ButtonAddFeeder: TButton;
    ButtonGotoFeeder: TButton;
    ButtonSetFeederPosition: TButton;
    EditTraySpacingX: TLabeledEdit;
    EditTraySpacingY: TLabeledEdit;
    EditTrayCountX: TLabeledEdit;
    EditTrayCountY: TLabeledEdit;
    ButtonTrayReset: TButton;
    EditTrayPickCount: TLabeledEdit;
    GroupBoxType: TGroupBox;
    RadioButtonKindVibration: TRadioButton;
    RadioButtonKindTray: TRadioButton;
    RadioButtonKindReel: TRadioButton;
    OpenPictureDialog1: TOpenDialog;
    ButtonGotoFeederNozzle: TButton;
    ImageNoSnap: TImage;
    ButtonSetNozzleHeight: TButton;
    ButtonTakeSnap: TButton;
    ButtonTrayAdvance: TButton;
    GroupBoxPlaceSpeedType: TGroupBox;
    RadioButtonMedium: TRadioButton;
    RadioButtonFast: TRadioButton;
    RadioButtonSlow: TRadioButton;
    ComboBoxNozzle: TComboBox;
    Label1: TLabel;
    ComboBoxRejectTray: TComboBox;
    Label2: TLabel;
    ButtonLoadFeeder: TButton;
    ButtonSaveFeeder: TButton;
    FileOpenDialogFeeder: TOpenDialog;
    FileSaveDialogFeeder: TSaveDialog;
    ButtonGotoNextFeeder: TButton;
    ButtonDiscard: TButton;
    ButtonTestPick: TButton;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    CheckBoxUseVision: TCheckBox;
    ButtonAMinus10: TButton;
    ButtonAMinus1: TButton;
    ButtonJogAMinus: TButton;
    ButtonJogAPlus: TButton;
    ButtonAPlus1: TButton;
    ButtonAPlus10: TButton;
    ButtonTestVision: TButton;
    ButtonResetAllTrays: TButton;
    ButtonPark: TButton;
    procedure ButtonAddFeederClick(Sender: TObject);
    procedure ButtonDeleteFeederClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonGotoFeederClick(Sender: TObject);
    procedure ListBoxFeederListClick(Sender: TObject);
    procedure EditFeederSnapNameClick(Sender: TObject);
    procedure ButtonGotoFeederNozzleClick(Sender: TObject);
    procedure ButtonTrayResetClick(Sender: TObject);
    procedure EditTrayPickCountKeyPress(Sender: TObject; var Key: Char);
    procedure EditFeederPositionXChange(Sender: TObject);
    procedure EditFeederPositionYChange(Sender: TObject);
    procedure EditFeederPositionZChange(Sender: TObject);
    procedure EditPartHeightChange(Sender: TObject);
    procedure EditTraySpacingXChange(Sender: TObject);
    procedure EditTraySpacingYChange(Sender: TObject);
    procedure EditTrayCountXChange(Sender: TObject);
    procedure EditTrayCountYChange(Sender: TObject);
    procedure ButtonSetFeederPositionClick(Sender: TObject);
    procedure RadioButtonKindReelClick(Sender: TObject);
    procedure RadioButtonKindTrayClick(Sender: TObject);
    procedure RadioButtonKindVibrationClick(Sender: TObject);
    procedure EditFeederDescriptionChange(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonSetNozzleHeightClick(Sender: TObject);
    procedure ButtonTestPickClick(Sender: TObject);
    procedure ButtonDiscardClick(Sender: TObject);
    procedure ButtonTakeSnapClick(Sender: TObject);
    procedure ButtonTrayAdvanceClick(Sender: TObject);
    procedure RadioButtonFastClick(Sender: TObject);
    procedure RadioButtonMediumClick(Sender: TObject);
    procedure RadioButtonSlowClick(Sender: TObject);
    procedure ComboBoxNozzleChange(Sender: TObject);
    procedure ComboBoxRejectTrayChange(Sender: TObject);
    procedure ComboBoxNozzleKeyPress(Sender: TObject; var Key: Char);
    procedure ComboBoxRejectTrayKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonLoadFeederClick(Sender: TObject);
    procedure ButtonSaveFeederClick(Sender: TObject);
    procedure ButtonGotoNextFeederClick(Sender: TObject);
    procedure CheckBoxUseVisionClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonAMinus10Click(Sender: TObject);
    procedure ButtonAMinus1Click(Sender: TObject);
    procedure ButtonJogAMinusClick(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure ButtonAPlus1Click(Sender: TObject);
    procedure ButtonAPlus10Click(Sender: TObject);
    procedure ButtonTestVisionClick(Sender: TObject);
    procedure ButtonResetAllTraysClick(Sender: TObject);
    procedure ButtonParkClick(Sender: TObject);
  private
    { Private declarations }
    function FeederIsUsed(F: integer): boolean; // test if feeder in use
    procedure UpdateFeederList;
    procedure UpdateButtons;
  public
    { Public declarations }
  end;

var
  FormFeeders: TFormFeeders;

implementation

{$R *.dfm}

uses
  Main, Settings, DeskWinCNC, CreateSnap, NozzleChanger, FmxUtils;

procedure TFormFeeders.UpdateButtons;
begin
  ButtonPark.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonTestPick.Enabled := (not PartPicked) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonTestVision.Enabled := (FeederCount > 0) and FeederList[Pred(CurrentFeeder)].Use_Vision and (not PartPicked) and CNCControllerFound and
    CNCInitialised and not CNCEmergencyStop;
  ButtonDiscard.Enabled := PartPicked and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoFeeder.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoNextFeeder.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoFeederNozzle.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonResetAllTrays.Visible := (FeederCount > 0);
  ButtonTrayReset.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  ButtonTrayAdvance.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  EditTraySpacingX.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  EditTraySpacingY.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  EditTrayCountX.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  EditTrayCountY.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);
  EditTrayPickCount.Visible := (FeederCount > 0) and (FeederList[Pred(CurrentFeeder)].Kind = 1);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

function TFormFeeders.FeederIsUsed(F: integer): boolean;
// test if feeder in use
var
  X: integer;
  Used: boolean;
begin
  Used := false;
  if (FeederCount > 0) and (PartCount > 0) then
    for X := 0 to PartCount - 1 do
      if Partlist[X].Feeder = F then
        Used := true;

  Result := Used;
end;

procedure TFormFeeders.UpdateFeederList;
var
  X: integer;
begin
  Enabled := false;

  ListBoxFeederList.Clear;
  if (FeederCount > 0) then
  begin
    if CurrentFeeder = 0 then
      CurrentFeeder := 1; // ensure current feeder is valid

    GroupBoxFeederDetails.Caption := 'Feeder Details - ' + IntToStr(CurrentFeeder) + ' of ' + IntToStr(FeederCount);
    for X := 0 to FeederCount - 1 do
    begin
      if FeederIsUsed(Succ(X)) then // if feeder is not used then indicate this

        ListBoxFeederList.Items.Add('Feeder ' + IntToStr(Succ(X)) + ' - ' + FeederList[X].Description)
      else
        ListBoxFeederList.Items.Add('Feeder ' + IntToStr(Succ(X)) + ' - ' + FeederList[X].Description + ' - * NOT USED *');
    end;

    with FeederList[Pred(CurrentFeeder)] do
    begin
      EditFeederDescription.Text := Description;
      EditFeederSnapName.Text := SnapName;

      EditFeederPositionX.Text := FloatToStrF(X, ffFixed, 10, 3);
      EditFeederPositionY.Text := FloatToStrF(Y, ffFixed, 10, 3);
      EditFeederPositionZ.Text := FloatToStrF(Z, ffFixed, 10, 3);
      EditPartHeight.Text := FloatToStrF(PartHeight, ffFixed, 10, 3);
      EditTraySpacingX.Text := FloatToStrF(TraySpacingX, ffFixed, 10, 3);
      EditTraySpacingY.Text := FloatToStrF(TraySpacingY, ffFixed, 10, 3);

      ComboBoxNozzle.ItemIndex := Pred(Nozzle);
      ComboBoxRejectTray.ItemIndex := Pred(RejectTray);

      if TrayCountX <= 0 then
        TrayCountX := 1; // range check
      EditTrayCountX.Text := IntToStr(TrayCountX);

      if TrayCountY <= 0 then
        TrayCountY := 1; // range check
      EditTrayCountY.Text := IntToStr(TrayCountY);

      if TrayPickCount <= 0 then
        TrayPickCount := 1; // range check

      EditTrayPickCount.Text := IntToStr(TrayPickCount) + ' of ' + IntToStr(TrayCountX * TrayCountY);

      case Kind of // handle feeder kind  0 = reel, 1 = tray, 2 = vibration
        0:
          begin
            RadioButtonKindReel.Checked := true;
          end;

        1:
          begin
            RadioButtonKindTray.Checked := true;
          end;

        2:
          begin
            RadioButtonKindVibration.Checked := true;
          end;
      end;

      if Kind = 0 then // if reel feeder then automatically select front or rear from position on machine
      begin
        if Y + CNCActualHomeY > (CNCMinY + (CNCMaxY - CNCMinY) / 2) then
          Location := 2 // rear
        else
          Location := 1; // front
      end
      else if Kind = 1 then // tray
      begin
        Location := 1; // front
      end
      else if Kind = 2 then // vibration
      begin
        Location := 0; // right
      end;

      case PlaceSpeedType of // 0 = fast, 1 = medium, 2 = slow
        0:
          begin
            RadioButtonFast.Checked := true;
          end;

        1:
          begin
            RadioButtonMedium.Checked := true;
          end;

        2:
          begin
            RadioButtonSlow.Checked := true;
          end;
      end;

      CheckBoxUseVision.Checked := Use_Vision;

      try
        ImagePartSnap.Picture.Bitmap.LoadFromFile(Settings_Directory + SnapName + '.bmp');
        ImageNoSnap.Visible := false;
        ImagePartSnap.Visible := true;
      except
        ImagePartSnap.Visible := false;
        ImageNoSnap.Visible := true;
      end;
    end;
    ListBoxFeederList.ItemIndex := Pred(CurrentFeeder); // show selection
  end
  else
  begin
    CurrentFeeder := 0;
    GroupBoxFeederDetails.Caption := 'Feeder Details - No Feeders';

    EditFeederDescription.Text := '';
    EditFeederSnapName.Text := '';

    EditFeederPositionX.Text := FloatToStrF(0, ffFixed, 10, 3);
    EditFeederPositionY.Text := FloatToStrF(0, ffFixed, 10, 3);
    EditFeederPositionZ.Text := FloatToStrF(0, ffFixed, 10, 3);
    EditPartHeight.Text := FloatToStrF(0, ffFixed, 10, 3);
    ComboBoxNozzle.ItemIndex := 0;
    ComboBoxRejectTray.ItemIndex := 0;
    EditTraySpacingX.Text := FloatToStrF(0, ffFixed, 10, 3);
    EditTraySpacingY.Text := FloatToStrF(0, ffFixed, 10, 3);
    EditTrayCountX.Text := IntToStr(1);
    EditTrayCountY.Text := IntToStr(1);
    EditTrayPickCount.Text := IntToStr(1);

    ImagePartSnap.Picture.Bitmap.FreeImage;
  end;

  Enabled := true;
end;

procedure TFormFeeders.ButtonSetNozzleHeightClick(Sender: TObject);
begin
  if (MessageDlg('ARE YOU SURE YOU WANT TO SET THE FEEDER Z POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    FeederList[Pred(CurrentFeeder)].Z := CNCZPos - CNCHomeZ;

    ProjectEdited := true; // indicate  save required

    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ButtonGotoNextFeederClick(Sender: TObject);
begin

  inc(CurrentFeeder);
  if CurrentFeeder > FeederCount then
    CurrentFeeder := 1; // select next feeder
  UpdateFeederList;

  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(FeederList[Pred(CurrentFeeder)].X, FeederList[Pred(CurrentFeeder)].Y, 0, 0, CNCMaxStepsPerSecond);

  UpdateButtons;
end;

procedure TFormFeeders.ButtonAddFeederClick(Sender: TObject);
begin
  inc(FeederCount); // add part to list
  SetLength(FeederList, FeederCount);
  CurrentFeeder := FeederCount;

  FeederList[Pred(CurrentFeeder)].Kind := 0;
  FeederList[Pred(CurrentFeeder)].Location := 1;
  FeederList[Pred(CurrentFeeder)].Description := '';
  FeederList[Pred(CurrentFeeder)].SnapName := '';
  FeederList[Pred(CurrentFeeder)].X := 0;
  FeederList[Pred(CurrentFeeder)].Y := 0;
  FeederList[Pred(CurrentFeeder)].Z := 0;
  FeederList[Pred(CurrentFeeder)].PartHeight := 0;
  FeederList[Pred(CurrentFeeder)].Nozzle := 0;
  FeederList[Pred(CurrentFeeder)].RejectTray := 1;
  FeederList[Pred(CurrentFeeder)].TraySpacingX := 0;
  FeederList[Pred(CurrentFeeder)].TraySpacingY := 0;
  FeederList[Pred(CurrentFeeder)].TrayCountX := 1;
  FeederList[Pred(CurrentFeeder)].TrayCountY := 1;
  FeederList[Pred(CurrentFeeder)].TrayPickCount := 1;
  FeederList[Pred(CurrentFeeder)].Use_Vision := true;

  UpdateFeederList;
  MessageDlg('Please select the CORRECT FEEDER TYPE!', mtConfirmation, [mbOk], 0, mbOk);
end;

procedure TFormFeeders.ButtonAMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonAMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonAPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonAPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonDeleteFeederClick(Sender: TObject);
var
  X: integer;
begin
  if FeederIsUsed(CurrentFeeder) then
  begin // warn if cannot be deleted
    MessageDlg('YOU CANNOT DELETE A FEEDER THAT IS IN USE!', mtWarning, [mbOk], 0, mbOk);
  end
  else // else prompt for deletion
    if (MessageDlg('ARE YOU SURE YOU WANT TO DELETE THIS FEEDER?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
    begin
      if FeederCount > 0 then
      begin
        if PartCount > 0 then
          // if part feeder >= currentfeeder then decrement part feeder
          for X := 0 to PartCount - 1 do
            if Partlist[X].Feeder >= CurrentFeeder then
              Dec(Partlist[X].Feeder);

        // ******************************************************************************

        if FeederCount > CurrentFeeder then // remove feeder from list
        begin
          for X := CurrentFeeder to FeederCount - 1 do // shift records down
            FeederList[Pred(X)] := FeederList[X];
        end;

        Dec(FeederCount); // remove feeder
        if CurrentFeeder > FeederCount then
          CurrentFeeder := FeederCount;

        SetLength(FeederList, FeederCount); // resize array

        ProjectEdited := true;
      end;

      UpdateFeederList;
      FormMain.UpdatePartList; // keep parts list updated
      UpdateButtons;
    end;
end;

procedure TFormFeeders.ButtonDiscardClick(Sender: TObject);
begin
  FormMain.DiscardPart(CurrentFeeder); // discart part to tray

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormFeeders.ButtonGotoFeederClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(FeederList[Pred(CurrentFeeder)].X, FeederList[Pred(CurrentFeeder)].Y, 0, 0, CNCMaxStepsPerSecond);

  UpdateButtons;
end;

procedure TFormFeeders.ButtonGotoFeederNozzleClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(FeederList[Pred(CurrentFeeder)].X + NozzleOffsetX, FeederList[Pred(CurrentFeeder)].Y + NozzleOffsetY, 0, 0,
    CNCMaxStepsPerSecond);

  if FeederList[Pred(CurrentFeeder)].Kind = 0 then
  // if reel feeder then operate actuator
  begin
    SetOutputFeeder(true); // operate actuator

    FormMain.Delay(ActuatorOnDelay); // delay after actuator
  end;

  FormMain.MoveHomeRelative(FeederList[Pred(CurrentFeeder)].X + NozzleOffsetX, FeederList[Pred(CurrentFeeder)].Y + NozzleOffsetY,
    FeederList[Pred(CurrentFeeder)].Z, 0, CNCMaxStepsPerSecond);

  UpdateButtons;
end;

procedure TFormFeeders.ButtonLoadFeederClick(Sender: TObject);
var
  Path, Name: string;
  Feeder: FeederRec;
begin
  FileOpenDialogFeeder.InitialDir := Settings_Directory;
  FileOpenDialogFeeder.Filename := '';
  FileOpenDialogFeeder.Title := 'Load a Feeder';
  if FileOpenDialogFeeder.Execute then
  begin
    Name := ChangeFileExt(ExtractFileName(FileOpenDialogFeeder.Filename), '');
    Path := Settings_Directory;
    if Load_Feeder(Path, Name, Feeder) then // load feeder
    begin
      inc(FeederCount); // add part to list
      SetLength(FeederList, FeederCount);
      CurrentFeeder := FeederCount;

      FeederList[Pred(CurrentFeeder)] := Feeder;
      UpdateFeederList;
    end;
  end;
end;

procedure TFormFeeders.ButtonParkClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  FormMain.UpdateStatus;
  UpdateButtons;

  FormMain.MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  UpdateButtons;
end;

procedure TFormFeeders.ButtonResetAllTraysClick(Sender: TObject);
var
  X: integer;
begin
  if (MessageDlg('ARE YOU SURE YOU WANT TO RESET ALL TRAYS?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    if FeederCount > 0 then
      for X := 0 to Pred(FeederCount) do
        FeederList[X].TrayPickCount := 1;

    ProjectEdited := true; // indicate  save required

    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ButtonSaveFeederClick(Sender: TObject);
var
  Path, Name: string;
begin
  FileSaveDialogFeeder.InitialDir := Settings_Directory;
  FileSaveDialogFeeder.Filename := FeederList[Pred(CurrentFeeder)].Description;
  FileSaveDialogFeeder.Title := 'Save a Feeder';
  if FileSaveDialogFeeder.Execute then
  begin
    Name := ChangeFileExt(ExtractFileName(FileSaveDialogFeeder.Filename), '');
    Path := Settings_Directory;
    Save_Feeder(Path, Name, FeederList[Pred(CurrentFeeder)]); // Save feeder
  end;
end;

procedure TFormFeeders.ButtonSetFeederPositionClick(Sender: TObject);
begin
  if (MessageDlg('ARE YOU SURE YOU WANT TO SET THE FEEDER POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    FeederList[Pred(CurrentFeeder)].X := CNCXPos - CNCActualHomeX;
    FeederList[Pred(CurrentFeeder)].Y := CNCYPos - CNCActualHomeY;

    ProjectEdited := true; // indicate  save required

    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ButtonTakeSnapClick(Sender: TObject);
begin
  if FormMain.CaptureUpLooking and FormCreateSnap.CreateSystemSnap(FormMain.ImageUplooking) then // create snap
  begin // update feeder part image
    FeederList[Pred(CurrentFeeder)].SnapName := ChangeFileExt(ExtractFileName(FormCreateSnap.Filename), '');
    UpdateFeederList;
    ProjectEdited := true;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ButtonTestPickClick(Sender: TObject);
begin
  if FormMain.PickPartWithoutCorrelation(CurrentFeeder, 0) then // pick and go to camera at ZERO angle
    UpdateFeederList; // refresh feeder data

  UpdateButtons;
end;

procedure TFormFeeders.ButtonTestVisionClick(Sender: TObject);
begin
  if FormMain.PickPart(CurrentFeeder, 0) then // pick and go to camera at ZERO angle and do vision check
    UpdateFeederList; // refresh feeder data

  UpdateButtons;
end;

procedure TFormFeeders.ButtonTrayAdvanceClick(Sender: TObject);
begin
  inc(FeederList[Pred(CurrentFeeder)].TrayPickCount); // advance tray count
  if FeederList[Pred(CurrentFeeder)].TrayPickCount > FeederList[Pred(CurrentFeeder)].TrayCountX * FeederList[Pred(CurrentFeeder)].TrayCountY then
    FeederList[Pred(CurrentFeeder)].TrayPickCount := 1; // wrap around

  ProjectEdited := true; // indicate  save required

  UpdateFeederList; // refresh feeder data
  UpdateButtons;
end;

procedure TFormFeeders.ButtonTrayResetClick(Sender: TObject);
begin
  FeederList[Pred(CurrentFeeder)].TrayPickCount := 1;

  ProjectEdited := true; // indicate  save required

  UpdateFeederList;
  UpdateButtons;
end;

procedure TFormFeeders.EditFeederDescriptionChange(Sender: TObject);
begin
  if Enabled then
  begin
    FeederList[Pred(CurrentFeeder)].Description := EditFeederDescription.Text;
    ProjectEdited := true;
  end;
end;

procedure TFormFeeders.EditFeederPositionXChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditFeederPositionX.Text);

      if (V + CNCActualHomeX >= CNCMinX) and (V + CNCActualHomeX <= CNCMaxX) then
      begin
        EditFeederPositionX.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].X := V;
        ProjectEdited := true;
      end
      else
        EditFeederPositionX.Color := clRed;
    except
      EditFeederPositionX.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditFeederPositionYChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditFeederPositionY.Text);

      if (V + CNCActualHomeY >= CNCMinY) and (V + CNCActualHomeY <= CNCMaxY) then
      begin
        EditFeederPositionY.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].Y := V;

        // ******************************************************************************

        if FeederList[Pred(CurrentFeeder)].Kind = 0 then // if reel feeder then automatically select front or rear from position on machine
        begin
          if FeederList[Pred(CurrentFeeder)].Y + CNCActualHomeY > (CNCMinY + (CNCMaxY - CNCMinY) / 2) then
            FeederList[Pred(CurrentFeeder)].Location := 2 // rear
          else
            FeederList[Pred(CurrentFeeder)].Location := 1; // front
        end;

        ProjectEdited := true;
      end
      else
        EditFeederPositionY.Color := clRed;
    except
      EditFeederPositionY.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditFeederPositionZChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditFeederPositionZ.Text);

      if (V + CNCHomeZ >= CNCMinZ) and (V + CNCHomeZ <= CNCMaxZ) then
      begin
        EditFeederPositionZ.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].Z := V;
        ProjectEdited := true;
      end
      else
        EditFeederPositionZ.Color := clRed;
    except
      EditFeederPositionZ.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditFeederSnapNameClick(Sender: TObject);
var
  Filename, FilePath: string;
begin
  OpenPictureDialog1.InitialDir := IncludeTrailingPathDelimiter(Settings_Directory);
  OpenPictureDialog1.Filename := FeederList[Pred(CurrentFeeder)].SnapName;

  if OpenPictureDialog1.Execute then
  begin
    Filename := ChangeFileExt(ExtractFileName(OpenPictureDialog1.Filename), '');
    FilePath := IncludeTrailingPathDelimiter(ExtractFilePath(OpenPictureDialog1.Filename));

    if FilePath <> ProjectPath then
    begin // if snap from different path
      if FileExists(Settings_Directory + Filename + '.bmp') then
      begin
        if (MessageDlg('A SNAP WITH THIS NAME ALREADY EXISTS IN THE PROJECT.' + #$0d + 'DO YOU WANT TO OVERWRITE IT WITH THIS SNAP?', mtConfirmation,
          [mbYes, mbNo], 0, mbYes) = mrYes) then
        begin // if exists then prompt for overwrite

          if FileCopy(FilePath + Filename + '.bmp', ProjectPath + Filename + '.bmp') then
          begin
            FeederList[Pred(CurrentFeeder)].SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.Filename), '');
            UpdateFeederList;
          end
          else
            MessageDlg('FILE COPY ERROR!!', mtError, [mbCancel], 0, mbCancel)
        end;
      end
      else // else do blind copy
      begin
        FileCopy(FilePath + Filename + '.bmp', ProjectPath + Filename + '.bmp');
        FeederList[Pred(CurrentFeeder)].SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.Filename), '');
        UpdateFeederList;
      end;
    end
    else
    begin
      FeederList[Pred(CurrentFeeder)].SnapName := ChangeFileExt(ExtractFileName(OpenPictureDialog1.Filename), '');
      UpdateFeederList;
    end;

    ProjectEdited := true;
  end;
  UpdateButtons;
end;

procedure TFormFeeders.EditPartHeightChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPartHeight.Text);

      if (V > 0) and (V <= 25) then
      begin
        EditPartHeight.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].PartHeight := V;
        ProjectEdited := true;
      end
      else
        EditPartHeight.Color := clRed;
    except
      EditPartHeight.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditTrayCountXChange(Sender: TObject);
Var
  V: integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditTrayCountX.Text);
      if (V > 0) and (V <= 50) then
      begin
        EditTrayCountX.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].TrayCountX := V;
        ProjectEdited := true;
      end
      else
        EditTrayCountX.Color := clRed;
    except
      FeederList[Pred(CurrentFeeder)].TrayCountX := 1;
      EditTrayCountX.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditTrayCountYChange(Sender: TObject);
Var
  V: integer;
begin
  if Enabled then
  begin
    try
      V := StrToInt(EditTrayCountY.Text);
      if (V > 0) and (V <= 50) then
      begin
        EditTrayCountY.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].TrayCountY := V;
        ProjectEdited := true;
      end
      else
        EditTrayCountY.Color := clRed;
    except
      FeederList[Pred(CurrentFeeder)].TrayCountY := 1;
      EditTrayCountY.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditTrayPickCountKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormFeeders.EditTraySpacingXChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTraySpacingX.Text);

      if (V >= -50) and (V <= 50) then
      begin
        EditTraySpacingX.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].TraySpacingX := V;
        ProjectEdited := true;
      end
      else
        EditTraySpacingX.Color := clRed;
    except
      EditTraySpacingX.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.EditTraySpacingYChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditTraySpacingY.Text);

      if (V >= -50) and (V <= 50) then
      begin
        EditTraySpacingY.Color := clWindow;
        FeederList[Pred(CurrentFeeder)].TraySpacingY := V;
        ProjectEdited := true;
      end
      else
        EditTraySpacingY.Color := clRed;
    except
      EditTraySpacingY.Color := clRed;
    end;
  end;
end;

procedure TFormFeeders.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings; // ensure the settings are saved first
end;

procedure TFormFeeders.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateFeederList;
  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormFeeders.ListBoxFeederListClick(Sender: TObject);
begin
  CurrentFeeder := Succ(ListBoxFeederList.ItemIndex); // select feeder clicked
  UpdateFeederList;
  UpdateButtons;
end;

procedure TFormFeeders.RadioButtonFastClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonFast.Checked then
      FeederList[Pred(CurrentFeeder)].PlaceSpeedType := 0;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.RadioButtonKindReelClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonKindReel.Checked then
    begin
      FeederList[Pred(CurrentFeeder)].Kind := 0;

      // ******************************************************************************
      // automatically select front or rear from position on machine

      if FeederList[Pred(CurrentFeeder)].Y + CNCActualHomeY > (CNCMinY + (CNCMaxY - CNCMinY) / 2) then
        FeederList[Pred(CurrentFeeder)].Location := 2 // rear
      else
        FeederList[Pred(CurrentFeeder)].Location := 1; // front
    end;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.RadioButtonKindTrayClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonKindTray.Checked then
      FeederList[Pred(CurrentFeeder)].Kind := 1;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;

end;

procedure TFormFeeders.RadioButtonKindVibrationClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonKindVibration.Checked then
      FeederList[Pred(CurrentFeeder)].Kind := 2;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.RadioButtonMediumClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonMedium.Checked then
      FeederList[Pred(CurrentFeeder)].PlaceSpeedType := 1;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.RadioButtonSlowClick(Sender: TObject);
begin
  if Enabled then
  begin
    if RadioButtonSlow.Checked then
      FeederList[Pred(CurrentFeeder)].PlaceSpeedType := 2;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ComboBoxRejectTrayChange(Sender: TObject);
begin
  if Enabled then
  begin
    FeederList[Pred(CurrentFeeder)].RejectTray := Succ(ComboBoxRejectTray.ItemIndex);
    ProjectEdited := true;
  end;
end;

procedure TFormFeeders.ComboBoxRejectTrayKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormFeeders.CheckBoxUseVisionClick(Sender: TObject);
begin
  if Enabled then
  begin
    FeederList[Pred(CurrentFeeder)].Use_Vision := CheckBoxUseVision.Checked;
    ProjectEdited := true;
    UpdateFeederList;
    UpdateButtons;
  end;
end;

procedure TFormFeeders.ComboBoxNozzleChange(Sender: TObject);
begin
  if Enabled then
  begin
    FeederList[Pred(CurrentFeeder)].Nozzle := Succ(ComboBoxNozzle.ItemIndex);
    ProjectEdited := true;
  end;
end;

procedure TFormFeeders.ComboBoxNozzleKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormFeeders.ButtonJogAMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -0.1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 0.1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormFeeders.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
