unit HomeSettings;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, DeskWinCNC, Settings, UiTypes, Vcl.Mask;

type
  TFormHomeSettings = class(TForm)
    ButtonClose: TBitBtn;
    GroupBoxHomeSettings: TGroupBox;
    Label1: TLabel;
    EditHome1X: TLabeledEdit;
    EditHome1Y: TLabeledEdit;
    ButtonSetHome1: TBitBtn;
    ImageHome1: TImage;
    ButtonHome1Snap: TBitBtn;
    ButtonGotoHome1: TBitBtn;
    ImageNoSnap1: TImage;
    GroupBoxJogControl: TGroupBox;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    ButtonTestHome1: TBitBtn;
    GroupBoxParkPostion: TGroupBox;
    ButtonGotoPark: TBitBtn;
    ButtonSetPark: TBitBtn;
    EditParkY: TLabeledEdit;
    EditParkX: TLabeledEdit;
    GroupBoxHome2Settings: TGroupBox;
    ButtonGotoHome2: TBitBtn;
    ButtonHome2Snap: TBitBtn;
    ButtonSetHome2: TBitBtn;
    ButtonTestHome2: TBitBtn;
    EditHome2X: TLabeledEdit;
    EditHome2Y: TLabeledEdit;
    ImageHome2: TImage;
    ImageNoSnap2: TImage;
    Label2: TLabel;
    EditHome1Z: TLabeledEdit;
    EditHome2Z: TLabeledEdit;
    procedure FormShow(Sender: TObject);
    procedure EditHome1XChange(Sender: TObject);
    procedure EditHome1YChange(Sender: TObject);
    procedure EditHome2XChange(Sender: TObject);
    procedure EditHome2YChange(Sender: TObject);
    procedure ButtonSetHome1Click(Sender: TObject);
    procedure ButtonSetHome2Click(Sender: TObject);
    procedure ButtonHome1SnapClick(Sender: TObject);
    procedure ButtonHome2SnapClick(Sender: TObject);
    procedure ButtonGotoHome1Click(Sender: TObject);
    procedure ButtonGotoHome2Click(Sender: TObject);
    procedure EditHome1XKeyPress(Sender: TObject; var Key: Char);
    procedure EditHome1YKeyPress(Sender: TObject; var Key: Char);
    procedure EditHome2XKeyPress(Sender: TObject; var Key: Char);
    procedure EditHome2YKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonTestHome1Click(Sender: TObject);
    procedure ButtonTestHome2Click(Sender: TObject);
    procedure EditParkXChange(Sender: TObject);
    procedure EditParkYChange(Sender: TObject);
    procedure ButtonSetParkClick(Sender: TObject);
    procedure ButtonGotoParkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure EditHome1ZKeyPress(Sender: TObject; var Key: Char);
    procedure EditHome1ZChange(Sender: TObject);
    procedure EditHome2ZKeyPress(Sender: TObject; var Key: Char);
    procedure EditHome2ZChange(Sender: TObject);
  private
    { Private declarations }
    Enabled: boolean;
    Procedure UpdateValues;
    procedure UpdateButtons;
  public
    { Public declarations }
  end;

var
  FormHomeSettings: TFormHomeSettings;

implementation

{$R *.dfm}

uses
  Main, CreateSnap, ImageIOVideo, Image;

procedure TFormHomeSettings.UpdateButtons;
begin
  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonSetHome1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoHome1.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonHome1Snap.Enabled := CNCVisualHome and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonTestHome1.Enabled := CNCVisualHome and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  // ******************************************************************************

  ButtonSetHome2.Enabled := CNCDualYAxis and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoHome2.Enabled := CNCDualYAxis and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonHome2Snap.Enabled := CNCVisualHome and CNCDualYAxis and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonTestHome2.Enabled := CNCVisualHome and CNCDualYAxis and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  // ******************************************************************************

  ButtonGotoPark.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetPark.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  // ******************************************************************************

  GroupBoxHome2Settings.Visible := CNCDualYAxis;
end;

procedure TFormHomeSettings.UpdateValues;
begin
  Enabled := false;

  EditHome1X.Text := FloatToStrF(CNCHome1X, ffFixed, 10, 3);
  EditHome1Y.Text := FloatToStrF(CNCHome1Y, ffFixed, 10, 3);
  EditHome1Z.Text := FloatToStrF(CNCHome1Z, ffFixed, 10, 3);

  EditHome2X.Text := FloatToStrF(CNCHome2X, ffFixed, 10, 3);
  EditHome2Y.Text := FloatToStrF(CNCHome2Y, ffFixed, 10, 3);
  EditHome2Z.Text := FloatToStrF(CNCHome2Z, ffFixed, 10, 3);

  EditParkX.Text := FloatToStrF(ParkX, ffFixed, 10, 3);
  EditParkY.Text := FloatToStrF(ParkY, ffFixed, 10, 3);

  Enabled := true;

  // ******************************************************************************

  Try
    ImageHome1.Picture.Bitmap.LoadFromFile(Settings_Directory + 'Home.BMP');
    ImageNoSnap1.Visible := false;
    ImageHome1.Visible := true;
  Except
    ImageHome1.Visible := false;
    ImageNoSnap1.Visible := true;
  End;

  // ******************************************************************************

  Try
    ImageHome2.Picture.Bitmap.LoadFromFile(Settings_Directory + 'Home2.BMP');
    ImageNoSnap2.Visible := false;
    ImageHome2.Visible := true;
  Except
    ImageHome2.Visible := false;
    ImageNoSnap2.Visible := true;
  End;
end;

procedure TFormHomeSettings.ButtonGotoHome1Click(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.MoveHomeRelativeWithNozzleProtection(0, 0, CNCHome1Z, 0, CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormHomeSettings.ButtonGotoHome2Click(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.MoveHomeRelativeWithNozzleProtection(CNCHome2X, CNCHome2Y, CNCHome2Z, 0, CNCMaxStepsPerSecond);
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormHomeSettings.ButtonGotoParkClick(Sender: TObject);
begin
  FormMain.MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormHomeSettings.ButtonHome1SnapClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
  begin
    FormCreateSnap.CreateSpecialSnap(FormMain.ImageDownlooking, Settings_Directory + 'Home.BMP');
    UpdateValues;
    UpdateButtons;
  end;
end;

procedure TFormHomeSettings.ButtonHome2SnapClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
  begin
    FormCreateSnap.CreateSpecialSnap(FormMain.ImageDownlooking, Settings_Directory + 'Home2.BMP');
    UpdateValues;
    UpdateButtons;
  end;
end;

procedure TFormHomeSettings.ButtonSetHome1Click(Sender: TObject);
begin
  if (MessageDlg('"WARNING!! WARNING!! WARNING!!' + #$0d + #$0d + 'CHANGING THIS WILL IMPACT ON' + #$0d + 'A WIDE RANGE OF OTHER FIXTURE SETTINGS.' + #$0d +
    #$0d + 'ARE YOU SURE YOU WANT TO' + #$0d + 'CHANGE THE HOME POSITION?', mtWarning, [mbYes, mbNo], 0, mbYes) = mrYes) and
    (MessageDlg('LAST WARNING!!!' + #$0d + #$0d + 'DO YOU REALLY WANT TO' + #$0d + 'CHANGE THE HOME POSITION?', mtWarning, [mbYes, mbNo], 0, mbYes) = mrYes)
  then
  begin
    CNCHome1X := CNCXPos; // set position
    CNCHome1Y := CNCYPos;
    CNCHome1Z := CNCZPos - CNCHomeZ;

    EditHome1X.Text := FloatToStrF(CNCHome1X, ffFixed, 10, 3);
    EditHome1Y.Text := FloatToStrF(CNCHome1Y, ffFixed, 10, 3);
    EditHome1Z.Text := FloatToStrF(CNCHome1Z, ffFixed, 10, 3);

    UpdateValues;
    UpdateButtons;
  end;
end;

procedure TFormHomeSettings.ButtonSetHome2Click(Sender: TObject);
begin
  if (MessageDlg('THE Y AXIS MUST BE' + #$0d + 'CAREFULLY ALIGNED' + #$0d + 'BEFORE SETTING THIS VALUE.' + #$0d + 'ARE YOU SURE?', mtConfirmation,
    [mbYes, mbNo], 0, mbYes) = mrYes) and (MessageDlg('ARE YOU SURE YOU WANT TO CHANGE THE HOME 2 POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes)
  then
  begin
    CNCHome2X := CNCXPos - CNCActualHomeX; // set position
    CNCHome2Y := CNCYPos - CNCActualHomeY;
    CNCHome2Z := CNCZPos - CNCHomeZ;

    EditHome2X.Text := FloatToStrF(CNCHome2X, ffFixed, 10, 3);
    EditHome2Y.Text := FloatToStrF(CNCHome2Y, ffFixed, 10, 3);
    EditHome2Z.Text := FloatToStrF(CNCHome2Z, ffFixed, 10, 3);

    UpdateValues;
    UpdateButtons;
  end;
end;

procedure TFormHomeSettings.ButtonSetParkClick(Sender: TObject);
begin
  ParkX := CNCXPos - CNCActualHomeX;
  ParkY := CNCYPos - CNCActualHomeY;

  UpdateValues;
  UpdateButtons;
end;

procedure TFormHomeSettings.ButtonTestHome1Click(Sender: TObject);
var
  B: TBitmap;
  X, Y, Correlation, PixelSize: double;
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(Settings_Directory + 'Home.bmp');
  Except
  End;
  FormMain.ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************

  try // set pixel size in mm
    PixelSize := DownlookingViewWidthInMM / FormMain.ImageDownlooking.Width;
  except
    PixelSize := 0.05; // default
  end;

  // ******************************************************************************

  if FormMain.MoveHomeRelativeWithNozzleProtection(0, 0, CNCHome1Z, 0, CNCMaxStepsPerSecond) then
  begin
    FormMain.Delay(DownlookingCameraSettlingDelay); // small delay

    if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
    begin
      FormMain.VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
      // correlate image
      Correlation := FormMain.VisionCorrelation; // get results
      X := FormMain.VisionCentreX * PixelSize; // error im mm
      Y := FormMain.VisionCentreY * PixelSize;

      if (Correlation > 0) then // if image found
      begin
        if FormMain.MoveHomeRelative(X, Y, CNCHome1Z, 0, CNCMaxStepsPerSecond) then
        begin
          Beep;
        end
        else
          MessageDlg('FAILED TO MOVE TO CENTRE!', mtError, [mbCancel], 0, mbCancel);
      end
      else
        MessageDlg('HOME TEST FAILED!', mtInformation, [mbOk], 0, mbOk);
    end
    else
      MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
  end
  else
    MessageDlg('FAILED TO MOVE TO HOME!', mtError, [mbCancel], 0, mbCancel);

  FreeImage(FormMain.ImageReference);
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormHomeSettings.ButtonTestHome2Click(Sender: TObject);
var
  B: TBitmap;
  X, Y, Correlation, PixelSize: double;
begin
  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(Settings_Directory + 'Home2.bmp');
  Except
  End;
  FormMain.ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************

  try // set pixel size in mm
    PixelSize := DownlookingViewWidthInMM / FormMain.ImageDownlooking.Width;
  except
    PixelSize := 0.05; // default
  end;

  // ******************************************************************************

  if FormMain.MoveHomeRelativeWithNozzleProtection(CNCHome2X, CNCHome2Y, CNCHome2Z, 0, CNCMaxStepsPerSecond) then
  begin
    FormMain.Delay(DownlookingCameraSettlingDelay); // small delay

    if FormMain.CaptureDownlooking and FormMain.CaptureDownlooking and FormMain.CaptureDownlooking then
    begin
      FormMain.VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
      // correlate image
      Correlation := FormMain.VisionCorrelation; // get results
      X := FormMain.VisionCentreX * PixelSize; // error im mm
      Y := FormMain.VisionCentreY * PixelSize;

      if (Correlation > 0) then // if image found
      begin
        if FormMain.MoveHomeRelative(CNCHome2X + X, CNCHome2Y + Y, CNCHome2Z, 0, CNCMaxStepsPerSecond) then
        begin
          Beep;
        end
        else
          MessageDlg('FAILED TO MOVE TO CENTRE!', mtError, [mbCancel], 0, mbCancel);
      end
      else
        MessageDlg('HOME 2 TEST FAILED!', mtInformation, [mbOk], 0, mbOk);
    end
    else
      MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
  end
  else
    MessageDlg('FAILED TO MOVE TO HOME!', mtError, [mbCancel], 0, mbCancel);

  FreeImage(FormMain.ImageReference);
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormHomeSettings.EditHome1XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome1X.Text);
      if (V >= CNCMinX) and (V <= CNCMaxX) then // restrict range
      begin
        CNCHome1X := V;
        EditHome1X.Color := clWindow; // normal colour
      end
      else
        EditHome1X.Color := clRed; // error colour
    except
      EditHome1X.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome1XKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.EditHome1YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome1Y.Text);
      if (V >= CNCMinY) and (V <= CNCMaxY) then // restrict range
      begin
        CNCHome1Y := V;
        EditHome1Y.Color := clWindow; // normal colour
      end
      else
        EditHome1Y.Color := clRed; // error colour
    except
      EditHome1Y.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome1YKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.EditHome2XChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome2X.Text);
      if (V >= CNCMinX) and (V <= CNCMaxX) then // restrict range
      begin
        CNCHome2X := V;
        EditHome2X.Color := clWindow; // normal colour
      end
      else
        EditHome2X.Color := clRed; // error colour
    except
      EditHome2X.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome2XKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.EditHome2YChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome2Y.Text);
      if (V >= CNCMinY) and (V <= CNCMaxY) then // restrict range
      begin
        CNCHome2Y := V;
        EditHome2Y.Color := clWindow; // normal colour
      end
      else
        EditHome2Y.Color := clRed; // error colour
    except
      EditHome2Y.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome2YKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.EditHome2ZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome2Z.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then // restrict range
      begin
        CNCHome2Z := V;
        EditHome2Z.Color := clWindow; // normal colour
      end
      else
        EditHome2Z.Color := clRed; // error colour
    except
      EditHome2Z.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome2ZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.EditParkXChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditParkX.Text);

      if (V + CNCActualHomeX >= CNCMinX) and (V + CNCActualHomeX <= CNCMaxX) then
      begin
        EditParkX.Color := clWindow;
        ParkX := V;
      end
      else
        EditParkX.Color := clRed;
    except
      EditParkX.Color := clRed;
    end;
  end;
end;

procedure TFormHomeSettings.EditParkYChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditParkX.Text);

      if (V + CNCActualHomeY >= CNCMinY) and (V + CNCActualHomeY <= CNCMaxY) then
      begin
        EditParkY.Color := clWindow;
        ParkY := V;
      end
      else
        EditParkY.Color := clRed;
    except
      EditParkY.Color := clRed;
    end;
  end;
end;

procedure TFormHomeSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings; // ensure the settings are saved first
end;

procedure TFormHomeSettings.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width; // position at top right
  Self.Top := 0;

  UpdateValues;
  UpdateButtons;
  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
end;

procedure TFormHomeSettings.EditHome1ZChange(Sender: TObject);
var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditHome1Z.Text);
      if (V >= CNCMinZ) and (V <= CNCMaxZ) then // restrict range
      begin
        CNCHome1Z := V;
        EditHome1Z.Color := clWindow; // normal colour
      end
      else
        EditHome1Z.Color := clRed; // error colour
    except
      EditHome1Z.Color := clRed; // error colour
    end;
  end;
end;

procedure TFormHomeSettings.EditHome1ZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

procedure TFormHomeSettings.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormHomeSettings.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
