unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls,
  Image, ImageIO, ImageIOVideo, FilterImageLoader, Filter, FilterWindow, FilterNormalisedCrossCorrelation,
  FilterResize, FilterRotation, FParameters, GetVerInfo, Menus, ExtDlgs, shFolder, Buttons, Grids,
  DeskWinApi, DeskWinCNC, UiTypes, WinApi.DirectShow9, WCamera, Vcl.Mask;

type
  TFormMain = class(TForm)
    ButtonHome: TButton;
    ButtonReset: TButton;
    GroupBoxPosition: TGroupBox;
    LabelStatus: TLabel;
    LabelX: TLabel;
    LabelY: TLabel;
    LabelZ: TLabel;
    LabelA: TLabel;
    PanelLiveVideo: TPanel;
    PanelVideoCrossHairX: TPanel;
    PanelVideoCrossHairY: TPanel;
    OpenPictureDialog1: TOpenPictureDialog;
    FileOpenDialogProject: TFileOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    NewProject1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Exit1: TMenuItem;
    Settings1: TMenuItem;
    CNCSettings1: TMenuItem;
    VisionSettings1: TMenuItem;
    NozzleChangerSettings1: TMenuItem;
    HomeSettings1: TMenuItem;
    LabelNozzle: TLabel;
    GroupBoxCameraSelection: TGroupBox;
    RadioButtonUpCamera: TRadioButton;
    RadioButtonDownCamera: TRadioButton;
    PanelV1: TPanel;
    PanelV2: TPanel;
    PanelV3: TPanel;
    PanelV4: TPanel;
    PanelV5: TPanel;
    PanelV6: TPanel;
    PanelV7: TPanel;
    PanelV8: TPanel;
    PanelV9: TPanel;
    PanelV10: TPanel;
    PanelV11: TPanel;
    PanelV12: TPanel;
    PanelH1: TPanel;
    PanelH2: TPanel;
    PanelH3: TPanel;
    PanelH5: TPanel;
    PanelH6: TPanel;
    PanelH4: TPanel;
    PanelH7: TPanel;
    PanelH8: TPanel;
    PanelH9: TPanel;
    PanelH10: TPanel;
    PanelH11: TPanel;
    PanelH12: TPanel;
    PanelV13: TPanel;
    PanelV17: TPanel;
    PanelV18: TPanel;
    PanelV19: TPanel;
    PanelV20: TPanel;
    PanelV14: TPanel;
    PanelV15: TPanel;
    PanelV16: TPanel;
    PanelH13: TPanel;
    PanelH14: TPanel;
    PanelH15: TPanel;
    PanelH16: TPanel;
    PanelH17: TPanel;
    PanelH18: TPanel;
    PanelH19: TPanel;
    PanelH20: TPanel;
    FileSaveDialogProject: TFileSaveDialog;
    ButtonEmergencyStop: TBitBtn;
    ListBoxPartList: TListBox;
    GroupBoxPlaceControls: TGroupBox;
    EditBoardOriginY: TLabeledEdit;
    EditBoardOriginX: TLabeledEdit;
    ButtonSetOrigin: TButton;
    ButtonGotoBoard: TButton;
    GroupBoxPartDetails: TGroupBox;
    EditPartPositionX: TLabeledEdit;
    EditPartPositionY: TLabeledEdit;
    EditPartAngle: TLabeledEdit;
    EditPartDesignator: TLabeledEdit;
    EditPartComment: TLabeledEdit;
    CheckBoxPartEnabled: TCheckBox;
    ImagePartSnap: TImage;
    ButtonDeletePart: TButton;
    ButtonAddPart: TButton;
    ButtonGotoPart: TButton;
    ButtonSetPartPosition: TButton;
    ButtonParkNozzle: TButton;
    ButtonSortParts: TButton;
    EditBoardHeight: TLabeledEdit;
    ButtonSetBoardHeight: TButton;
    RejectTraySettings1: TMenuItem;
    TimerStartup: TTimer;
    TimerDelay: TTimer;
    NozzleOffsetSettings1: TMenuItem;
    ImageNoSnap: TImage;
    ButtonStartBoard: TButton;
    ButtonPause: TButton;
    ButtonStop: TButton;
    ButtonResume: TButton;
    ButtonDiscard: TButton;
    ButtonPickPart: TButton;
    ButtonPlacePart: TButton;
    ButtonGotoCamera: TButton;
    GroupBoxJogControl: TGroupBox;
    ButtonJogAMinus: TButton;
    ButtonJogAPlus: TButton;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonAMinus1: TButton;
    ButtonAPlus1: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonAMinus10: TButton;
    ButtonAPlus10: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    ButtonPark: TButton;
    ButtonGotoNextPart: TButton;
    ComboBoxFeeder: TComboBox;
    LabelFeeder: TLabel;
    ButtonFiducials: TButton;
    ButtonFeeders: TButton;
    SaveProject1: TMenuItem;
    ImportPlaceFile1: TMenuItem;
    PanelH21: TPanel;
    PanelV22: TPanel;
    PanelV24: TPanel;
    PanelV25: TPanel;
    PanelV26: TPanel;
    PanelV27: TPanel;
    PanelV28: TPanel;
    PanelV29: TPanel;
    PanelV30: TPanel;
    PanelH22: TPanel;
    PanelH23: TPanel;
    PanelH24: TPanel;
    PanelH25: TPanel;
    PanelH26: TPanel;
    PanelH27: TPanel;
    PanelH28: TPanel;
    PanelH29: TPanel;
    PanelH30: TPanel;
    PanelV21: TPanel;
    PanelV23: TPanel;
    CheckBoxMetric: TCheckBox;
    ButtonStartPanel: TButton;
    GroupBoxPanelSettings: TGroupBox;
    ButtonPanelSettings: TButton;
    ButtonResetPanel: TButton;
    EditCurrentPanelCount: TLabeledEdit;
    ButtonNextBoard: TButton;
    GroupBoxVisionResult: TGroupBox;
    LabelVisionResult: TLabel;
    PanelVideoCrossHairXSmall: TPanel;
    PanelVideoCrossHairYSmall: TPanel;
    PanelCameraUp: TPanel;
    LabelVideoTouchUp: TLabel;
    PanelCameraDown: TPanel;
    LabelVideoTouchDown: TLabel;
    procedure ButtonHomeClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure ButtonJogAMinusClick(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonAPlus1Click(Sender: TObject);
    procedure ButtonAMinus1Click(Sender: TObject);
    procedure ButtonAPlus10Click(Sender: TObject);
    procedure ButtonAMinus10Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonResetClick(Sender: TObject);
    procedure ButtonFeedersClick(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure VisionSettings1Click(Sender: TObject);
    procedure NozzleChangerSettings1Click(Sender: TObject);
    procedure CNCSettings1Click(Sender: TObject);
    procedure HomeSettings1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure RadioButtonUpCameraClick(Sender: TObject);
    procedure RadioButtonDownCameraClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonEmergencyStopClick(Sender: TObject);
    procedure ButtonSetOriginClick(Sender: TObject);
    procedure EditBoardOriginXKeyPress(Sender: TObject; var Key: Char);
    procedure EditBoardOriginYKeyPress(Sender: TObject; var Key: Char);
    procedure EditBoardOffsetZKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonGotoBoardClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Close1Click(Sender: TObject);
    procedure ButtonAddPartClick(Sender: TObject);
    procedure ListBoxPartListClick(Sender: TObject);
    procedure ButtonDeletePartClick(Sender: TObject);
    procedure ButtonGotoPartClick(Sender: TObject);
    procedure ButtonParkNozzleClick(Sender: TObject);
    procedure EditPartPositionXChange(Sender: TObject);
    procedure EditPartPositionYChange(Sender: TObject);
    procedure EditPartAngleChange(Sender: TObject);
    procedure ButtonSetBoardHeightClick(Sender: TObject);
    procedure EditBoardHeightKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonGotoCameraClick(Sender: TObject);
    procedure RejectTraySettings1Click(Sender: TObject);
    procedure TimerStartupTimer(Sender: TObject);
    procedure TimerDelayTimer(Sender: TObject);
    procedure ButtonSetPartPositionClick(Sender: TObject);
    procedure ButtonFiducialsClick(Sender: TObject);
    procedure ButtonSortPartsClick(Sender: TObject);
    procedure NozzleOffsetSettings1Click(Sender: TObject);
    procedure EditPartDesignatorChange(Sender: TObject);
    procedure EditPartCommentChange(Sender: TObject);
    procedure CheckBoxPartEnabledClick(Sender: TObject);
    procedure ButtonParkClick(Sender: TObject);
    procedure ButtonGotoNextPartClick(Sender: TObject);
    procedure ComboBoxFeederKeyPress(Sender: TObject; var Key: Char);
    procedure ComboBoxFeederChange(Sender: TObject);
    procedure SaveProject1Click(Sender: TObject);
    procedure CheckBoxMetricClick(Sender: TObject);
    procedure ImportPlaceFile1Click(Sender: TObject);
    procedure ButtonDiscardClick(Sender: TObject);
    procedure ButtonPickPartClick(Sender: TObject);
    procedure ButtonPlacePartClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure EditCurrentPanelCountKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonResetPanelClick(Sender: TObject);
    procedure ButtonPanelSettingsClick(Sender: TObject);
    procedure ButtonNextBoardClick(Sender: TObject);
    procedure ButtonStartBoardClick(Sender: TObject);
    procedure ButtonStartPanelClick(Sender: TObject);
    procedure ButtonPauseClick(Sender: TObject);
    procedure ButtonResumeClick(Sender: TObject);
    procedure ButtonStopClick(Sender: TObject);
    procedure PaintBoxImageUpClick(Sender: TObject);
    procedure PaintBoxImageDownClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PanelCameraUpClick(Sender: TObject);
    procedure PanelCameraDownClick(Sender: TObject);
    procedure LabelVideoTouchDownClick(Sender: TObject);
    procedure LabelVideoTouchUpClick(Sender: TObject);
    procedure PaintBoxVideoUpClick(Sender: TObject);
    procedure PaintBoxVideoDownClick(Sender: TObject);
  private
    { Private declarations }
    SystemStarted: Boolean;
    DelayFlag: Boolean;
    UpCameraFrameAvailable: Boolean;
    DownCameraFrameAvailable: Boolean;
    function LoadProject: Boolean;
    function SaveProject: Boolean;

  public
    { Public declarations }
    ImageLoaded: PBitmap32;
    ImageReference: PBitmap32;
    ImageDownlooking: PBitmap32;
    ImageUplooking: PBitmap32;
    VisionCentreX: double;
    VisionCentreY: double;
    VisionAngle: double;
    VisionCorrelation: double;
    CameraDeviceList: TStringList;
    VideoBitmapUp, VideoBitmapDown: TBitmap;

    function Initialise: Boolean;
    procedure UpdateCameraSelection;
    procedure UpdateVideoGridRulers;
    procedure UpdateButtons;
    procedure UpdateStatus;
    function CorrelateHome1: Boolean;
    function CorrelateHome2: Boolean;
    function AlignDualYAxis: Boolean;
    function Home: Boolean;
    function VisualCorrelation(Angle: double; EnlargeMM: Integer; UseUpCamera: Boolean): Boolean;
    function AngularVisualCorrelation(Angle: double; EnlargeMM: Integer): Boolean;
    procedure UpdatePartList;
    function CaptureDownlooking: Boolean;
    function CaptureUplooking: Boolean;
    procedure Delay(T: double);
    function MoveBoardRelativeWithPartAndNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveBoardRelativeWithPart(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveBoardRelativeWithNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveBoardRelative(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveHomeRelativeWithPartAndNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveHomeRelativeWithPart(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveHomeRelativeWithNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
    function MoveHomeRelative(X, Y, Z, A: double; Speed: Integer): Boolean;
    function Move(X, Y, Z, A: double; Speed: Integer): Boolean;
    function TestFiducials: Boolean;
    procedure AutomaticCycle;
    function PickAndPlace: Boolean;
    function PickPart(Feeder: Integer; Angle: double): Boolean;
    function PickPartWithoutCorrelation(Feeder: Integer; Angle: double): Boolean;
    function PlacePart(Part: Integer): Boolean;
    function DiscardPart(Feeder: Integer): Boolean;
    procedure Speak(S: String);
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

uses
  Math, CNCSettings, Settings, Feeders, NozzleChanger, VisionSettings, HomeSettings,
  CreateSnap, RejectTray, FiducialSettings, NozzleOffset, NewProject, StrUtils,
  ImportPlaceFile, ConfirmNozzleSelection, PanelSettings, VisionTest, ComObj,
  MetroDisplayRotation;

var
  Voice: Variant;

procedure TFormMain.Speak(S: String);
const
  SVSFlagsAsync = 1;
begin
  try
    if VarType(Voice) <> varDispatch then
      Voice := CreateOleObject('SAPI.SpVoice');
    Voice.Speak(Lowercase(S), SVSFlagsAsync)
  except
  end
end;

procedure TFormMain.Delay(T: double);
begin
  TimerDelay.Enabled := false; // ensure timer is disabled
  DelayFlag := false;
  TimerDelay.Interval := Round(T * 1000); // milliseconds
  Application.ProcessMessages;
  UpdateStatus;
  UpdateButtons;
  TimerDelay.Enabled := true; // enable timer is disabled
  Repeat
    Application.ProcessMessages;
  Until DelayFlag;
  TimerDelay.Enabled := false; // ensure timer is disabled
  DelayFlag := false;
  Application.ProcessMessages;
end;

function TFormMain.CaptureDownlooking: Boolean;
Var
  B: TBitmap;
begin
  B := FormVisionSettings.WCameraDown.CurrentImageToBitmap(true, 100);
  FreeImage(ImageDownlooking); // dispose of previous image
  ImageDownlooking := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;
  Result := true; // return status
end;

function TFormMain.CaptureUplooking: Boolean;
Var
  B: TBitmap;
begin
  B := FormVisionSettings.WCameraUp.CurrentImageToBitmap(true, 100);
  FreeImage(ImageUplooking); // dispose of previous image
  ImageUplooking := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;
  Result := true; // return status
end;

procedure TFormMain.CheckBoxMetricClick(Sender: TObject);
begin
  BoardMetric := CheckBoxMetric.Checked;
  DisplayMetric := BoardMetric;
  if Enabled then
    ProjectEdited := true;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.CheckBoxPartEnabledClick(Sender: TObject);
begin
  if Enabled then
  begin
    PartList[Pred(CurrentPart)].Enabled := CheckBoxPartEnabled.Checked; // update changes
    UpdatePartList;
    ProjectEdited := true;
  end;
end;

procedure TFormMain.UpdateCameraSelection;
begin
  case ViewSelection of // select required view
    0: // downlooking
      begin
        PanelCameraUp.Visible := false;
        PanelCameraDown.Visible := true;

        if not RadioButtonDownCamera.Checked then
          UpdateVideoGridRulers;

        RadioButtonDownCamera.Checked := true;
      end;
    1: // uplooking
      begin
        PanelCameraDown.Visible := false;
        PanelCameraUp.Visible := true;

        if not RadioButtonUpCamera.Checked then
          UpdateVideoGridRulers;

        RadioButtonUpCamera.Checked := true;
      end;
  end;
end;

procedure TFormMain.UpdateButtons;
begin
  // ******************************************************************************

  if CNCEmergencyStop then // disable all outputs if emergency stop
  begin
    if CNCOutputFeederState then
      SetOutputFeeder(false);

    if CNCOutputBlowState then
      SetOutputBlow(false);

    if CNCOutputVacuumState then
      SetOutputVacuum(false);

    if CNCOutputDispenserState then
      SetOutputDispenser(false);
  end;

  // ******************************************************************************

  UpdateCameraSelection;

  // ******************************************************************************

  ButtonReset.Enabled := CNCEmergencyStop or not(CNCControllerFound and CNCInitialised);
  ButtonHome.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonPark.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  GroupBoxJogControl.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonParkNozzle.Enabled := NozzleChangerEnabled and (CurrentNozzle > 0) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonGotoCamera.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonEmergencyStop.Enabled := CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  // ******************************************************************************

  CheckBoxMetric.Visible := ProjectOpen;

  GroupBoxPlaceControls.Visible := ProjectOpen;
  GroupBoxPlaceControls.Enabled := ProjectOpen and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonFeeders.Visible := ProjectOpen;
  ButtonFiducials.Visible := ProjectOpen;

  ButtonDeletePart.Enabled := ProjectOpen and (PartCount >= 1);

  ButtonSetPartPosition.Enabled := ProjectOpen and (PartCount >= 1) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonGotoPart.Enabled := ProjectOpen and (PartCount >= 1) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonGotoNextPart.Enabled := ProjectOpen and (PartCount > 1) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;

  ButtonSetOrigin.Enabled := ProjectOpen and (PanelBoardCount = 1) and not(AutomaticPanel or AutomaticBoard);

  ButtonSortParts.Enabled := ProjectOpen and (PartCount > 1) and not(AutomaticPanel or AutomaticBoard);
  ButtonFeeders.Enabled := ProjectOpen and not(AutomaticPanel or AutomaticBoard);
  ButtonFiducials.Enabled := ProjectOpen and not(AutomaticPanel or AutomaticBoard);

  SaveProject1.Enabled := ProjectOpen and ProjectEdited;
  Close1.Enabled := ProjectOpen;
  GroupBoxPanelSettings.Visible := ProjectOpen;
  GroupBoxPartDetails.Visible := ProjectOpen;
  ListBoxPartList.Visible := ProjectOpen;

  ButtonFeeders.Enabled := ProjectOpen and not(AutomaticPanel or AutomaticBoard);
  ImportPlaceFile1.Enabled := ProjectOpen and not(AutomaticPanel or AutomaticBoard);

  ButtonPickPart.Enabled := ProjectOpen and (not PartPicked) and not(AutomaticPanel or AutomaticBoard);
  ButtonDiscard.Enabled := ProjectOpen and PartPicked and not(AutomaticPanel or AutomaticBoard);

  File1.Enabled := not(AutomaticPanel or AutomaticBoard);
  // disable menu while placing
  Settings1.Enabled := not(AutomaticPanel or AutomaticBoard);

  GroupBoxPanelSettings.Enabled := ProjectOpen;
  ButtonSetBoardHeight.Enabled := (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonSetOrigin.Enabled := (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonGotoBoard.Enabled := (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonResetPanel.Enabled := ProjectOpen and (PanelBoardCount > 1) and (not(AutomaticPanel or AutomaticBoard));
  ButtonNextBoard.Enabled := ProjectOpen and (PanelBoardCount > PanelCountX * PanelCountY) and not(AutomaticPanel or AutomaticBoard);

  // ******************************************************************************

  ButtonPause.Enabled := (not Pause) and (AutomaticPanel or AutomaticBoard);
  ButtonResume.Enabled := Pause;
  ButtonStop.Enabled := AutomaticPanel or AutomaticBoard;
  ButtonStartPanel.Enabled := ((PanelCountX > 1) or (PanelCountY > 1)) and (CurrentPart > 0) and (CurrentPart <= PartCount) and
    (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and CNCInitialised and not CNCEmergencyStop;
  ButtonStartBoard.Enabled := (CurrentPart > 0) and (CurrentPart <= PartCount) and (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and
    CNCInitialised and not CNCEmergencyStop;
  ButtonPickPart.Enabled := (CurrentPart > 0) and (CurrentPart <= PartCount) and (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and
    CNCInitialised and not CNCEmergencyStop;
  ButtonPlacePart.Enabled := (CurrentPart > 0) and (CurrentPart <= PartCount) and (not(AutomaticPanel or AutomaticBoard)) and CNCControllerFound and
    CNCInitialised and not CNCEmergencyStop;

  // ******************************************************************************

  if ProjectOpen then
    FormMain.Caption := 'Pick And Place - ' + ProjectName
  else
    FormMain.Caption := 'Pick And Place - ** NO PROJECT! **';

  Application.ProcessMessages;
end;

procedure TFormMain.ImportPlaceFile1Click(Sender: TObject);
begin
  if FormImportPlaceFile.ShowModal = mrOk then
  begin
    UpdatePartList;
    UpdateStatus;
    UpdateButtons;
  end;
end;

function TFormMain.Initialise: Boolean;
begin
  Result := CNCInitialise;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.NewProject1Click(Sender: TObject);
begin
  if ProjectOpen and (MessageDlg('Save Changes To Current Project?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    if SaveProject then
      ProjectOpen := false; // reset flag
  end
  else
    ProjectOpen := false; // reset flag

  // ******************************************************************************

  if not ProjectOpen then
  begin
    if (FormNewProject.ShowModal = mrOk) then // prompt for project name
    begin // try creating folder
      if CreateDir(ProjectPath) then
      begin // try create blank project and then load project
        if Create_New_Project(ProjectPath, ProjectName) and Load_Project(ProjectPath, ProjectName) then
        begin
          ProjectOpen := true;
        end
        else
        begin
          MessageDlg('FILE CREATION ERROR!', mtError, [mbCancel], 0, mbCancel);
          ProjectName := ''; // blank project name
          ProjectOpen := false; // set flag
          ProjectEdited := false; // indicate no save required
          PartCount := 0;
          CurrentPart := 0; // no part selected
          SetLength(PartList, PartCount); // clear parts list
        end;
      end
      else
      begin
        MessageDlg('FOLDER CREATION ERROR!', mtError, [mbCancel], 0, mbCancel);
        ProjectName := ''; // blank project name
        ProjectOpen := false; // set flag
        ProjectEdited := false; // indicate no save required
        PartCount := 0;
        CurrentPart := 0; // no part selected
        SetLength(PartList, PartCount); // clear parts list
      end;
    end
    else
    begin
      ProjectName := ''; // blank project name
      ProjectOpen := false; // set flag
      ProjectEdited := false; // indicate no save required
      PartCount := 0;
      CurrentPart := 0; // no part selected
      SetLength(PartList, PartCount); // clear parts list
    end;
  end;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.NozzleChangerSettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormNozzleChanger.ShowModal; // show nozzle changer form
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.NozzleOffsetSettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormNozzleOffset.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.RadioButtonDownCameraClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  UpdateButtons;
end;

procedure TFormMain.RadioButtonUpCameraClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  UpdateButtons;
end;

procedure TFormMain.RejectTraySettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormRejectTray.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.Open1Click(Sender: TObject);
begin
  if ProjectOpen and ProjectEdited and (MessageDlg('Save Changes To Current Project??', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    if ProjectName = '' then // prompt for filename
    begin
      if SaveProject then
        ProjectOpen := false; // reset flag
    end
    else if Save_Project(ProjectPath, ProjectName) then // use current filename
      ProjectOpen := false; // reset flag
  end
  else
    ProjectOpen := false;

  if not ProjectOpen then // if ok to create new project
    ProjectOpen := LoadProject;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.LabelVideoTouchDownClick(Sender: TObject);
begin
  if CaptureDownlooking then
    FormCreateSnap.CreateProjectSnap(ImageDownlooking);
end;

procedure TFormMain.LabelVideoTouchUpClick(Sender: TObject);
begin
  if CaptureUplooking then
    FormCreateSnap.CreateProjectSnap(ImageUplooking);
end;

procedure TFormMain.ListBoxPartListClick(Sender: TObject);
begin
  CurrentPart := Succ(ListBoxPartList.ItemIndex); // select part clicked

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.LoadProject: Boolean;
begin
  if not ProjectOpen then // if ok to create new project
  begin
    FileOpenDialogProject.DefaultFolder := Data_Directory;
    FileOpenDialogProject.filename := '';
    FileOpenDialogProject.Title := 'Open Project';
    FileOpenDialogProject.OkButtonLabel := 'Open Project';
    if FileOpenDialogProject.Execute then
    begin
      ProjectPath := IncludeTrailingPathDelimiter(ExtractFilePath(FileOpenDialogProject.filename));
      ProjectName := ChangeFileExt(ExtractFileName(FileOpenDialogProject.filename), '');
      ProjectOpen := Load_Project(ProjectPath, ProjectName); // load project
      Result := ProjectOpen; // return status
    end
    else
      Result := false; // indicate failure
  end
  else
    Result := false; // indicate failure

  UpdatePartList; // refresh parts list
  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.SaveProject: Boolean;
begin
  if ProjectOpen then // if project
  begin
    if ProjectPath = '' then
      ProjectPath := Data_Directory;
    FileSaveDialogProject.DefaultFolder := ProjectPath;
    FileSaveDialogProject.filename := ChangeFileExt(ProjectName, '');
    FileSaveDialogProject.Title := 'Save Project As';
    FileSaveDialogProject.OkButtonLabel := 'Save Project';
    if FileSaveDialogProject.Execute then
    begin
      ProjectPath := IncludeTrailingPathDelimiter(ExtractFilePath(FileSaveDialogProject.filename));
      ProjectName := ChangeFileExt(ExtractFileName(FileSaveDialogProject.filename), '');

      if Save_Project(ProjectPath, ProjectName) then // save this project
      begin
        ProjectEdited := false;
        Result := true; // return success
      end
      else
        Result := false; // indicate failure
    end
    else
      Result := false; // indicate failure
  end
  else
    Result := false; // indicate failure

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.SaveProject1Click(Sender: TObject);
begin
  if Save_Project(ProjectPath, ProjectName) then
    ProjectEdited := false;

  UpdateButtons;
end;

procedure TFormMain.TimerDelayTimer(Sender: TObject);
begin
  TimerDelay.Enabled := false; // end delay
  DelayFlag := true;
end;

procedure TFormMain.TimerStartupTimer(Sender: TObject);
begin
  TimerStartup.Enabled := false;

  // ******************************************************************************
  FormVisionSettings.StartCameras;
  FormVisionSettings.UpdateVideoPositionUp;
  FormVisionSettings.UpdateVideoPositionDown;

  // ******************************************************************************
  CNCInitialised := false;
  CNCInitialise; // try initialising the controller

  // ******************************************************************************
  if CNCControllerFound then
  begin
    if CNCInitialised then
    begin
      if CNCEmergencyStop then
      begin
        Speak('EMERGENCY STOP!');
        MessageDlg('EMERGENCY STOP!', mtError, [mbCancel], 0, mbCancel);
      end
      else
        Home;
    end
    else
    begin
      Speak('FAILED TO INITIALISE CNC CONTROLLER!');
      MessageDlg('FAILED TO INITIALISE CNC CONTROLLER!', mtError, [mbCancel], 0, mbCancel);
    end;
  end
  else
  begin
    Speak('FAILED TO LOCATE CNC CONTROLLER!');
    MessageDlg('FAILED TO LOCATE CNC CONTROLLER!', mtError, [mbCancel], 0, mbCancel);
  end;

  // ******************************************************************************
  if NozzleChangerEnabled then // confirm nozzle status to prevent damage
  begin
    FormConfirmNozzleSelection.ShowModal;
    UpdateStatus;
    UpdateButtons;
  end;

  // ******************************************************************************
  UpdateVideoGridRulers;

  // ******************************************************************************
  If ProjectOpen then
    ListBoxPartList.SetFocus;
end;

Procedure TFormMain.UpdateStatus;
var
  PanX, PanY: double;
begin
  if CNCEmergencyStop then
    LabelStatus.Caption := 'EMERGENCY STOP'
  else if CNCControllerFound and CNCInitialised then
    LabelStatus.Caption := 'READY'
  else
    LabelStatus.Caption := 'DISABLED';

  // ******************************************************************************
  // determine panel count based X and Y position

  if PanelBoardCount <= 0 then // range check
    PanelBoardCount := 1;

  if PanelBoardCount > PanelCountX * PanelCountY then // range check
    PanelBoardCount := 1;

  if PanelCountX <= 0 then // range check
    PanelCountX := 1;

  if PanelCountY <= 0 then // range check
    PanelCountY := 1;

  if (PanelCountX = 1) and (PanelCountY = 1) then
  begin // no X or Y
    PanX := 0;
    PanY := 0;
  end
  else if PanelCountX = 1 then
  begin // Y ONLY
    PanY := Pred(PanelBoardCount) * PanelSpacingY;
    PanX := 0;
  end
  else if PanelCountY = 1 then
  begin // X ONLY
    PanX := Pred(PanelBoardCount) * PanelSpacingX;
    PanY := 0;
  end
  else
  begin
    PanX := (Pred(PanelBoardCount) Mod PanelCountX) * PanelSpacingX;
    PanY := (Pred(PanelBoardCount) Div PanelCountX) * PanelSpacingY;
  end;

  BoardOriginX := PanelOriginX + PanX; // adjust by position of current board
  BoardOriginY := PanelOriginY + PanY;

  // ******************************************************************************

  if ProjectOpen and not(FormCNCSettings.Visible or FormHomeSettings.Visible or FormRejectTray.Visible or FormNozzleChanger.Visible or FormFeeders.Visible or
    FormVisionSettings.Visible or FormNozzleOffset.Visible) then
  begin // if project open then show values relative to PCB offset
    GroupBoxPosition.Color := clYellow; // show BOARD relative values in YELLOW
    DisplayMetric := BoardMetric; // ensure correct mode

    if BoardMetric then
    begin
      LabelX.Caption := 'X ' + FloatToStrF(CNCXPos - CNCActualHomeX - BoardOriginX, ffFixed, 10, 3) + 'mm';
      LabelY.Caption := 'Y ' + FloatToStrF(CNCYPos - CNCActualHomeY - BoardOriginY, ffFixed, 10, 3) + 'mm';
      LabelZ.Caption := 'Z ' + FloatToStrF(CNCZPos - CNCHomeZ, ffFixed, 10, 3) + 'mm';
      LabelA.Caption := 'A ' + FloatToStrF(CNCAPos, ffFixed, 10, 3);
    end
    else
    begin
      LabelX.Caption := 'X ' + FloatToStrF((CNCXPos - CNCActualHomeX - BoardOriginX) / 25.4, ffFixed, 10, 4) + 'in';
      LabelY.Caption := 'Y ' + FloatToStrF((CNCYPos - CNCActualHomeY - BoardOriginY) / 25.4, ffFixed, 10, 4) + 'in';
      LabelZ.Caption := 'Z ' + FloatToStrF((CNCZPos - CNCHomeZ) / 25.4, ffFixed, 10, 4) + 'in';
      LabelA.Caption := 'A ' + FloatToStrF(CNCAPos, ffFixed, 10, 3);
    end;
  end
  else
  begin // else show HOME relative values
    DisplayMetric := true; // always default to metric with no job
    GroupBoxPosition.Color := clLime; // show HOME relative values in LIME
    LabelX.Caption := 'X ' + FloatToStrF(CNCXPos - CNCActualHomeX, ffFixed, 10, 3) + 'mm';
    LabelY.Caption := 'Y ' + FloatToStrF(CNCYPos - CNCActualHomeY, ffFixed, 10, 3) + 'mm';
    LabelZ.Caption := 'Z ' + FloatToStrF(CNCZPos - CNCHomeZ, ffFixed, 10, 3) + 'mm';
    LabelA.Caption := 'A ' + FloatToStrF(CNCAPos, ffFixed, 10, 3);
  end;

  if BoardMetric then
  begin
    EditBoardOriginX.Text := FloatToStrF(BoardOriginX, ffFixed, 10, 3);
    EditBoardOriginY.Text := FloatToStrF(BoardOriginY, ffFixed, 10, 3);
    EditBoardHeight.Text := FloatToStrF(BoardHeight, ffFixed, 10, 3);
  end
  else
  begin
    EditBoardOriginX.Text := FloatToStrF(BoardOriginX / 25.4, ffFixed, 10, 4);
    EditBoardOriginY.Text := FloatToStrF(BoardOriginY / 25.4, ffFixed, 10, 4);
    EditBoardHeight.Text := FloatToStrF(BoardHeight / 25.4, ffFixed, 10, 4);
  end;

  EditCurrentPanelCount.Text := IntToStr(PanelBoardCount) + ' of ' + IntToStr(PanelCountX * PanelCountY);

  if NozzleChangerEnabled then
  begin
    if CurrentNozzle > 0 then
      LabelNozzle.Caption := 'NOZZLE ' + IntToStr(CurrentNozzle)
    else
      LabelNozzle.Caption := 'NO NOZZLE';
  end
  else
    LabelNozzle.Caption := '';
end;

procedure TFormMain.ButtonSetBoardHeightClick(Sender: TObject);
begin
  Speak('ARE YOU SURE YOU WANT TO SET THE BOARD HEIGHT?');
  if (MessageDlg('ARE YOU SURE YOU WANT TO SET THE BOARD HEIGHT?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    BoardHeight := CNCZPos - CNCHomeZ;
    ProjectEdited := true; // indicate  save required

    UpdateStatus;
    UpdateButtons;
  end;
end;

procedure TFormMain.ButtonSetOriginClick(Sender: TObject);
begin
  Speak('ARE YOU SURE YOU WANT TO SET THE PANEL ORIGIN?');
  if (MessageDlg('ARE YOU SURE YOU WANT TO SET THE PANEL ORIGIN?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    PanelOriginX := CNCXPos - CNCActualHomeX;
    PanelOriginY := CNCYPos - CNCActualHomeY;

    ProjectEdited := true; // indicate  save required

    UpdateStatus;
    UpdateButtons;
  end;
end;

procedure TFormMain.ButtonSetPartPositionClick(Sender: TObject);
begin
  Speak('ARE YOU SURE YOU WANT TO SET THE POSITION?');
  if (MessageDlg('ARE YOU SURE YOU WANT TO SET THE POSITION?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    PartList[Pred(CurrentPart)].X := CNCXPos - CNCActualHomeX - BoardOriginX;
    PartList[Pred(CurrentPart)].Y := CNCYPos - CNCActualHomeY - BoardOriginY;
    ProjectEdited := true; // indicate  save required

    UpdatePartList;
    UpdateStatus;
    UpdateButtons;
  end;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonSortPartsClick(Sender: TObject); { sort the part list by nozzle, feeder, designator, comment }

  Function PartRecCompare(A, B: PartRec): Boolean;
  Var
    NozzleA, NozzleB, FeederA, FeederB: Integer;
  begin
    FeederA := A.Feeder; // get feeder
    if FeederA = 0 then
      FeederA := MaxInt; // if invalid then place at end

    FeederB := B.Feeder;
    if FeederB = 0 then
      FeederB := MaxInt; // if invalid then place at end

    try
      NozzleA := FeederList[Pred(A.Feeder)].Nozzle; // get nozzle
    except
      NozzleA := MaxInt; // if invalid then place at end
    end;
    if NozzleA = 0 then
      NozzleA := MaxInt; // if invalid then place at end

    try
      NozzleB := FeederList[Pred(B.Feeder)].Nozzle;
    except
      NozzleB := MaxInt; // if invalid then place at end
    end;
    if NozzleB = 0 then
      NozzleB := MaxInt; // if invalid then place at end

    // ******************************************************************************
    // priority = nozzle, feeder, designator, comment

    Result := (NozzleA > NozzleB) or ((NozzleA = NozzleB) and (FeederA > FeederB)) or
      ((NozzleA = NozzleB) and (FeederA = FeederB) and (A.Designator > B.Designator)) or
      ((NozzleA = NozzleB) and (FeederA = FeederB) and (A.Designator = B.Designator) and (A.Comment > B.Comment));
  end; // sorted by nozzle and then by feeder

  Procedure SwapPartRec(Var A, B: PartRec);
  Var
    C: PartRec;
  Begin
    C := A;
    A := B;
    B := C;
  end;

  Procedure QuickSortParts(Var Vector: Array Of PartRec);
  var
    First, Last: Integer;

    Procedure Partition(Var Vector: Array Of PartRec; First, Last: Integer);
    var
      Right, Left: Integer;
      V: PartRec;
    begin
      V := Vector[(First + Last) shr 1];
      Right := First;
      Left := Last;
      repeat
        while PartRecCompare(V, Vector[Right]) do
          inc(Right);

        while PartRecCompare(Vector[Left], V) do
          Dec(Left);

        if (Right <= Left) then
        begin
          SwapPartRec(Vector[Right], Vector[Left]);
          inc(Right);
          Dec(Left);
        end;
      until Right > Left;

      if (First < Left) then
        Partition(Vector, First, Left);
      if (Right < Last) then
        Partition(Vector, Right, Last);
    end;

  begin
    First := 0;
    Last := Pred(PartCount);
    if First < Last then
      Partition(Vector, First, Last)
  end;

begin
  if PartCount > 1 then
  begin
    QuickSortParts(PartList); // sort by nozzle, and feeder
    ProjectEdited := true;
    CurrentPart := 1; // reset part index due to reshuffle caused by sort

    UpdatePartList;
    UpdateStatus;
    UpdateButtons;
  end;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonStartBoardClick(Sender: TObject);
var
  Result: Integer;
  Run: Boolean;
begin
  Run := false;

  if (CurrentPart > 1) then
  begin
    Speak('Select Part to Start With');
    Result := MessageDlg('The Current Part is NOT part 1' + #$0d + 'Select Part to Start With.', mtConfirmation, [mbYes, mbNo, mbCancel], 0, mbNo,
      ['PART 1', 'CURRENT PART', 'CANCEL']);
    if Result = mrYes then
    begin
      CurrentPart := 1; // reset to beginning
      UpdatePartList;
      Run := true; // normal start
    end
    else if Result = mrNo then
      Run := true; // current part start
  end
  else
    Run := true; // normal start

  if Run then
  begin
    PartPicked := false;
    AutomaticBoard := true; // set automatic board cycle
    AutomaticPanel := false;
    Pause := false;
    UpdateStatus;
    UpdateButtons;
    AutomaticCycle;
    MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, 0, 0, CNCMaxStepsPerSecond);
  end;

  UpdateStatus;
  UpdateButtons;
  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonStartPanelClick(Sender: TObject);
var
  Result: Integer;
  Run: Boolean;
begin
  Run := false;

  PartPicked := false;
  AutomaticPanel := true; // set automatic panel cycle
  AutomaticBoard := false;
  Pause := false;
  UpdateStatus;
  UpdateButtons;

  if CurrentPart > 1 then
  begin
    Speak('Select Part to Start With');
    Result := MessageDlg('The Current Part is NOT part 1' + #$0d + 'Select Part to Start With.', mtConfirmation, [mbYes, mbNo, mbCancel], 0, mbNo,
      ['PART 1', 'CURRENT PART', 'CANCEL']);
    if Result = mrYes then
    begin
      CurrentPart := 1; // reset to beginning
      UpdatePartList;
      Run := true; // normal start
    end
    else if Result = mrNo then
      Run := true; // current part start
  end
  else
    Run := true; // normal start

  if Run then
  begin
    AutomaticCycle;
    MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, 0, 0, CNCMaxStepsPerSecond);
  end;

  UpdateStatus;
  UpdateButtons;
  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonStopClick(Sender: TObject);
begin
  AutomaticPanel := false; // reset automatic panel cycle
  AutomaticBoard := false; // reset automatic board cycle
  Pause := false; // reset pause of automatic cycle

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonPickPartClick(Sender: TObject);
begin
  if (CurrentPart > 0) and (CurrentPart <= PartCount) then // if valid part
  begin // pick and go to camera at required angle
    FiducialX := 0; // reset fiducial as possibly not yet checked
    FiducialY := 0;

    if PickPart(PartList[Pred(CurrentPart)].Feeder, PartList[Pred(CurrentPart)].Angle) then
    begin
      // part was picked
    end
    else
    begin
      Speak('FAILED TO PICK PART');
      MessageDlg('FAILED TO PICK PART!', mtInformation, [mbCancel], 0, mbCancel);
    end;
  end;

  UpdateStatus;
  UpdateButtons;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonEmergencyStopClick(Sender: TObject);
begin
  CNCEmergencyStop := true;

  AutomaticPanel := false;
  AutomaticBoard := false;
  Pause := false;
  PartPicked := false;

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonDeletePartClick(Sender: TObject);
var
  X: Integer;
begin
  if (MessageDlg('ARE YOU SURE YOU WANT TO DELETE THIS PART?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    if PartCount > 0 then
    begin
      if PartCount > CurrentPart then
      begin
        for X := CurrentPart to PartCount - 1 do // shift records down
          PartList[Pred(X)] := PartList[X];
      end;
      Dec(PartCount); // remove part
      if CurrentPart > PartCount then
        CurrentPart := PartCount; // keep current part valid

      SetLength(PartList, PartCount); // resize array

      ProjectEdited := true;
    end;

    UpdatePartList;
    UpdateStatus;
    UpdateButtons;
  end;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := JOG_SMALL_STEP;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := JOG_SMALL_STEP;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonNextBoardClick(Sender: TObject);
begin
  inc(PanelBoardCount); // advance board count
  if PanelBoardCount > PanelCountX * PanelCountY then
    PanelBoardCount := 1; // wrap around

  CurrentPart := 1; // reset part selection
  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonPanelSettingsClick(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormPanelSettings.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonParkNozzleClick(Sender: TObject);
begin
  FormNozzleChanger.ParkNozzle;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonPauseClick(Sender: TObject);
begin
  Pause := true;
  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.TestFiducials: Boolean;
var
  B: TBitmap;
  X1, Y1, X2, Y2, Correlation, MMX, MMY, MMActX, MMActY: double;
  Status: Boolean;
begin
  Status := false; // assume failure

  FiducialX := 0; // assume all ok
  FiducialY := 0;
  FiducialXScale := 1;
  FiducialYScale := 1;
  FiducialAngle := 0; // not used at present

  ViewSelection := 0; // downlooking camera
  FormMain.UpdateVideoGridRulers;
  FormMain.UpdateButtons;

  if BoardFiducialEnable then // if fiducial check is enabled
  begin
    B := TBitmap.Create; // prepare visual reference
    Try
      B.LoadFromFile(ProjectPath + BoardFiducial1SnapName + '.bmp');
    Except
    End;
    ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
    B.Free;

    // ******************************************************************************

    if MoveBoardRelativeWithNozzleProtection(BoardFiducial1X, BoardFiducial1Y, BoardFiducial1Z, 0, CNCMaxStepsPerSecond) then
    begin
      Delay(DownlookingCameraSettlingDelay); // small delay

      if CaptureDownlooking then
      begin
        VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
        // correlate image
        Correlation := VisionCorrelation; // get results
        X1 := VisionCentreX; // error im mm
        Y1 := VisionCentreY;

        if (Correlation > 0) then // if image found
        begin
          if BoardDualFiducial then // if dual fiducial
          begin
            B := TBitmap.Create; // prepare visual reference
            Try
              B.LoadFromFile(ProjectPath + BoardFiducial2SnapName + '.bmp');
            Except
            End;
            FreeImage(ImageReference);
            ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
            B.Free;

            // ******************************************************************************

            if MoveBoardRelativeWithNozzleProtection(BoardFiducial2X, BoardFiducial2Y, BoardFiducial2Z, 0, CNCMaxStepsPerSecond) then
            begin
              Delay(DownlookingCameraSettlingDelay); // small delay

              if CaptureDownlooking then
              begin
                VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
                // correlate image
                Correlation := VisionCorrelation; // get results

                X2 := FormMain.VisionCentreX; // error im mm
                Y2 := FormMain.VisionCentreY;

                if (Correlation > 0) then // if image found
                begin
                  MMX := BoardFiducial2X - BoardFiducial1X;
                  // fiducial difference values
                  MMY := BoardFiducial2Y - BoardFiducial1Y;

                  MMActX := X2 - X1; // calc error
                  MMActY := Y2 - Y1;

                  if abs(MMX) > 25 then // if fiducial differential > 25mm
                  begin
                    FiducialXScale := MMActX / MMX;
                    FiducialX := X1 * FiducialXScale;
                    // use scaled first as reference
                  end
                  else
                  begin
                    FiducialX := X1; // use first as reference
                    FiducialXScale := 1; // no scaling
                  end;

                  if abs(MMY) > 25 then // if fiducial differential > 25mm
                  begin
                    FiducialYScale := MMActY / MMY;
                    FiducialY := Y1 * FiducialYScale;
                    // use scaled first as reference
                  end
                  else
                  begin
                    FiducialY := Y1; // use first as reference
                    FiducialYScale := 1; // no scaling
                  end;

                  FiducialAngle := 0; // calc angular offset

                  Status := true; // success
                end;
              end;
            end;
          end
          else // else single fiducial
          begin
            FiducialX := X1; // simple offset
            FiducialY := Y1;
            Status := true; // success
          end;
        end;
      end;
    end;

    Result := Status;

    FreeImage(ImageReference);
  end
  else // if fiducial chack is disabled then
    Result := true; // report success

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.AutomaticCycle;
var
  Retry: Integer;
  Status: Boolean;
begin
  PartPicked := false;
  UpdateStatus;
  UpdateButtons;

  // ******************************************************************************
  Status := TestFiducials; // fiducial check

  if not Status then
  begin
    Speak('Fiducial Check Failure');
    Status := (MessageDlg('FIDUCIAL FAILURE. DO YOU WANT TO CONTINUE ANYWAY?', mtConfirmation, [mbYes, mbCancel], 0, mbCancel) = mrYes);
    FiducialX := 0; // assume all ok - NO OFFSET
    FiducialY := 0;
  end;

  // ******************************************************************************
  if Status then // if OK then do it
  begin
    repeat
    begin
      Retry := PickRetryCount; // set retry count
      repeat
        if Pause then
        begin
          repeat
            UpdateStatus;
            UpdateButtons;
            Application.ProcessMessages;
          until (not Pause) or (not(AutomaticPanel or AutomaticBoard)) or CNCEmergencyStop;
          Pause := false;
          UpdateStatus;
          UpdateButtons;
          Application.ProcessMessages;
        end;

        if (AutomaticPanel or AutomaticBoard) and ((not Pause) or CNCEmergencyStop) then
        begin
          Status := PickAndPlace; // try part placement
          if not Status then
          begin
            if PartPicked then
              DiscardPart(PartList[Pred(CurrentPart)].Feeder); // discard if picked
            Dec(Retry); // decrement retry count
          end;
        end
        else
          Status := false;

      until Status or (Retry <= 0) or (not(AutomaticPanel or AutomaticBoard)) or CNCEmergencyStop;

      if (AutomaticPanel or AutomaticBoard) and not(Status or CNCEmergencyStop) then // if failed to place part
      begin
        if (Retry <= 0) then // if failed on retry limit
        begin
          Speak('Retry Limit Reached Failed to Place Part');
          MessageDlg('Retry Limit Reached.' + #$0d + 'Failed to Place Part', mtInformation, [mbCancel], 0, mbCancel);
        end
        else // other cause of failure
        begin
          Speak('Failed to Place Part');
          MessageDlg('Failed to Place Part.', mtInformation, [mbCancel], 0, mbCancel);
        end;
        AutomaticPanel := false; // reset automatic panel cycle
        AutomaticBoard := false; // reset automatic board cycle
      end;
    end
    until (not(AutomaticPanel or AutomaticBoard)) or CNCEmergencyStop;
    // repeat until finished or aborted
    if (Retry > 0) and not CNCEmergencyStop then
      Speak('Automatic Placement Cycle Finished');
  end;

  // ******************************************************************************

  AutomaticPanel := false; // reset automatic panel cycle
  AutomaticBoard := false; // reset automatic board cycle
  Pause := false;

  UpdateStatus;
  UpdateButtons;
  ListBoxPartList.SetFocus;
end;

procedure TFormMain.PaintBoxImageDownClick(Sender: TObject);
begin
  if CaptureDownlooking then
    FormCreateSnap.CreateProjectSnap(ImageDownlooking);
end;

procedure TFormMain.PaintBoxImageUpClick(Sender: TObject);
begin
  if CaptureUplooking then
    FormCreateSnap.CreateProjectSnap(ImageUplooking);
end;

procedure TFormMain.PaintBoxVideoDownClick(Sender: TObject);
begin
  if CaptureDownlooking then
    FormCreateSnap.CreateProjectSnap(ImageDownlooking);
end;

procedure TFormMain.PaintBoxVideoUpClick(Sender: TObject);
begin
  if CaptureUplooking then
    FormCreateSnap.CreateProjectSnap(ImageUplooking);
end;

function TFormMain.PickAndPlace: Boolean;
var
  Status: Boolean;
begin
  Status := false;
  if (CurrentPart > 0) and (CurrentPart <= PartCount) then // if valid part
  begin // pick if required and go to camera at required angle
    if not PartList[Pred(CurrentPart)].Enabled then // if part to be skipped
    begin
      inc(CurrentPart); // select next part
      if CurrentPart > PartCount then
      begin
        CurrentPart := 1; // wrap around at end of list
        AutomaticBoard := false; // reset automatic board cycle

        inc(PanelBoardCount); // advance board count
        if PanelBoardCount > PanelCountX * PanelCountY then
        begin
          PanelBoardCount := 1; // wrap around
          AutomaticPanel := false; // reset automatic panel cycle
        end;
      end;
      UpdatePartList;
      Status := true; // prevent error flag for disabled parts
    end
    else if PartPicked or PickPart(PartList[Pred(CurrentPart)].Feeder, PartList[Pred(CurrentPart)].Angle) then
    begin // place part on board
      Status := false; // assume failure
      if PlacePart(CurrentPart) then
      begin
        inc(CurrentPart); // select next part
        if CurrentPart > PartCount then
        begin
          CurrentPart := 1; // wrap around at end of list
          AutomaticBoard := false; // reset automatic board cycle

          inc(PanelBoardCount); // advance board count
          if PanelBoardCount > PanelCountX * PanelCountY then
          begin
            PanelBoardCount := 1; // wrap around
            AutomaticPanel := false; // reset automatic panel cycle
          end;
        end;
        Status := true; // success!!
        UpdatePartList;
      end;
    end;
  end;

  UpdateStatus;
  UpdateButtons;
  ListBoxPartList.SetFocus;
  Result := Status;
end;

procedure TFormMain.ButtonPlacePartClick(Sender: TObject);
var
  Status: Boolean;
begin
  if (CurrentPart > 0) and (CurrentPart <= PartCount) then // if valid part
  begin // pick if required and go to camera at required angle

    // ******************************************************************************
    Status := TestFiducials; // fiducial check

    if not Status then
    begin
      Speak('Fiducial Check Failure');
      Status := (MessageDlg('FIDUCIAL FAILURE. DO YOU WANT TO CONTINUE ANYWAY?', mtConfirmation, [mbYes, mbCancel], 0, mbCancel) = mrYes);
      FiducialX := 0; // assume all ok - NO OFFSET
      FiducialY := 0;
    end;

    // ******************************************************************************
    if Status then // if ok
    begin
      if not PartList[Pred(CurrentPart)].Enabled then // if part to be skipped
      begin
        inc(CurrentPart); // select next part
        if CurrentPart > PartCount then
        begin
          CurrentPart := 1; // wrap around at end of list
          AutomaticBoard := false; // reset automatic board cycle

          inc(PanelBoardCount); // advance board count
          if PanelBoardCount > PanelCountX * PanelCountY then
          begin
            PanelBoardCount := 1; // wrap around
            AutomaticPanel := false; // reset automatic panel cycle
          end;
        end;

        UpdatePartList;
      end
      else if PartPicked or PickPart(PartList[Pred(CurrentPart)].Feeder, PartList[Pred(CurrentPart)].Angle) then
      begin // place part on board
        if PlacePart(CurrentPart) then
        begin
          MoveBoardRelativeWithNozzleProtection(PartList[Pred(CurrentPart)].X, PartList[Pred(CurrentPart)].Y, 0, 0, CNCMaxStepsPerSecond);
          // goto part to inspect

          inc(CurrentPart); // select next part
          if CurrentPart > PartCount then
          begin
            CurrentPart := 1; // wrap around at end of list
            AutomaticBoard := false; // reset automatic board cycle

            inc(PanelBoardCount); // advance board count
            if PanelBoardCount > PanelCountX * PanelCountY then
            begin
              PanelBoardCount := 1; // wrap around
              AutomaticPanel := false; // reset automatic panel cycle
            end;
          end;

          UpdatePartList;
        end
        else
        begin
          Speak('FAILED TO PICK PART');
          MessageDlg('FAILED TO PICK PART!', mtInformation, [mbCancel], 0, mbCancel);
        end;
      end
      else
      begin
        Speak('FAILED TO PICK PART');
        MessageDlg('FAILED TO PICK PART!', mtInformation, [mbCancel], 0, mbCancel);
      end;
    end;
  end;
  UpdateStatus;
  UpdateButtons;
  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonJogAMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1 / CNCAStepsPerRev * 360;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1 / CNCAStepsPerRev * 360;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -JOG_SMALL_STEP;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonAddPartClick(Sender: TObject);
begin
  inc(PartCount); // add part to list
  SetLength(PartList, PartCount);
  CheckBoxPartEnabled.Checked := true; // default to enabled
  CurrentPart := PartCount;

  PartList[Pred(CurrentPart)].Designator := '';
  PartList[Pred(CurrentPart)].Comment := '';
  PartList[Pred(CurrentPart)].X := CNCXPos - CNCActualHomeX - BoardOriginX;
  PartList[Pred(CurrentPart)].Y := CNCYPos - CNCActualHomeY - BoardOriginY;
  PartList[Pred(CurrentPart)].Angle := 0;
  PartList[Pred(CurrentPart)].Feeder := 0;
  PartList[Pred(CurrentPart)].Enabled := true;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonAMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonAMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonAPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 10;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonAPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.PanelCameraDownClick(Sender: TObject);
begin
  if CaptureDownlooking then
    FormCreateSnap.CreateProjectSnap(ImageDownlooking);
end;

procedure TFormMain.PanelCameraUpClick(Sender: TObject);
begin
  if CaptureUplooking then
    FormCreateSnap.CreateProjectSnap(ImageUplooking);
end;

procedure TFormMain.VisionSettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormVisionSettings.ShowModal; // show camera settings form
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.Close1Click(Sender: TObject);
begin
  if ProjectOpen and ProjectEdited and (MessageDlg('Save Changes To Current Project?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
  begin
    if ProjectName = '' then // prompt for filename
    begin
      if SaveProject then
        ProjectOpen := false; // reset flag
    end
    else if Save_Project(ProjectPath, ProjectName) then // use current filename
      ProjectOpen := false; // reset flag
  end
  else
    ProjectOpen := false;

  if not ProjectOpen then
  begin
    PartCount := 0;
    CurrentPart := 0; // no part selected
    SetLength(PartList, PartCount); // clear parts list
    LastProjectPath := ''; // no project
    LastProjectName := '';
  end;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.CNCSettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormCNCSettings.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.EditBoardHeightKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keystrokes
end;

procedure TFormMain.EditBoardOriginXKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keystrokes
end;

procedure TFormMain.EditBoardOriginYKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keystrokes
end;

procedure TFormMain.EditCurrentPanelCountKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keystrokes
end;

procedure TFormMain.EditBoardOffsetZKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keystrokes
end;

procedure TFormMain.EditPartAngleChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      V := StrToFloat(EditPartAngle.Text);

      if (V > -360) and (V < 360) then
      begin
        EditPartAngle.Color := clWindow;
        PartList[Pred(CurrentPart)].Angle := V; // update changes
        ProjectEdited := true;
      end
      else
        EditPartAngle.Color := clRed;
    except
      EditPartAngle.Color := clRed;
    end;
  end;
end;

procedure TFormMain.EditPartCommentChange(Sender: TObject);
begin
  if Enabled then
  begin
    PartList[Pred(CurrentPart)].Comment := EditPartComment.Text;
    // update changes
    ProjectEdited := true;
  end;
end;

procedure TFormMain.EditPartDesignatorChange(Sender: TObject);
begin
  if Enabled then
  begin
    PartList[Pred(CurrentPart)].Designator := EditPartDesignator.Text;
    // update changes
    ProjectEdited := true;
  end;
end;

procedure TFormMain.EditPartPositionXChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditPartPositionX.Text)
      else
        V := StrToFloat(EditPartPositionX.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeX + BoardOriginX >= CNCMinX) and (V + CNCActualHomeX + BoardOriginX <= CNCMaxX) then
      begin
        PartList[Pred(CurrentPart)].X := V; // update changes
        EditPartPositionX.Color := clWindow;
        ProjectEdited := true;
      end
      else
        EditPartPositionX.Color := clRed;
    except
      EditPartPositionX.Color := clRed;
    end;
  end;
end;

procedure TFormMain.EditPartPositionYChange(Sender: TObject);
Var
  V: double;
begin
  if Enabled then
  begin
    try
      if BoardMetric then
        V := StrToFloat(EditPartPositionY.Text)
      else
        V := StrToFloat(EditPartPositionY.Text) * 25.4; // convert to metric

      if (V + CNCActualHomeY + BoardOriginY >= CNCMinY) and (V + CNCActualHomeY + BoardOriginY <= CNCMaxY) then
      begin
        PartList[Pred(CurrentPart)].Y := V; // update changes
        EditPartPositionY.Color := clWindow;
        ProjectEdited := true;
      end
      else
        EditPartPositionY.Color := clRed;
    except
      EditPartPositionY.Color := clRed;
    end;
  end;
end;

procedure TFormMain.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.ButtonDiscardClick(Sender: TObject);
begin
  if (CurrentPart > 0) and (CurrentPart <= PartCount) then // if valid part
    DiscardPart(PartList[Pred(CurrentPart)].Feeder); // discart part to tray

  UpdateStatus;
  UpdateButtons;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonFeedersClick(Sender: TObject);
begin
  if (CurrentPart > 0) then
    CurrentFeeder := PartList[Pred(CurrentPart)].Feeder
    // select feeder for current part
  else
    CurrentFeeder := 0; // no selection

  GroupBoxJogControl.Visible := false;
  FormFeeders.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdatePartList;
  UpdateButtons;
  UpdateStatus;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonFiducialsClick(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormFiducialSettings.ShowModal;
  GroupBoxJogControl.Visible := true;
  UpdateButtons;
  UpdateStatus;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonParkClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  UpdateStatus;
  UpdateButtons;

  MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond);

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonGotoCameraClick(Sender: TObject);
begin
  ViewSelection := 1; // uplooking camera
  UpdateStatus;
  UpdateButtons;

  MoveHomeRelativeWithNozzleProtection(UplookingCameraX, UplookingCameraY, UplookingCameraZ, 0, CNCMaxStepsPerSecond);

  FormMain.UpdateStatus;
  FormMain.UpdateButtons;
  UpdateButtons;
end;

procedure TFormMain.ButtonGotoNextPartClick(Sender: TObject);
begin
  inc(CurrentPart);
  if CurrentPart > PartCount then
    CurrentPart := 1; // select next part
  UpdatePartList;

  ViewSelection := 0; // downlooking camera
  UpdateStatus;
  UpdateButtons;

  MoveBoardRelativeWithNozzleProtection(PartList[Pred(CurrentPart)].X + FiducialX, PartList[Pred(CurrentPart)].Y + FiducialY, 0, 0, CNCMaxStepsPerSecond);

  UpdateStatus;
  UpdateButtons;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonGotoBoardClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  UpdateStatus;
  UpdateButtons;

  MoveHomeRelativeWithNozzleProtection(BoardOriginX, BoardOriginY, 0, 0, CNCMaxStepsPerSecond);

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonGotoPartClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  UpdateStatus;
  UpdateButtons;

  MoveBoardRelativeWithNozzleProtection(PartList[Pred(CurrentPart)].X + FiducialX, PartList[Pred(CurrentPart)].Y + FiducialY, 0, 0, CNCMaxStepsPerSecond);

  UpdateStatus;
  UpdateButtons;

  ListBoxPartList.SetFocus;
end;

procedure TFormMain.ButtonHomeClick(Sender: TObject);
begin
  ViewSelection := 0; // downlooking camera
  UpdateButtons;
  Home;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SystemStarted := false;

  SetOutputFeeder(false); // turn off all hardware
  SetOutputVacuum(false);
  SetOutputBlow(false);
  SetOutputDispenser(false);

  // ******************************************************************************

  Save_Settings; // ensure the settings are saved first

  // ******************************************************************************

  FormVisionSettings.StopCameraUp; // stop cameras
  FormVisionSettings.StopCameraDown;

  // ******************************************************************************

  if Assigned(VideoBitmapUp) then
    VideoBitmapUp.Free;
  if Assigned(VideoBitmapDown) then
    VideoBitmapDown.Free;

  // ******************************************************************************
  if CNCControllerFound and CNCInitialised then // stop controller motion before closing
  begin
    DeskWinAPICommand.CommandType := ENDMOVE; // terminate movement
    SendAPICommandToController(DeskWinAPICommand);
  end;

  DeskWinClose; // CNC control is now terminated
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  Result: Integer;
begin
  if ProjectOpen and ProjectEdited then
  begin
    Result := MessageDlg('Save Changes to PROJECT?', mtConfirmation, [mbYes, mbNo, mbCancel], 0, mbNo, ['YES', 'NO', 'CANCEL']);

    if Result = mrCancel then
      CanClose := false
    else if Result = mrYes then
    begin
      if Save_Project(ProjectPath, ProjectName) then // use current filename
        ProjectOpen := false; // reset flag
    end
    else
      ProjectOpen := false;  // discard and allow close
  end
  else
    ProjectOpen := false;

  if not ProjectOpen then
  begin
    PartCount := 0;
    CurrentPart := 0; // no part selected
    SetLength(PartList, PartCount); // clear parts list
  end;

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;

  CanClose := not ProjectOpen; // only allow close if project saved or abandoned
end;

procedure TFormMain.FormCreate(Sender: TObject);
  Function MakeLCID(lgID: Word; srtid: Word): DWORD;
  Begin
    Result := MakeLong(lgID, srtid);
  End;

  Function MakeLangID(p, S: Word): Word;
  Begin
    Result := (S shl 10) or p
  End;

begin
  Win32Check(SetThreadLocale(MakeLCID(MakeLangID(LANG_ENGLISH, SUBLANG_ENGLISH_US), 0))); // attempt to address '.' decimal separator issue
  GetFormatSettings;
  Application.UpdateFormatSettings := false;

  SystemStarted := false;

  if (Win32MajorVersion >= 6) then // if windows 8 or higher
  begin
    TMetroDisplayRotation.SetDisplayAutoRotationPreferences(TMetroDisplayRotation.ORIENTATION_PREFERENCE_LANDSCAPE or
      TMetroDisplayRotation.ORIENTATION_PREFERENCE_LANDSCAPE_FLIPPED);
  end;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  try
    CameraDeviceList.Free;
  except
  end;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  if SystemStarted then
    UpdateVideoGridRulers;

  FormVisionSettings.UpdateVideoPositionUp;
  FormVisionSettings.UpdateVideoPositionDown;
end;

procedure TFormMain.UpdateVideoGridRulers;
const
  GridSpacing = 1;
  GridLineLength = 3;
  MajorGridLineLength = 5;
var
  PixelSize: double;
  GridSize, MajorGridSize, Width, Height: Integer;
begin
  PanelLiveVideo.Visible := false; // hide panel for faster processing

  if ViewSelection = 0 then
  begin // show crosshairs centred on downlooking video image
    PanelVideoCrossHairX.Left := PanelCameraDown.Left;
    PanelVideoCrossHairX.Top := PanelCameraDown.Top + (PanelCameraDown.Height div 2);
    PanelVideoCrossHairX.Width := PanelCameraDown.Width;
    PanelVideoCrossHairX.Height := 1;

    PanelVideoCrossHairY.Top := PanelCameraDown.Top;
    PanelVideoCrossHairY.Left := PanelCameraDown.Left + (PanelCameraDown.Width div 2);
    PanelVideoCrossHairY.Height := PanelCameraDown.Height;
    PanelVideoCrossHairY.Width := 1;

    // ******************************************************************************
    // aspect ratio check

    Width := PanelCameraDown.Width;
    Height := PanelCameraDown.Height;
  end
  else
  begin // show crosshairs centred on uplooking video image
    PanelVideoCrossHairX.Left := PanelCameraUp.Left;
    PanelVideoCrossHairX.Top := PanelCameraUp.Top + (PanelCameraUp.Height div 2);
    PanelVideoCrossHairX.Width := PanelCameraUp.Width;
    PanelVideoCrossHairX.Height := 1;

    PanelVideoCrossHairY.Top := PanelCameraUp.Top;
    PanelVideoCrossHairY.Left := PanelCameraUp.Left + (PanelCameraUp.Width div 2);
    PanelVideoCrossHairY.Height := PanelCameraUp.Height;
    PanelVideoCrossHairY.Width := 1;

    // ******************************************************************************
    // aspect ratio check

    Width := PanelCameraUp.Width;
    Height := PanelCameraUp.Height;
  end;

  if Width > (Height * 4) div 3 then
    Width := (Height * 4) div 3;

  // ******************************************************************************

  try // set pixel size in mm
    if ViewSelection = 0 then
      PixelSize := DownlookingViewWidthInMM / Width
    else
      PixelSize := UplookingViewWidthInMM / Width;
  except
    PixelSize := 0.0625; // default
  end;

  GridSize := Round(GridLineLength / PixelSize);
  MajorGridSize := Round(MajorGridLineLength / PixelSize);

  // ******************************************************************************
  PanelVideoCrossHairXSmall.Top := PanelVideoCrossHairX.Top - (GridSize div 5);
  PanelVideoCrossHairXSmall.Height := 2 * (GridSize div 5);
  PanelVideoCrossHairXSmall.Left := PanelVideoCrossHairY.Left - 2;
  PanelVideoCrossHairXSmall.Width := 5;

  PanelV1.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV1.Height := 2 * GridSize;
  PanelV1.Left := PanelVideoCrossHairY.Left - Round(GridSpacing / PixelSize);
  PanelV1.Width := 1;

  PanelV2.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV2.Height := 2 * GridSize;
  PanelV2.Left := PanelVideoCrossHairY.Left - Round(2 * GridSpacing / PixelSize);
  PanelV2.Width := 1;

  PanelV3.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV3.Height := 2 * GridSize;
  PanelV3.Left := PanelVideoCrossHairY.Left - Round(3 * GridSpacing / PixelSize);
  PanelV3.Width := 1;

  PanelV4.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV4.Height := 2 * GridSize;
  PanelV4.Left := PanelVideoCrossHairY.Left - Round(4 * GridSpacing / PixelSize);
  PanelV4.Width := 1;

  PanelV5.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV5.Height := 2 * MajorGridSize;
  PanelV5.Left := PanelVideoCrossHairY.Left - Round(5 * GridSpacing / PixelSize);
  PanelV5.Width := 1;

  PanelV6.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV6.Height := 2 * GridSize;
  PanelV6.Left := PanelVideoCrossHairY.Left - Round(6 * GridSpacing / PixelSize);
  PanelV6.Width := 1;

  PanelV7.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV7.Height := 2 * GridSize;
  PanelV7.Left := PanelVideoCrossHairY.Left - Round(7 * GridSpacing / PixelSize);
  PanelV7.Width := 1;

  PanelV8.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV8.Height := 2 * GridSize;
  PanelV8.Left := PanelVideoCrossHairY.Left - Round(8 * GridSpacing / PixelSize);
  PanelV8.Width := 1;

  PanelV9.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV9.Height := 2 * GridSize;
  PanelV9.Left := PanelVideoCrossHairY.Left - Round(9 * GridSpacing / PixelSize);
  PanelV9.Width := 1;

  PanelV10.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV10.Height := 2 * MajorGridSize;
  PanelV10.Left := PanelVideoCrossHairY.Left - Round(10 * GridSpacing / PixelSize);
  PanelV10.Width := 1;

  PanelV11.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV11.Height := 2 * GridSize;
  PanelV11.Left := PanelVideoCrossHairY.Left - Round(11 * GridSpacing / PixelSize);
  PanelV11.Width := 1;

  PanelV12.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV12.Height := 2 * GridSize;
  PanelV12.Left := PanelVideoCrossHairY.Left - Round(12 * GridSpacing / PixelSize);
  PanelV12.Width := 1;

  PanelV13.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV13.Height := 2 * GridSize;
  PanelV13.Left := PanelVideoCrossHairY.Left - Round(13 * GridSpacing / PixelSize);
  PanelV13.Width := 1;

  PanelV14.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV14.Height := 2 * GridSize;
  PanelV14.Left := PanelVideoCrossHairY.Left - Round(14 * GridSpacing / PixelSize);
  PanelV14.Width := 1;

  PanelV15.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV15.Height := 2 * MajorGridSize;
  PanelV15.Left := PanelVideoCrossHairY.Left - Round(15 * GridSpacing / PixelSize);
  PanelV15.Width := 1;

  // ******************************************************************************

  PanelV16.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV16.Height := 2 * GridSize;
  PanelV16.Left := PanelVideoCrossHairY.Left + Round(GridSpacing / PixelSize);
  PanelV16.Width := 1;

  PanelV17.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV17.Height := 2 * GridSize;
  PanelV17.Left := PanelVideoCrossHairY.Left + Round(2 * GridSpacing / PixelSize);
  PanelV17.Width := 1;

  PanelV18.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV18.Height := 2 * GridSize;
  PanelV18.Left := PanelVideoCrossHairY.Left + Round(3 * GridSpacing / PixelSize);
  PanelV18.Width := 1;

  PanelV19.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV19.Height := 2 * GridSize;
  PanelV19.Left := PanelVideoCrossHairY.Left + Round(4 * GridSpacing / PixelSize);
  PanelV19.Width := 1;

  PanelV20.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV20.Height := 2 * MajorGridSize;
  PanelV20.Left := PanelVideoCrossHairY.Left + Round(5 * GridSpacing / PixelSize);
  PanelV20.Width := 1;

  PanelV21.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV21.Height := 2 * GridSize;
  PanelV21.Left := PanelVideoCrossHairY.Left + Round(6 * GridSpacing / PixelSize);
  PanelV21.Width := 1;

  PanelV22.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV22.Height := 2 * GridSize;
  PanelV22.Left := PanelVideoCrossHairY.Left + Round(7 * GridSpacing / PixelSize);
  PanelV22.Width := 1;

  PanelV23.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV23.Height := 2 * GridSize;
  PanelV23.Left := PanelVideoCrossHairY.Left + Round(8 * GridSpacing / PixelSize);
  PanelV23.Width := 1;

  PanelV24.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV24.Height := 2 * GridSize;
  PanelV24.Left := PanelVideoCrossHairY.Left + Round(9 * GridSpacing / PixelSize);
  PanelV24.Width := 1;

  PanelV25.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV25.Height := 2 * MajorGridSize;
  PanelV25.Left := PanelVideoCrossHairY.Left + Round(10 * GridSpacing / PixelSize);
  PanelV25.Width := 1;

  PanelV26.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV26.Height := 2 * GridSize;
  PanelV26.Left := PanelVideoCrossHairY.Left + Round(11 * GridSpacing / PixelSize);
  PanelV26.Width := 1;

  PanelV27.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV27.Height := 2 * GridSize;
  PanelV27.Left := PanelVideoCrossHairY.Left + Round(12 * GridSpacing / PixelSize);
  PanelV27.Width := 1;

  PanelV28.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV28.Height := 2 * GridSize;
  PanelV28.Left := PanelVideoCrossHairY.Left + Round(13 * GridSpacing / PixelSize);
  PanelV28.Width := 1;

  PanelV29.Top := PanelVideoCrossHairX.Top - GridSize;
  PanelV29.Height := 2 * GridSize;
  PanelV29.Left := PanelVideoCrossHairY.Left + Round(14 * GridSpacing / PixelSize);
  PanelV29.Width := 1;

  PanelV30.Top := PanelVideoCrossHairX.Top - MajorGridSize;
  PanelV30.Height := 2 * MajorGridSize;
  PanelV30.Left := PanelVideoCrossHairY.Left + Round(15 * GridSpacing / PixelSize);
  PanelV30.Width := 1;

  // ******************************************************************************
  PanelVideoCrossHairYSmall.Top := PanelVideoCrossHairX.Top - 2;
  PanelVideoCrossHairYSmall.Height := 5;
  PanelVideoCrossHairYSmall.Left := PanelVideoCrossHairY.Left - (GridSize div 5);
  PanelVideoCrossHairYSmall.Width := 2 * (GridSize Div 5);

  PanelH1.Top := PanelVideoCrossHairX.Top - Round(GridSpacing / PixelSize);
  PanelH1.Height := 1;
  PanelH1.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH1.Width := 2 * GridSize;

  PanelH2.Top := PanelVideoCrossHairX.Top - Round(2 * GridSpacing / PixelSize);
  PanelH2.Height := 1;
  PanelH2.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH2.Width := 2 * GridSize;

  PanelH3.Top := PanelVideoCrossHairX.Top - Round(3 * GridSpacing / PixelSize);
  PanelH3.Height := 1;
  PanelH3.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH3.Width := 2 * GridSize;

  PanelH4.Top := PanelVideoCrossHairX.Top - Round(4 * GridSpacing / PixelSize);
  PanelH4.Height := 1;
  PanelH4.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH4.Width := 2 * GridSize;

  PanelH5.Top := PanelVideoCrossHairX.Top - Round(5 * GridSpacing / PixelSize);
  PanelH5.Height := 1;
  PanelH5.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH5.Width := 2 * MajorGridSize;

  PanelH6.Top := PanelVideoCrossHairX.Top - Round(6 * GridSpacing / PixelSize);
  PanelH6.Height := 1;
  PanelH6.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH6.Width := 2 * GridSize;

  PanelH7.Top := PanelVideoCrossHairX.Top - Round(7 * GridSpacing / PixelSize);
  PanelH7.Height := 1;
  PanelH7.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH7.Width := 2 * GridSize;

  PanelH8.Top := PanelVideoCrossHairX.Top - Round(8 * GridSpacing / PixelSize);
  PanelH8.Height := 1;
  PanelH8.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH8.Width := 2 * GridSize;

  PanelH9.Top := PanelVideoCrossHairX.Top - Round(9 * GridSpacing / PixelSize);
  PanelH9.Height := 1;
  PanelH9.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH9.Width := 2 * GridSize;

  PanelH10.Top := PanelVideoCrossHairX.Top - Round(10 * GridSpacing / PixelSize);
  PanelH10.Height := 1;
  PanelH10.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH10.Width := 2 * MajorGridSize;

  PanelH11.Top := PanelVideoCrossHairX.Top - Round(11 * GridSpacing / PixelSize);
  PanelH11.Height := 1;
  PanelH11.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH11.Width := 2 * GridSize;

  PanelH12.Top := PanelVideoCrossHairX.Top - Round(12 * GridSpacing / PixelSize);
  PanelH12.Height := 1;
  PanelH12.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH12.Width := 2 * GridSize;

  PanelH13.Top := PanelVideoCrossHairX.Top - Round(13 * GridSpacing / PixelSize);
  PanelH13.Height := 1;
  PanelH13.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH13.Width := 2 * GridSize;

  PanelH14.Top := PanelVideoCrossHairX.Top - Round(14 * GridSpacing / PixelSize);
  PanelH14.Height := 1;
  PanelH14.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH14.Width := 2 * GridSize;

  PanelH15.Top := PanelVideoCrossHairX.Top - Round(15 * GridSpacing / PixelSize);
  PanelH15.Height := 1;
  PanelH15.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH15.Width := 2 * MajorGridSize;

  // ******************************************************************************

  PanelH16.Top := PanelVideoCrossHairX.Top + Round(GridSpacing / PixelSize);
  PanelH16.Height := 1;
  PanelH16.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH16.Width := 2 * GridSize;

  PanelH17.Top := PanelVideoCrossHairX.Top + Round(2 * GridSpacing / PixelSize);
  PanelH17.Height := 1;
  PanelH17.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH17.Width := 2 * GridSize;

  PanelH18.Top := PanelVideoCrossHairX.Top + Round(3 * GridSpacing / PixelSize);
  PanelH18.Height := 1;
  PanelH18.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH18.Width := 2 * GridSize;

  PanelH19.Top := PanelVideoCrossHairX.Top + Round(4 * GridSpacing / PixelSize);
  PanelH19.Height := 1;
  PanelH19.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH19.Width := 2 * GridSize;

  PanelH20.Top := PanelVideoCrossHairX.Top + Round(5 * GridSpacing / PixelSize);
  PanelH20.Height := 1;
  PanelH20.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH20.Width := 2 * MajorGridSize;

  PanelH21.Top := PanelVideoCrossHairX.Top + Round(6 * GridSpacing / PixelSize);
  PanelH21.Height := 1;
  PanelH21.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH21.Width := 2 * GridSize;

  PanelH22.Top := PanelVideoCrossHairX.Top + Round(7 * GridSpacing / PixelSize);
  PanelH22.Height := 1;
  PanelH22.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH22.Width := 2 * GridSize;

  PanelH23.Top := PanelVideoCrossHairX.Top + Round(8 * GridSpacing / PixelSize);
  PanelH23.Height := 1;
  PanelH23.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH23.Width := 2 * GridSize;

  PanelH24.Top := PanelVideoCrossHairX.Top + Round(9 * GridSpacing / PixelSize);
  PanelH24.Height := 1;
  PanelH24.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH24.Width := 2 * GridSize;

  PanelH25.Top := PanelVideoCrossHairX.Top + Round(10 * GridSpacing / PixelSize);
  PanelH25.Height := 1;
  PanelH25.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH25.Width := 2 * MajorGridSize;

  PanelH26.Top := PanelVideoCrossHairX.Top + Round(11 * GridSpacing / PixelSize);
  PanelH26.Height := 1;
  PanelH26.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH26.Width := 2 * GridSize;

  PanelH27.Top := PanelVideoCrossHairX.Top + Round(12 * GridSpacing / PixelSize);
  PanelH27.Height := 1;
  PanelH27.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH27.Width := 2 * GridSize;

  PanelH28.Top := PanelVideoCrossHairX.Top + Round(13 * GridSpacing / PixelSize);
  PanelH28.Height := 1;
  PanelH28.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH28.Width := 2 * GridSize;

  PanelH29.Top := PanelVideoCrossHairX.Top + Round(14 * GridSpacing / PixelSize);
  PanelH29.Height := 1;
  PanelH29.Left := PanelVideoCrossHairY.Left - GridSize;
  PanelH29.Width := 2 * GridSize;

  PanelH30.Top := PanelVideoCrossHairX.Top + Round(15 * GridSpacing / PixelSize);
  PanelH30.Height := 1;
  PanelH30.Left := PanelVideoCrossHairY.Left - MajorGridSize;
  PanelH30.Width := 2 * MajorGridSize;

  PanelLiveVideo.Visible := true; // show again
end;

procedure TFormMain.FormShow(Sender: TObject);
var
  NameBuf: Array [0 .. MAX_PATH] of Char;
  ResolutionList: TStringList;
begin
  ResolutionList := TStringList.Create;

  BoardOriginX := 0;
  BoardOriginY := 0;

  ProjectOpen := false;
  ProjectName := '';
  ProjectPath := '';

  // ****** get SPECIAL FOLDER path to complete data paths ******
  ShGetFolderPath(Application.Handle, CSIDL_PERSONAL, 0, 0, NameBuf);

  Data_Directory := IncludeTrailingPathDelimiter(NameBuf + Data_Directory);
  ForceDirectories(Data_Directory);
  // force directory existence to prevent errors!!

  Settings_Directory := IncludeTrailingPathDelimiter(NameBuf + Settings_Directory);
  ForceDirectories(Settings_Directory);
  // force directory existence to prevent errors!!

  Load_Settings; // fetch settings

  // ******************************************************************************

  UpCameraFrameAvailable := false;
  DownCameraFrameAvailable := false;

  PanelCameraUp.Align := alClient;
  PanelCameraDown.Align := alClient;

  VideoBitmapUp := TBitmap.Create;
  VideoBitmapDown := TBitmap.Create;

  DisplayMetric := true;

  // ******************************************************************************

  ImageDownlooking := CreateImage(800, 600);
  ImageUplooking := CreateImage(800, 600);

  // ******************************************************************************

  FormVisionSettings.UpdateVideoPositionUp;
  FormVisionSettings.UpdateVideoPositionDown;

  ViewSelection := 0; // downlooking camera
  UpdateCameraSelection;
  UpdateVideoGridRulers;

  // ******************************************************************************

  if (LastProjectPath <> '') and (LastProjectName <> '') and FileExists(LastProjectPath + LastProjectName + Project_Extension) and
    Load_Project(LastProjectPath, LastProjectName) then
  begin
    ProjectOpen := true; // valid file
  end
  else
  begin
    ProjectOpen := false; // invalid file
    ProjectPath := '';
    ProjectName := '';
    LastProjectPath := '';
    LastProjectName := '';
  end;

  // ******************************************************************************

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;

  SystemStarted := true; // set flag to allow ruler updates when form resized

  TimerStartup.Enabled := true; // set startup timer
  ResolutionList.Free;
end;

procedure TFormMain.ComboBoxFeederChange(Sender: TObject);
var
  X, N, F: Integer;
  C: string;
begin
  if Enabled then
  begin
    F := Succ(ComboBoxFeeder.ItemIndex);
    if PartList[Pred(CurrentPart)].Feeder <> F then
    begin
      PartList[Pred(CurrentPart)].Feeder := F;
      ProjectEdited := true;

      C := PartList[Pred(CurrentPart)].Comment;
      N := 0;
      for X := 1 to PartCount do
      begin
        if PartList[Pred(X)].Comment = C then
          inc(N); // get number of matching parts
      end;

      if N > 0 then
      begin
        if (MessageDlg('Update ALL Matching Parts?', mtConfirmation, [mbYes, mbNo], 0, mbYes) = mrYes) then
        begin
          for X := 1 to PartCount do
          begin
            if UpperCase(PartList[Pred(X)].Comment) = UpperCase(C) then // ignore case matching
              PartList[Pred(X)].Feeder := F; // update all matching parts to this feeder
          end;
        end;
      end;
    end;

    UpdatePartList;
    UpdateStatus;
    UpdateButtons;
  end;
end;

procedure TFormMain.ComboBoxFeederKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0; // cancel keypress
end;

function TFormMain.CorrelateHome1: Boolean;
var
  B: TBitmap;
  X, Y, Correlation: double;
begin
  Application.ProcessMessages;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(Settings_Directory + 'Home.BMP');
  Except
  End;
  ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************

  if CNCMove(CNCActualHomeX, CNCActualHomeY, 0, 0, CNCMaxStepsPerSecond div 2) then
  begin // at position but UP
    if CNCMove(CNCActualHomeX, CNCActualHomeY, CNCHomeZ + CNCHome1Z, 0, CNCMaxStepsPerSecond div 2) then
    begin // at position at correct height

      Delay(DownlookingCameraSettlingDelay); // small delay
      Application.ProcessMessages;

      if CaptureDownlooking then
      begin
        VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
        // correlate image
        Correlation := VisionCorrelation; // get results
        X := VisionCentreX; // error im mm
        Y := VisionCentreY;

        if (Correlation > 0) then // if image found
        begin
          CNCActualHomeX := CNCActualHomeX + X; // offset by error amount
          CNCActualHomeY := CNCActualHomeY + Y;
          Result := true; // success
        end
        else
        begin
          Speak('CORRELATION FAILED');
          MessageDlg('CORRELATION FAILED!', mtError, [mbCancel], 0, mbCancel);
          Result := false; // correlation failed
        end;
      end
      else
      begin
        Speak('CAMERA FAILED');
        MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
        Result := false; // failed to take picture
      end;
    end
    else
    begin
      Speak('FAILED TO MOVE TO POSITION');
      MessageDlg('FAILED TO MOVE TO POSITION!', mtError, [mbCancel], 0, mbCancel);
      Result := false; // failed to move to position
    end;
  end
  else
  begin
    Speak('FAILED TO MOVE TO POSITION');
    MessageDlg('FAILED TO MOVE TO POSITION!', mtError, [mbCancel], 0, mbCancel);
    Result := false; // failed to move to position
  end;
  FreeImage(ImageReference);
end;

function TFormMain.CorrelateHome2: Boolean;
var
  B: TBitmap;
  Y, Correlation: double;
begin
  Application.ProcessMessages;

  B := TBitmap.Create; // prepare visual reference
  Try
    B.LoadFromFile(Settings_Directory + 'Home2.BMP');
  Except
  End;
  ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
  B.Free;

  // ******************************************************************************
  if CNCMoveHomeRelativeWithNozzleProtection(CNCHome2X, CNCHome2Y, CNCHome2Z, 0, CNCMaxStepsPerSecond div 2) then
  begin // at position at correct height
    Delay(DownlookingCameraSettlingDelay); // small delay
    Application.ProcessMessages;

    if CaptureDownlooking then
    begin
      VisualCorrelation(0, DownlookingCameraEnlargementMM, false);
      // correlate image
      Correlation := VisionCorrelation; // get results
      Y := VisionCentreY; // get Y error in mm

      if (Correlation > 0) then // if image found
      begin
        SetOutputYaxis2Disable(true); // disable 2nd Y axis for adjustment
        CNCMoveHomeRelative(CNCHome2X, CNCHome2Y + Y, CNCHome2Z - CNCHomeZ, 0, CNCMaxStepsPerSecond div 2);
        SetOutputYaxis2Disable(false); // enable 2nd Y axis once adjusted

        Application.ProcessMessages;
        if CNCMoveHomeRelative(CNCHome2X, CNCHome2Y + Y, CNCHome2Z - CNCHomeZ, 0, CNCMaxStepsPerSecond div 2) then
        begin
          Result := CorrelateHome1; // redo home again once finished
        end
        else
        begin
          Speak('FAILED TO MOVE TO POSITION');
          MessageDlg('FAILED TO MOVE TO POSITION!', mtError, [mbCancel], 0, mbCancel);
          Result := false; // correlation failed
        end;
      end
      else
      begin
        Speak('CORRELATION FAILED');
        MessageDlg('CORRELATION FAILED!', mtError, [mbCancel], 0, mbCancel);
        Result := false; // correlation failed
      end;
    end
    else
    begin
      Speak('CAMERA FAILED');
      MessageDlg('CAMERA FAILED!', mtError, [mbCancel], 0, mbCancel);
      Result := false; // failed to take picture
    end;
  end
  else
  begin
    Speak('FAILED TO MOVE TO POSITION');
    MessageDlg('FAILED TO MOVE TO POSITION!', mtError, [mbCancel], 0, mbCancel);
    Result := false; // failed to move to position
  end;
  FreeImage(ImageReference);
end;

function TFormMain.AlignDualYAxis: Boolean;
begin
  Application.ProcessMessages;
  if CorrelateHome1 then
    Result := CorrelateHome2
  else
    Result := false;

  Application.ProcessMessages;
  if Result then
    Result := CNCMoveHomeRelative(0, 0, CNCHome1Z, 0, CNCMaxStepsPerSecond div 4); // move to origin

  Application.ProcessMessages;
  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.Home: Boolean;
begin
  Application.ProcessMessages;

  CNCHome;
  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;

  CNCActualHomeX := CNCHome1X; // assume default home
  CNCActualHomeY := CNCHome1Y;

  if CNCVisualHome then
  begin
    if CNCDualYAxis then
    begin
      Result := AlignDualYAxis; // align axis
    end
    else
    begin
      Result := CorrelateHome1; // find home
    end;
  end
  else
    Result := true;

  Application.ProcessMessages;
  MoveHomeRelativeWithNozzleProtection(ParkX, ParkY, CNCHome1Z - CNCHomeZ, 0, CNCMaxStepsPerSecond);

  Application.ProcessMessages;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.HomeSettings1Click(Sender: TObject);
begin
  GroupBoxJogControl.Visible := false;
  FormHomeSettings.ShowModal;
  GroupBoxJogControl.Visible := true;
  Application.ProcessMessages;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonResetClick(Sender: TObject);
begin
  AutomaticPanel := false;
  AutomaticBoard := false;
  Pause := false;
  PartPicked := false;

  ViewSelection := 0; // downlooking camera
  UpdateButtons;

  CNCEmergencyStop := false;
  UpdateStatus;
  Application.ProcessMessages;

  if Initialise then
  begin
    UpdateStatus;
    Application.ProcessMessages;
    Home;
  end
  else
  begin
    if CNCControllerFound then
    begin
      Speak('FAILED TO INITIALISE CNC CONTROLLER');
      MessageDlg('FAILED TO INITIALISE CNC CONTROLLER!', mtError, [mbCancel], 0, mbCancel);
    end
    else
    begin
      Speak('FAILED TO LOCATE CNC CONTROLLER');
      MessageDlg('FAILED TO LOCATE CNC CONTROLLER!', mtError, [mbCancel], 0, mbCancel);
    end;
  end;

  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonResetPanelClick(Sender: TObject);
begin
  PanelBoardCount := 1; // reset panel
  CurrentPart := 1; // reset part selection

  UpdatePartList;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.ButtonResumeClick(Sender: TObject);
begin
  Pause := false;
  UpdateStatus;
  UpdateButtons;
end;

procedure TFormMain.UpdatePartList;
var
  X, N: Integer;
  DisabledText: string;
begin
  Enabled := false;

  CheckBoxMetric.Checked := BoardMetric;

  if (PartCount > 0) and (FeederCount > 0) then
  begin
    ComboBoxFeeder.Items.Clear;
    for X := 1 to FeederCount do
    begin
      if FeederList[Pred(X)].Description <> '' then
        ComboBoxFeeder.Items.Add(IntToStr(X) + ' - ' + FeederList[Pred(X)].Description) { add to list }
      else
        ComboBoxFeeder.Items.Add(IntToStr(X)); { add to list }
    end;

    N := PartList[Pred(CurrentPart)].Feeder; { select current }
    if (N > 0) then
    begin
      ComboBoxFeeder.ItemIndex := Pred(N); { select current }
      ComboBoxFeeder.Color := clWindow;
    end
    else
    begin
      ComboBoxFeeder.ItemIndex := -1; { invalid selection }
      ComboBoxFeeder.Text := '** NO FEEDER SELECTED **';
      ComboBoxFeeder.Color := clRed;
    end;
  end
  else
  begin
    ComboBoxFeeder.Items.Clear; // blank feeder list
    ComboBoxFeeder.ItemIndex := -1;
    ComboBoxFeeder.Text := '** NO FEEDER SELECTED **';
    ComboBoxFeeder.Color := clRed;
  end;

  // ******************************************************************************

  ListBoxPartList.Clear;
  if PartCount > 0 then
  begin
    if CurrentPart = 0 then
      CurrentPart := 1; // ensure current part is valid

    GroupBoxPartDetails.Caption := 'Part Details - ' + IntToStr(CurrentPart) + ' of ' + IntToStr(PartCount);
    for X := 0 to PartCount - 1 do
    begin
      if PartList[X].Enabled then // include part status
        DisabledText := ''
      else
        DisabledText := ' - DISABLED';

      if (PartList[X].Designator <> '') and (PartList[X].Comment <> '') then
        ListBoxPartList.Items.Add('Part ' + IntToStr(Succ(X)) + DisabledText + ' - ' + PartList[X].Designator + ' - ' + PartList[X].Comment)
      else if (PartList[X].Designator <> '') then
        ListBoxPartList.Items.Add('Part ' + IntToStr(Succ(X)) + DisabledText + ' - ' + PartList[X].Designator)
      else if (PartList[X].Comment <> '') then
        ListBoxPartList.Items.Add('Part ' + IntToStr(Succ(X)) + DisabledText + ' - ' + PartList[X].Comment)
      else
        ListBoxPartList.Items.Add('Part ' + IntToStr(Succ(X)) + DisabledText);
    end;

    with PartList[Pred(CurrentPart)] do
    begin
      EditPartDesignator.Text := Designator;
      EditPartComment.Text := Comment;
      EditPartAngle.Text := FloatToStrF(Angle, ffFixed, 10, 2);

      if BoardMetric then
      begin
        EditPartPositionX.Text := FloatToStrF(X, ffFixed, 10, 3);
        EditPartPositionY.Text := FloatToStrF(Y, ffFixed, 10, 3);
      end
      else
      begin
        EditPartPositionX.Text := FloatToStrF(X / 25.4, ffFixed, 10, 4);
        EditPartPositionY.Text := FloatToStrF(Y / 25.4, ffFixed, 10, 4);
      end;

      CheckBoxPartEnabled.Checked := Enabled;
    end;
    ListBoxPartList.ItemIndex := Pred(CurrentPart); // show selection

    if (PartList[Pred(CurrentPart)].Feeder > 0) and (PartList[Pred(CurrentPart)].Feeder <= FeederCount) then
    begin // if valid number
      try
        ImagePartSnap.Picture.Bitmap.LoadFromFile(Settings_Directory + FeederList[Pred(PartList[Pred(CurrentPart)].Feeder)].SnapName + '.bmp'); // show snap

        ImageNoSnap.Visible := false;
        ImagePartSnap.Visible := true;
      except
        ImagePartSnap.Visible := false;
        ImageNoSnap.Visible := true;
      end;
    end
    else
    begin
      ImagePartSnap.Visible := false;
      ImageNoSnap.Visible := true;
    end;

  end
  else
  begin
    CurrentPart := 0;
    GroupBoxPartDetails.Caption := 'Part Details - No Parts';

    EditPartDesignator.Text := '';
    EditPartComment.Text := '';
    EditPartPositionX.Text := '';
    EditPartPositionY.Text := '';
    EditPartAngle.Text := '';
    CheckBoxPartEnabled.Checked := true;

    ImagePartSnap.Visible := false;
  end;

  Enabled := true;
end;

function TFormMain.MoveBoardRelativeWithPartAndNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position WITH PART but PROTECT NOZZLE against damage
  if not CNCOutputVacuumState then
  begin // if vacuum is not active then
    SetOutputVacuum(true); // activate the Vacuum
    FormMain.Delay(PickDelay); // delay for Pick Vacuum
  end;

  Result := CNCMoveHomeRelativeWithNozzleProtection(X + BoardOriginX, Y + BoardOriginY, Z, A, Speed); // move directly as move is ok

  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.MoveBoardRelativeWithPart(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position WITH PART
  if not CNCOutputVacuumState then
  begin // if vacuum is not active then
    SetOutputVacuum(true); // activate the Vacuum
    FormMain.Delay(PickDelay); // delay for Pick Vacuum
  end;

  Result := CNCMoveHomeRelativeWithNozzleProtection(X + BoardOriginX, Y + BoardOriginY, Z, A, Speed); // move directly as move is ok

  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.MoveHomeRelativeWithPartAndNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position WITH PART but PROTECT NOZZLE against damage
  if not CNCOutputVacuumState then
  begin // if vacuum is not active then
    SetOutputVacuum(true); // activate the Vacuum
    FormMain.Delay(PickDelay); // delay for Pick Vacuum
  end;

  Result := CNCMoveHomeRelativeWithNozzleProtection(X, Y, Z, A, Speed); // move directly as move is ok

  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.MoveHomeRelativeWithPart(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position WITH PART
  if not CNCOutputVacuumState then
  begin // if vacuum is not active then
    SetOutputVacuum(true); // activate the Vacuum
    FormMain.Delay(PickDelay); // delay for Pick Vacuum
  end;

  Result := CNCMoveHomeRelative(X, Y, Z, A, Speed);

  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.MoveBoardRelativeWithNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
begin
  Result := MoveHomeRelativeWithNozzleProtection(X + BoardOriginX, Y + BoardOriginY, Z, A, Speed);
  Application.ProcessMessages;
end;

function TFormMain.MoveHomeRelativeWithNozzleProtection(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position but PROTECT NOZZLE against damage
  if CNCOutputVacuumState then
  begin // if vacuum is active then
    SetOutputVacuum(false); // deactivate the Vacuum
    FormMain.Delay(PickDelay); // delay for Vacuum release
  end;

  if CNCOutputFeederState then
  begin // if feeder actuator is active then
    SetOutputFeeder(false); // release feeder actuator
    FormMain.Delay(ActuatorOffDelay); // delay after actuator
  end;

  Result := CNCMoveHomeRelativeWithNozzleProtection(X, Y, Z, A, Speed);
  // move directly as move is ok
  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.MoveBoardRelative(X, Y, Z, A: double; Speed: Integer): Boolean;
begin
  Result := MoveHomeRelative(X + BoardOriginX, Y + BoardOriginY, Z, A, Speed);
  Application.ProcessMessages;
end;

function TFormMain.MoveHomeRelative(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // move relative to HOME position
  Result := CNCMoveHomeRelative(X, Y, Z, A, Speed);

  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.Move(X, Y, Z, A: double; Speed: Integer): Boolean;
begin // general move absolute
  Result := CNCMove(X, Y, Z, A, Speed);

  UpdateStatus;
  UpdateButtons;
  Application.ProcessMessages;
end;

function TFormMain.PlacePart(Part: Integer): Boolean;
var
  Status: Boolean;
  Speed: Integer;
  PlaceX, PlaceY, PositionX, PositionY, PartHeight: double;
begin // place part at part position
  Status := false; // assume failure

  if (Part > 0) and (Part <= PartCount) and (PartList[Pred(Part)].Feeder > 0) and (PartList[Pred(Part)].Feeder <= FeederCount) then // if valid part
  begin
    ViewSelection := 1; // uplooking camera
    UpdateStatus;

    // ******************************************************************************

    PositionX := PartList[Pred(Part)].X; // base position of part
    PositionY := PartList[Pred(Part)].Y;
    PartHeight := FeederList[Pred(PartList[Pred(Part)].Feeder)].PartHeight;

    PlaceX := PositionX + NozzleOffsetX + (FiducialX * FiducialXScale) + PartPickedX; // determine place position
    PlaceY := PositionY + NozzleOffsetY + (FiducialY * FiducialYScale) + PartPickedY;

    // ******************************************************************************

    Case FeederList[Pred(PartList[Pred(Part)].Feeder)].PlaceSpeedType of
      0:
        Speed := FastPlaceSpeed;
      1:
        Speed := MediumPlaceSpeed;
      2:
        Speed := SlowPlaceSpeed;
    else
      Speed := FastPlaceSpeed;
    end;

    // ******************************************************************************

    if MoveBoardRelativeWithPartAndNozzleProtection(PlaceX, PlaceY, 0 - CNCHomeZ, PartPickedAngle, Speed) then
    begin

      // ******************************************************************************

      if MoveBoardRelativeWithPart(PlaceX, PlaceY, (BoardHeight - PartHeight) + PlaceZPush, PartPickedAngle, Speed) then
      begin
        // ******************************************************************************

        if CNCOutputVacuumState then
        begin // if vacuum is active then
          SetOutputVacuum(false); // deactivate the Vacuum
          Delay(PlaceDelay); // delay for Place vacuum release
        end;

        // ******************************************************************************

        if BlowDelay > 0 then // if blow delay > 0
        begin
          SetOutputBlow(true); // start blow
          Delay(BlowDelay); // delay for blow to start
        end;

        // ******************************************************************************
        // move up from board

        if MoveBoardRelativeWithNozzleProtection(PlaceX, PlaceY, 0 - CNCHomeZ, PartPickedAngle, Speed) then
        begin
          PartPicked := false;
          PartPickedX := 0;
          PartPickedY := 0;
          PartPickedAngle := 0;

          Status := true; // passed
        end
        else
          Status := false; // failed to move up after placement

        SetOutputBlow(false); // stop blow
      end
      else
        Status := false; // failed to lower part down to board
    end
    else
      Status := false; // failed to move part to board
  end;

  Save_Settings; // ensure the settings are saved first

  Result := Status; // return result
end;

function TFormMain.PickPart(Feeder: Integer; Angle: double): Boolean;
var
  B: TBitmap;
  S: string;
  Status: Boolean;
  ImagePresent: Boolean;
  Speed: Integer;
  TrayX, TrayY, PositionX, PositionY, PositionZ, ClearanceX, ClearanceY: double; // feeder clearance distances
  Rotation: double; // rotation to correct for feeder position
begin // pick part from selected feeder and go to uplooking camera
  Status := false; // assume failure

  if TrayRefillRequest > 0 then // if tray refill requested
  begin
    S := 'FEEDER ' + IntToStr(TrayRefillRequest) + ' ' + FeederList[Pred(TrayRefillRequest)].Description + ' TRAY NEEDS TO BE REFILLED!';
    Speak(S);
    MessageDlg(S, mtInformation, [mbOk], 0, mbOk);
    TrayRefillRequest := 0; // reset flag
  end;

  if (Feeder > 0) and (Feeder <= FeederCount) then // if valid feeder
  begin
    B := TBitmap.Create; // prepare visual reference
    Try
      B.LoadFromFile(Settings_Directory + FeederList[Pred(Feeder)].SnapName + '.bmp');
      FormMain.ImageReference := CreateImageFromBitmap(B); // convert to PBitmap32
      ImagePresent := true;
    Except
      ImagePresent := false;
      S := 'SNAP IMAGE ' + FeederList[Pred(Feeder)].SnapName + ' IS MISSING!';
      Speak(S);
      MessageDlg(S, mtInformation, [mbOk], 0, mbOk);
    End;
    B.Free;

    if ImagePresent then
    begin
      // ******************************************************************************
      PositionX := FeederList[Pred(Feeder)].X; // base position of feeder
      PositionY := FeederList[Pred(Feeder)].Y;
      PositionZ := FeederList[Pred(Feeder)].Z;

      // ******************************************************************************

      if FeederList[Pred(Feeder)].Kind = 1 then
      // if TRAY feeder then select correct position
      begin
        if FeederList[Pred(Feeder)].TrayPickCount <= 0 then // range check
          FeederList[Pred(Feeder)].TrayPickCount := 1;

        // determine tray count based X and Y position

        if (FeederList[Pred(Feeder)].TrayCountX = 1) and (FeederList[Pred(Feeder)].TrayCountY = 1) then
        begin // no X or Y
          TrayX := 0;
          TrayY := 0;
        end
        else if FeederList[Pred(Feeder)].TrayCountX = 1 then
        begin // Y ONLY
          TrayY := Pred(FeederList[Pred(Feeder)].TrayPickCount) * FeederList[Pred(Feeder)].TraySpacingY;
          TrayX := 0;
        end
        else if FeederList[Pred(Feeder)].TrayCountY = 1 then
        begin // X ONLY
          TrayX := Pred(FeederList[Pred(Feeder)].TrayPickCount) * FeederList[Pred(Feeder)].TraySpacingX;
          TrayY := 0;
        end
        else
        begin
          TrayX := (Pred(FeederList[Pred(Feeder)].TrayPickCount) Div FeederList[Pred(Feeder)].TrayCountY) * FeederList[Pred(Feeder)].TraySpacingX;

          TrayY := (Pred(FeederList[Pred(Feeder)].TrayPickCount) Mod FeederList[Pred(Feeder)].TrayCountY) * FeederList[Pred(Feeder)].TraySpacingY;
        end;

        PositionX := PositionX + TrayX; // adjust by offset tray offset
        PositionY := PositionY + TrayY;
      end;

      // ******************************************************************************

      // select correct nozzle first
      if FormNozzleChanger.SelectNozzle(FeederList[Pred(Feeder)].Nozzle) then
      begin
        // ******************************************************************************
        if MoveHomeRelativeWithNozzleProtection(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond) then
        begin
          // ******************************************************************************
          if not CNCOutputVacuumState then
          begin // if vacuum is not active then
            SetOutputVacuum(true); // activate the Vacuum
          end;

          // ******************************************************************************
          if FeederList[Pred(Feeder)].Kind = 0 then
          // if reel feeder then operate actuator
          begin
            SetOutputFeeder(true); // operate actuator
            Delay(ActuatorOnDelay); // delay after actuator
          end;

          // ******************************************************************************
          if MoveHomeRelative(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, PositionZ, 0, CNCMaxStepsPerSecond) then
          begin
            // ******************************************************************************
            Delay(PickDelay); // delay for Pickup of part

            // ******************************************************************************
            ViewSelection := 1; // select uplooking camera
            UpdateStatus;

            // ******************************************************************************
            Case FeederList[Pred(Feeder)].PlaceSpeedType of
              0:
                Speed := FastPlaceSpeed;
              1:
                Speed := MediumPlaceSpeed;
              2:
                Speed := SlowPlaceSpeed;
            else
              Speed := FastPlaceSpeed;
            end;

            // ******************************************************************************
            // move up from feeder first

            if MoveHomeRelativeWithPart(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, 0 - CNCHomeZ, 0, Speed) then
            begin
              if FeederList[Pred(Feeder)].Kind = 0 then
              // if reel feeder then operate actuator
              begin
                SetOutputFeeder(false); // deactivate actuator
                Delay(ActuatorOffDelay); // delay after deactivating actuator
              end;

              // ******************************************************************************

              ClearanceX := 0;
              ClearanceY := 0;
              Rotation := 0;

              if FeederList[Pred(Feeder)].Kind = 0 then // if REEL feeder
              begin // now set rotation and feeder clearance to avoid hitting other feeders
                Case FeederList[Pred(Feeder)].Location of
                  // 0 = right, 1 = front, 2 = rear
                  0:
                    begin // right
                      ClearanceX := -20;
                      ClearanceY := 0;
                      Rotation := 90;
                    end;

                  1:
                    begin // front
                      ClearanceX := 0;
                      ClearanceY := 20;
                      Rotation := 0;
                    end;

                  2:
                    begin // rear
                      ClearanceX := 0;
                      ClearanceY := -20;
                      Rotation := 180;
                    end;
                end;
              end
              else if FeederList[Pred(Feeder)].Kind = 1 then // if TRAY feeder
              begin // now set rotation
                Case FeederList[Pred(Feeder)].Location of
                  0: // 0 = right, 1 = front, 2 = rear
                    begin // right
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := 90;
                    end;

                  1:
                    begin // front
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := 0;
                    end;

                  2:
                    begin // rear
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := 180;
                    end;
                end;
              end
              else // else must be VIBRATION
              begin // now set rotation
                Case FeederList[Pred(Feeder)].Location of
                  0: // 0 = right, 1 = front, 2 = rear
                    begin // right
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := 0;
                    end;

                  1:
                    begin // front
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := -90;
                    end;

                  2:
                    begin // rear
                      ClearanceX := 0;
                      ClearanceY := 0;
                      Rotation := 90;
                    end;
                end;
              end;

              // ******************************************************************************

              if MoveHomeRelativeWithPartAndNozzleProtection(PositionX + NozzleOffsetX + ClearanceX, PositionY + NozzleOffsetY + ClearanceY, 0 - CNCHomeZ, 0,
                Speed) then
              begin
                if FeederList[Pred(Feeder)].Use_Vision then // if vision enabled
                begin
                  if MoveHomeRelativeWithPartAndNozzleProtection(UplookingCameraX, UplookingCameraY, 0 - CNCHomeZ, Rotation + Angle, Speed) then
                  // move to camera focal height allowing for part height
                  begin
                    if MoveHomeRelativeWithPartAndNozzleProtection(UplookingCameraX, UplookingCameraY, UplookingCameraZ - FeederList[Pred(Feeder)].PartHeight,
                      Rotation + Angle, Speed) then
                    begin
                      PartPicked := true; // part was potentially picked so set picked flag
                      PartPickedX := 0;
                      PartPickedY := 0;
                      PartPickedAngle := Angle; // start with angle of INTENDED PLACEMENT

                      Delay(UplookingCameraSettlingDelay); // small delay

                      if CaptureUplooking then // capture image
                      begin
                        if AngularVisualCorrelation(PartPickedAngle, UplookingCameraEnlargementMM) then // correlate
                        begin // move to new angle
                          PartPickedAngle := Angle - VisionAngle; // set new angle only, ignore centere error for the moment
                          if MoveHomeRelativeWithPart(UplookingCameraX + PartPickedX, UplookingCameraY + PartPickedY,
                            UplookingCameraZ - FeederList[Pred(Feeder)].PartHeight, Rotation + PartPickedAngle, Speed div 10) then // move slowly
                          begin
                            Delay(UplookingCameraSettlingDelay); // small delay

                            if CaptureUplooking then // capture image
                            begin // scale of 2
                              if VisualCorrelation(Angle, UplookingCameraEnlargementMM, true) then // correlate at placement angle to find actual centre
                              begin
                                PartPickedX := -VisionCentreX; // set new position
                                PartPickedY := -VisionCentreY;
                                PartPickedAngle := Rotation + PartPickedAngle; // correct angle for placing

                                if (not VisionTestMode and (AutomaticPanel or AutomaticBoard)) or
                                  MoveHomeRelativeWithPart(UplookingCameraX + PartPickedX, UplookingCameraY + PartPickedY,
                                  UplookingCameraZ - FeederList[Pred(Feeder)].PartHeight, PartPickedAngle, Speed div 10) then
                                // only move to centre if not in automatic as it is pointless otherwise
                                // move slowly
                                begin
                                  Status := true; // passed!!! - PART IS GOOD AND CENTRE FOUND!
                                  If VisionTestMode then
                                    Delay(3); // delay 3 seconds to allow visual check
                                end
                                else
                                begin
                                  Status := false; // failed to move to centre
                                  Speak('Failed to move to centre');
                                end;
                              end
                              else
                              begin
                                Status := false; // failed confirmation correlation
                                Speak('Failed confirmation correlation');
                              end;
                            end
                            else
                            begin
                              Status := false; // failed to capture image
                              Speak('Failed to capture image');
                            end;
                          end
                          else
                          begin
                            Status := false; // failed to move to centre
                            Speak('Failed to move to centre');
                          end;
                        end
                        else
                        begin
                          Status := false; // failed angular correlation
                          Speak('Failed angular correlation');
                        end;
                      end
                      else
                      begin
                        Status := false; // failed to capture image
                        Speak('Failed to capture image');
                      end;
                    end
                    else
                    begin
                      Status := false;
                      // failed to move to camera focal height allowing for part height
                      Speak('Failed to move to camera focal height');
                    end;
                  end
                  else
                  begin
                    Status := false; // failed to move to camera
                    Speak('Failed to move to camera');
                  end;
                end
                else
                begin
                  Status := true; // vision disabled so assume success!!
                  PartPicked := true; // part was potentially picked so set picked flag
                  PartPickedX := 0;
                  PartPickedY := 0;
                  PartPickedAngle := Angle; // start with angle of INTENDED PLACEMENT
                end;
              end
              else
              begin
                Status := false; // failed to move to camera
                Speak('Failed to move clear of feeder');
              end;
            end
            else
            begin
              Status := false; // failed to move up with part
              Speak('Failed to move up with part');
            end;
          end
          else
          begin
            Status := false; // failed to move down to part
            Speak('Failed to move down to part');
          end;
        end
        else
        begin
          Status := false; // failed to move to feeder
          Speak('Failed to move to feeder');
        end;
      end
      else
      begin
        Status := false; // failed to select nozzle
        Speak('Failed to select nozzle');
      end;

      // ******************************************************************************

      if FeederList[Pred(Feeder)].Kind = 1 then
      // if TRAY feeder then advance tray
      begin
        inc(FeederList[Pred(Feeder)].TrayPickCount); // advance tray count
        if FeederList[Pred(Feeder)].TrayPickCount > FeederList[Pred(Feeder)].TrayCountX * FeederList[Pred(Feeder)].TrayCountY then
        begin
          FeederList[Pred(Feeder)].TrayPickCount := 1; // wrap around
          TrayRefillRequest := Feeder; // set tray refill request
        end;

        if Save_Project(ProjectPath, ProjectName) then // save this project now changes have bee made to feeder
        begin
          ProjectEdited := false;
        end;
      end;
    end;
  end;
  FreeImage(ImageReference);
  Result := Status; // return result
end;

function TFormMain.PickPartWithoutCorrelation(Feeder: Integer; Angle: double): Boolean;
var
  Status: Boolean;
  Speed: Integer;
  TrayX, TrayY, PositionX, PositionY, PositionZ, ClearanceX, ClearanceY: double;
  // feeder clearance distances
  Rotation: double; // rotation to correct for feeder position
begin // pick part from selected feeder and go to uplooking camera
  Status := false; // assume failure

  if (Feeder > 0) and (Feeder <= FeederCount) then // if valid feeder
  begin
    PositionX := FeederList[Pred(Feeder)].X; // base position of feeder
    PositionY := FeederList[Pred(Feeder)].Y;
    PositionZ := FeederList[Pred(Feeder)].Z;

    // ******************************************************************************

    if FeederList[Pred(Feeder)].Kind = 1 then
    // if TRAY feeder then select correct position
    begin
      if FeederList[Pred(Feeder)].TrayPickCount <= 0 then // range check
        FeederList[Pred(Feeder)].TrayPickCount := 1;

      // determine tray count based X and Y position

      if (FeederList[Pred(Feeder)].TrayCountX = 1) and (FeederList[Pred(Feeder)].TrayCountY = 1) then
      begin // no X or Y
        TrayX := 0;
        TrayY := 0;
      end
      else if FeederList[Pred(Feeder)].TrayCountX = 1 then
      begin // Y ONLY
        TrayY := Pred(FeederList[Pred(Feeder)].TrayPickCount) * FeederList[Pred(Feeder)].TraySpacingY;
        TrayX := 0;
      end
      else if FeederList[Pred(Feeder)].TrayCountY = 1 then
      begin // X ONLY
        TrayX := Pred(FeederList[Pred(Feeder)].TrayPickCount) * FeederList[Pred(Feeder)].TraySpacingX;
        TrayY := 0;
      end
      else
      begin
        TrayX := (Pred(FeederList[Pred(Feeder)].TrayPickCount) Div FeederList[Pred(Feeder)].TrayCountY) * FeederList[Pred(Feeder)].TraySpacingX;

        TrayY := (Pred(FeederList[Pred(Feeder)].TrayPickCount) Mod FeederList[Pred(Feeder)].TrayCountY) * FeederList[Pred(Feeder)].TraySpacingY;
      end;

      PositionX := PositionX + TrayX; // adjust by offset tray offset
      PositionY := PositionY + TrayY;
    end;

    // ******************************************************************************

    // select correct nozzle first
    if FormNozzleChanger.SelectNozzle(FeederList[Pred(Feeder)].Nozzle) then
    begin
      // ******************************************************************************

      if MoveHomeRelativeWithNozzleProtection(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond) then
      begin

        // ******************************************************************************
        if not CNCOutputVacuumState then
        begin // if vacuum is not active then
          SetOutputVacuum(true); // activate the Vacuum
        end;

        // ******************************************************************************

        if FeederList[Pred(Feeder)].Kind = 0 then
        // if reel feeder then operate actuator
        begin
          SetOutputFeeder(true); // operate actuator
          Delay(ActuatorOnDelay); // delay after actuator
        end;

        // ******************************************************************************

        if MoveHomeRelative(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, PositionZ, 0, CNCMaxStepsPerSecond) then
        begin
          // ******************************************************************************

          Delay(PickDelay); // delay for Pickup of part

          // ******************************************************************************

          ViewSelection := 1; // select uplooking camera
          UpdateStatus;

          // ******************************************************************************

          Case FeederList[Pred(Feeder)].PlaceSpeedType of
            0:
              Speed := FastPlaceSpeed;
            1:
              Speed := MediumPlaceSpeed;
            2:
              Speed := SlowPlaceSpeed;
          else
            Speed := FastPlaceSpeed;
          end;

          // ******************************************************************************
          // move up from feeder first

          if MoveHomeRelativeWithPart(PositionX + NozzleOffsetX, PositionY + NozzleOffsetY, 0 - CNCHomeZ, 0, Speed) then
          begin
            if FeederList[Pred(Feeder)].Kind = 0 then
            // if reel feeder then operate actuator
            begin
              SetOutputFeeder(false); // deactivate actuator
              Delay(ActuatorOffDelay); // delay after deactivating actuator
            end;

            // ******************************************************************************

            ClearanceX := 0;
            ClearanceY := 0;
            Rotation := 0;

            if FeederList[Pred(Feeder)].Kind = 0 then // if REEL feeder
            begin // now set rotation and feeder clearance to avoid hitting other feeders
              Case FeederList[Pred(Feeder)].Location of
                // 0 = right, 1 = front, 2 = rear
                0:
                  begin // right
                    ClearanceX := -20;
                    ClearanceY := 0;
                    Rotation := 90;
                  end;

                1:
                  begin // front
                    ClearanceX := 0;
                    ClearanceY := 20;
                    Rotation := 0;
                  end;

                2:
                  begin // rear
                    ClearanceX := 0;
                    ClearanceY := -20;
                    Rotation := 180;
                  end;
              end;
            end
            else if FeederList[Pred(Feeder)].Kind = 1 then // if TRAY feeder
            begin // now set rotation
              Case FeederList[Pred(Feeder)].Location of
                0: // 0 = right, 1 = front, 2 = rear
                  begin // right
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := 90;
                  end;

                1:
                  begin // front
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := 0;
                  end;

                2:
                  begin // rear
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := 180;
                  end;
              end;
            end
            else // else must be VIBRATION
            begin // now set rotation
              Case FeederList[Pred(Feeder)].Location of
                0: // 0 = right, 1 = front, 2 = rear
                  begin // right
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := 0;
                  end;

                1:
                  begin // front
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := -90;
                  end;

                2:
                  begin // rear
                    ClearanceX := 0;
                    ClearanceY := 0;
                    Rotation := 90;
                  end;
              end;
            end;

            // ******************************************************************************

            if MoveHomeRelativeWithPartAndNozzleProtection(PositionX + NozzleOffsetX + ClearanceX, PositionY + NozzleOffsetY + ClearanceY, 0 - CNCHomeZ, 0,
              Speed) then
            begin // move to camera focal height allowing for part height
              if MoveHomeRelativeWithPart(UplookingCameraX, UplookingCameraY, 0 - CNCHomeZ, Rotation + Angle, Speed) then
              begin
                if MoveHomeRelativeWithPart(UplookingCameraX, UplookingCameraY, UplookingCameraZ - FeederList[Pred(Feeder)].PartHeight, Rotation + Angle, Speed)
                then
                begin
                  PartPicked := true;
                  // part was potentially picked so set picked flag
                  PartPickedX := 0;
                  PartPickedY := 0;
                  PartPickedAngle := Rotation + Angle;
                  // preserve angle of INTENDED PLACEMENT

                  Status := true;
                  // passed!!! - BUT PART HAS NOT BEEN VISUALLY CHECKED
                end
                else
                  Status := false;
                // failed to move to camera focal height allowing for part height
              end
              else
                Status := false; // failed to move to camera
            end
            else
              Status := false; // failed to move to camera
          end
          else
            Status := false; // failed to move up with part
        end
        else
          Status := false; // failed to move down to part
      end
      else
        Status := false; // failed to move to feeder
    end
    else
      Status := false; // failed to select nozzle

    // ******************************************************************************

    if FeederList[Pred(Feeder)].Kind = 1 then
    // if TRAY feeder then advance tray
    begin
      inc(FeederList[Pred(Feeder)].TrayPickCount); // advance tray count
      if FeederList[Pred(Feeder)].TrayPickCount > FeederList[Pred(Feeder)].TrayCountX * FeederList[Pred(Feeder)].TrayCountY then
      begin
        FeederList[Pred(Feeder)].TrayPickCount := 1; // wrap around
      end;
    end;
  end;
  Result := Status; // return result
end;

function TFormMain.DiscardPart(Feeder: Integer): Boolean;
var
  TrayLocationX, TrayLocationY: double;
begin
  if (Feeder > 0) and (Feeder <= FeederCount) then // if valid feeder
  begin
    ViewSelection := 1; // uplooking camera
    UpdateStatus;
    UpdateButtons;

    // ******************************************************************************

    TrayLocationX := RejectTray1X; // default to tray 1
    TrayLocationY := RejectTray1Y;

    case FeederList[Pred(Feeder)].RejectTray of
      1:
        begin
          TrayLocationX := RejectTray1X;
          TrayLocationY := RejectTray1Y;
        end;

      2:
        begin
          TrayLocationX := RejectTray2X;
          TrayLocationY := RejectTray2Y;
        end;

      3:
        begin
          TrayLocationX := RejectTray3X;
          TrayLocationY := RejectTray3Y;
        end;

      4:
        begin
          TrayLocationX := RejectTray4X;
          TrayLocationY := RejectTray4Y;
        end;

      5:
        begin
          TrayLocationX := RejectTray5X;
          TrayLocationY := RejectTray5Y;
        end;

    end;

    // discard part at either selected discard tray or ORIGIN
    if MoveHomeRelativeWithPartAndNozzleProtection(TrayLocationX, TrayLocationY, 0 - CNCHomeZ, 0, CNCMaxStepsPerSecond) then
    begin
      if CNCOutputVacuumState then
      begin // if vacuum is active then
        SetOutputVacuum(false); // dectivate the Vacuum
        Delay(PlaceDelay); // delay for Place Vacuum release
      end;

      // ******************************************************************************

      if BlowDelay > 0 then // if blow delay > 0
      begin
        SetOutputBlow(true); // start blow
        Delay(5 * BlowDelay); // delay for blow
        SetOutputBlow(false); // stop blow
      end;

      // ******************************************************************************

      Result := true; // success
    end
    else
      Result := false; // failed to move to tray
  end
  else
    Result := false; // invalid feeder

  // ******************************************************************************

  SetOutputBlow(false); // stop blow
  SetOutputVacuum(false); // dectivate the Vacuum
  PartPicked := false; // no part

  UpdateStatus;
  UpdateButtons;
end;

function TFormMain.VisualCorrelation(Angle: double; EnlargeMM: Integer; UseUpCamera: Boolean): Boolean; // do alignment search for downlooking camera
type
  FindRec = record
    Correlation: double;
    X: Integer;
    Y: Integer;
    Scale: Integer;
  end;
var
  Scale, X, Y, Z, PosX, PosY, RangeX, RangeY, OldScale, Enlargement: Integer;
  SearchWidth, SearchHeight, Top, Bottom, Left, Right: Integer;
  FilterCorrelation1: TFilterNormalisedCrossCorrelation;
  FilterWindow1: TFilterWindow;
  FilterResize1: TFilterResize;
  FilterRotation1: TFilterRotation;
  Correlation, Worst, PixelSize, OldX, OldY: double;
  ImageSearchWindow, ImageResizedSearch, ImageResizedReference, ImageTemp: PBitmap32;
  Best, NextBest, ThirdBest, FourthBest, BestFound, NextBestFound, ThirdBestFound, FourthBestFound: FindRec;

  function EvaluateImage(X, Y: Integer): double;
  begin
    FilterCorrelation1 := TFilterNormalisedCrossCorrelation.Create;
    FilterCorrelation1.setParameterImage('INIMAGETOSEARCH', ImageResizedSearch); // image to search
    FilterCorrelation1.setParameterImage('INIMAGETOFIND', ImageResizedReference); // reference to find
    FilterCorrelation1.setParameterInteger('X', X); // offset
    FilterCorrelation1.setParameterInteger('Y', Y); // offset
    FilterCorrelation1.Run;
    Result := FilterCorrelation1.GetOutputParameterSingle('CORRELATION').Value;
    FilterCorrelation1.Free;
  end;

  procedure DoCorrelation;
  begin
    Correlation := EvaluateImage(PosX, PosY); // analyse correlation

    if Correlation > Best.Correlation then
    begin
      FourthBest := ThirdBest;
      ThirdBest := NextBest;
      NextBest := Best; // use best as next best
      Best.Correlation := Correlation;
      Best.X := PosX;
      Best.Y := PosY;
      Best.Scale := Scale;
    end;

    if Correlation < Worst then
      Worst := Correlation; // preserve worst
  end;

begin
  if VisionTestMode then
    FormVisiontest.Show;

  // ******************************************************************************
  Scale := 1; // FIXED SCALE

  if UseUpCamera then
  begin // use uplooking camera
    try // set pixel size in mm
      PixelSize := UplookingViewWidthInMM / ImageUplooking.Width;
      Enlargement := Round(EnlargeMM / PixelSize); // enlargement of search area in pixels
    except
      PixelSize := 0.0625; // default
      Enlargement := 100;
    end;

    if Angle <> 0 then // rotate image CLOCKWISE to requested angle
    begin
      FilterRotation1 := TFilterRotation.Create; // get windowed portion
      FilterRotation1.setParameterImage('INIMAGE', ImageUplooking);
      FilterRotation1.setParameterSingle('ANGLE', Angle);
      FilterRotation1.Run;
      ImageTemp := CreateImageFromImage(FilterRotation1.GetOutputParameterImage('OUTIMAGE').Image);
      FilterRotation1.Free;
    end
    else
      ImageTemp := CreateImageFromImage(ImageUplooking); // else use original image
  end
  else
  begin // use downlooking camera
    try // set pixel size in mm
      PixelSize := DownlookingViewWidthInMM / ImageDownlooking.Width;
      Enlargement := Round(EnlargeMM / PixelSize); // enlargement of search area in pixels
    except
      PixelSize := 0.0625; // default
      Enlargement := 100;
    end;

    if Angle <> 0 then // rotate image CLOCKWISE to requested angle
    begin
      FilterRotation1 := TFilterRotation.Create; // get windowed portion
      FilterRotation1.setParameterImage('INIMAGE', ImageDownlooking);
      FilterRotation1.setParameterSingle('ANGLE', Angle);
      FilterRotation1.Run;
      ImageTemp := CreateImageFromImage(FilterRotation1.GetOutputParameterImage('OUTIMAGE').Image);
      FilterRotation1.Free;
    end
    else
      ImageTemp := CreateImageFromImage(ImageDownlooking); // else use original image
  end;

  // ******************************************************************************
  SearchWidth := ImageReference.Width + Enlargement; // search window area enlargement
  SearchHeight := ImageReference.Height + Enlargement;

  // ******************************************************************************
  if (SearchWidth < ImageTemp.Width) and (SearchHeight < ImageTemp.Height) then // if window required
  begin
    ImageSearchWindow := CreateImageLike(ImageTemp); // create window image

    Bottom := (ImageTemp.Height div 2) - (SearchHeight div 2);
    Top := Bottom + SearchHeight;
    Left := (ImageTemp.Width div 2) - (SearchWidth div 2);
    Right := Left + SearchWidth;

    FilterWindow1 := TFilterWindow.Create; // get windowed portion
    FilterWindow1.setParameterImage('INIMAGE', ImageTemp);
    FilterWindow1.setParameterImage('OUTIMAGE', ImageSearchWindow);
    FilterWindow1.setParameterInteger('TOP', Top);
    FilterWindow1.setParameterInteger('BOTTOM', Bottom);
    FilterWindow1.setParameterInteger('LEFT', Left);
    FilterWindow1.setParameterInteger('RIGHT', Right);
    FilterWindow1.Run;
    FilterWindow1.Free;
  end
  else
    ImageSearchWindow := CreateImageFromImage(ImageTemp); // else use original

  { ****************************************************************************** }
  // scale image to blur for better match and also to increase speed!!

  ImageResizedSearch := CreateImage(ImageSearchWindow.Width div Scale, ImageSearchWindow.Height div Scale);
  ImageResizedReference := CreateImage(ImageReference.Width div Scale, ImageReference.Height div Scale);

  FilterResize1 := TFilterResize.Create;
  FilterResize1.setParameterImage('INIMAGE', ImageSearchWindow);
  FilterResize1.setParameterImage('OUTIMAGE', ImageResizedSearch);
  FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
  FilterResize1.Run;
  FilterResize1.Free;

  FilterResize1 := TFilterResize.Create;
  FilterResize1.setParameterImage('INIMAGE', ImageReference);
  FilterResize1.setParameterImage('OUTIMAGE', ImageResizedReference);
  FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
  FilterResize1.Run;
  FilterResize1.Free;

  // ******************************************************************************
  if VisionTestMode then
  begin
    ShowImage(ImageResizedSearch, FormVisiontest.ImageSearch);
    ShowImage(ImageResizedReference, FormVisiontest.ImageReference);
    MessageDlg('SINGLE STEP!', mtInformation, [mbOk], 0, mbOk);
  end;

  // ******************************************************************************

  Best.X := 0;
  Best.Y := 0;
  Best.Correlation := 0;
  Best.Scale := Scale; // record scale
  Worst := 1;

  NextBest := Best;
  ThirdBest := Best;
  FourthBest := Best;

  BestFound := Best;
  NextBestFound := Best;
  ThirdBestFound := Best;
  FourthBestFound := Best;

  // *****************************************************************************
  // do first level correlation scan

  PosX := 0;
  PosY := 0;

  RangeX := ImageResizedSearch.Width - ImageResizedReference.Width; // search enlargement range dirrerential only
  RangeY := ImageResizedSearch.Height - ImageResizedReference.Height;

  X := Max(RangeX, RangeY);

  Z := X div 8; // do a test every 8 pixels
  for X := -Z to Z do
  begin
    for Y := -Z to Z do
    begin
      PosX := X * 8;
      PosY := Y * 8;
      if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
        DoCorrelation;
    end;
  end;

  BestFound := Best; // best within 8 pixels at this scale
  NextBestFound := NextBest;
  ThirdBestFound := ThirdBest;
  FourthBestFound := FourthBest;

  // *****************************************************************************
  // try best location to determine best result

  for X := -6 to 6 do // do a test every pixel
    for Y := -6 to 6 do
    begin
      PosX := BestFound.X + X;
      PosY := BestFound.Y + Y;
      if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
        DoCorrelation;
    end;

  // *****************************************************************************
  // try next best location to determine best result
  if (abs(NextBestFound.X - BestFound.X) > 6) and (abs(NextBestFound.Y - BestFound.Y) > 6) then
  begin // if not within range of best test then
    for X := -6 to 6 do // do a test every pixel
      for Y := -6 to 6 do
      begin
        PosX := NextBestFound.X + X;
        PosY := NextBestFound.Y + Y;
        if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
          DoCorrelation;
      end;
  end;

  // *****************************************************************************
  // try third best location to determine best result
  if (abs(ThirdBestFound.X - BestFound.X) > 6) and (abs(ThirdBestFound.Y - BestFound.Y) > 6) and (abs(ThirdBestFound.X - NextBestFound.X) > 6) and
    (abs(ThirdBestFound.Y - NextBestFound.Y) > 6) then
  begin // if not within range of best test or next best test then
    for X := -6 to 6 do // do a test every pixel
      for Y := -6 to 6 do
      begin
        PosX := ThirdBestFound.X + X;
        PosY := ThirdBestFound.Y + Y;
        if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
          DoCorrelation;
      end;
  end;

  // *****************************************************************************
  // try fourth best location to determine best result
  if (abs(FourthBestFound.X - BestFound.X) > 6) and (abs(FourthBestFound.Y - BestFound.Y) > 6) and (abs(FourthBestFound.X - NextBestFound.X) > 6) and
    (abs(FourthBestFound.Y - NextBestFound.Y) > 6) and (abs(FourthBestFound.X - ThirdBestFound.X) > 6) and (abs(FourthBestFound.Y - ThirdBestFound.Y) > 6) then
  begin // if not within range of best test or next best test or third best test then
    for X := -6 to 6 do // do a test every pixel
      for Y := -6 to 6 do
      begin
        PosX := FourthBestFound.X + X;
        PosY := FourthBestFound.Y + Y;
        if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
          DoCorrelation;
      end;
  end;

  // ******************************************************************************
  // IF LARGE SCALE THEN RETEST RESULT AT BEST RESOLUTION TO OBTAIN BETTER FINAL RESULT
  if Best.Scale > 1 then
  begin
    OldScale := Scale; // preserve old scale
    Scale := 1; // better resolution for final test

    BestFound.X := Round(BestFound.X * OldScale / Scale); // rescale to keep units correct
    BestFound.Y := Round(BestFound.Y * OldScale / Scale);
    BestFound.Scale := Scale;

    FreeImage(ImageResizedSearch);
    FreeImage(ImageResizedReference);

    ImageResizedSearch := CreateImage(ImageSearchWindow.Width div Scale, ImageSearchWindow.Height div Scale);
    ImageResizedReference := CreateImage(ImageReference.Width div Scale, ImageReference.Height div Scale);

    FilterResize1 := TFilterResize.Create;
    FilterResize1.setParameterImage('INIMAGE', ImageSearchWindow);
    FilterResize1.setParameterImage('OUTIMAGE', ImageResizedSearch);
    FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
    FilterResize1.Run;
    FilterResize1.Free;

    FilterResize1 := TFilterResize.Create;
    FilterResize1.setParameterImage('INIMAGE', ImageReference);
    FilterResize1.setParameterImage('OUTIMAGE', ImageResizedReference);
    FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
    FilterResize1.Run;
    FilterResize1.Free;

    // *****************************************************************************

    RangeX := ImageResizedSearch.Width;
    RangeY := ImageResizedSearch.Height;

    for X := -4 to 4 do // do a test every pixel
      for Y := -4 to 4 do
      begin
        PosX := BestFound.X + X;
        PosY := BestFound.Y + Y;
        if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
          DoCorrelation;
      end;
  end;

  // *****************************************************************************
  // test magnitude or result to determine success

  if (Best.Correlation >= VisionCorrelationLimit) and (Best.Correlation - Worst > 0.05) then
  begin
    VisionCorrelation := Best.Correlation;
    VisionCentreX := Best.X * Best.Scale;
    VisionCentreY := -Best.Y * Best.Scale; // fix Y axis reversal due to image line order

    // ******************************************************************************

    if (Angle <> 0) then // if angle <> 0 then ROTATE result to compensate for rotation
    begin
      OldX := VisionCentreX;
      OldY := VisionCentreY;

      VisionCentreX := (OldX * Cos(Angle * Pi / 180)) - (OldY * Sin(Angle * Pi / 180));
      VisionCentreY := (OldY * Cos(Angle * Pi / 180)) + (OldX * Sin(Angle * Pi / 180));
    end;

    // ******************************************************************************

    if UseUpCamera then
      VisionCentreX := -VisionCentreX; // reverse X if uplooking

    // ******************************************************************************

    VisionCentreX := VisionCentreX * PixelSize; // convert to mm
    VisionCentreY := VisionCentreY * PixelSize;

    Result := true; // passed - part matches expected
  end
  else
  begin
    VisionCorrelation := 0;
    VisionCentreX := 0;
    VisionCentreY := 0;
    Result := false;
  end;
  VisionAngle := 0; // angle not determined

  // *****************************************************************************
  // dispose of images
  FreeImage(ImageResizedSearch);
  FreeImage(ImageResizedReference);
  FreeImage(ImageSearchWindow);
  FreeImage(ImageTemp);

  // ******************************************************************************

  LabelVisionResult.Caption := 'Correlation = ' + FloatToStrF(VisionCorrelation, ffFixed, 10, 2) + '  X = ' + FloatToStrF(VisionCentreX, ffFixed, 10, 2) +
    'mm  Y = ' + FloatToStrF(VisionCentreY, ffFixed, 10, 2) + 'mm';

  if VisionTestMode then
    FormVisiontest.Close;
end;

function TFormMain.AngularVisualCorrelation(Angle: double; EnlargeMM: Integer): Boolean;
type
  TestRec = record
    Correlation: double;
    Angle: double;
    CentreX: double;
    CentreY: double;
  end;

var
  C, AngleStep, OldAngleStep: double;
  X, Y, Scale: Integer;
  Best, Best1: TestRec;
  PixelSize: double;
  SearchWidth, SearchHeight, Top, Bottom, Left, Right, Enlargement: Integer;
  ImageToSearch: PBitmap32;
  FilterWindow1: TFilterWindow;

  procedure AngularCorrelation(TestAngle: double; Scale: Integer);
  type
    FindRec = record
      Correlation: single;
      X: Integer;
      Y: Integer;
      Scale: Integer;
    end;
  var
    X, Y, Z, PosX, PosY, RangeX, RangeY: Integer;
    SearchWidth, SearchHeight, Top, Bottom, Left, Right: Integer;
    FilterCorrelation1: TFilterNormalisedCrossCorrelation;
    FilterWindow1: TFilterWindow;
    FilterResize1: TFilterResize;
    FilterRotation1: TFilterRotation;
    Correlation, Worst: double;
    ImageSearchWindow, ImageResizedSearch, ImageResizedPreSearch, ImageResizedReference: PBitmap32;
    Best, NextBest, ThirdBest, FourthBest, BestFound, NextBestFound, ThirdBestFound, FourthBestFound: FindRec;

    function EvaluateImage(X, Y: Integer): double;
    begin
      FilterCorrelation1 := TFilterNormalisedCrossCorrelation.Create;
      FilterCorrelation1.setParameterImage('INIMAGETOSEARCH', ImageResizedSearch); // image to search
      FilterCorrelation1.setParameterImage('INIMAGETOFIND', ImageResizedReference); // reference to find
      FilterCorrelation1.setParameterInteger('X', X); // offset
      FilterCorrelation1.setParameterInteger('Y', Y); // offset
      FilterCorrelation1.Run;
      Result := FilterCorrelation1.GetOutputParameterSingle('CORRELATION').Value;
      FilterCorrelation1.Free;
    end;

    procedure DoCorrelation;
    begin
      Correlation := EvaluateImage(PosX, PosY); // analyse correlation

      if Correlation > Best.Correlation then
      begin
        FourthBest := ThirdBest;
        ThirdBest := NextBest;
        NextBest := Best; // use best as next best
        Best.Correlation := Correlation;
        Best.X := PosX;
        Best.Y := PosY;
        Best.Scale := Scale;
      end;

      if Correlation < Worst then
        Worst := Correlation; // preserve worst
    end;

  begin // size the search image to include the enlargement
    X := Max(ImageReference.Width, ImageReference.Height); // find largest dimension

    SearchWidth := X + Enlargement; // search window area enlargement {squared }
    SearchHeight := X + Enlargement;

    if (SearchWidth < ImageToSearch.Width) and (SearchHeight < ImageToSearch.Height) then // if window required
    begin
      ImageSearchWindow := CreateImageLike(ImageToSearch); // create window image

      Bottom := (ImageToSearch.Height div 2) - (SearchHeight div 2);
      Top := Bottom + SearchHeight;
      Left := (ImageToSearch.Width div 2) - (SearchWidth div 2);
      Right := Left + SearchWidth;

      FilterWindow1 := TFilterWindow.Create; // get windowed portion
      FilterWindow1.setParameterImage('INIMAGE', ImageToSearch);
      FilterWindow1.setParameterImage('OUTIMAGE', ImageSearchWindow);
      FilterWindow1.setParameterInteger('TOP', Top);
      FilterWindow1.setParameterInteger('BOTTOM', Bottom);
      FilterWindow1.setParameterInteger('LEFT', Left);
      FilterWindow1.setParameterInteger('RIGHT', Right);
      FilterWindow1.Run;
      FilterWindow1.Free;

    end
    else
      ImageSearchWindow := CreateImageFromImage(ImageToSearch); // else use original

    { ****************************************************************************** }
    // scale and blur image for better match and to increase speed!!

    ImageResizedPreSearch := CreateImage(ImageSearchWindow.Width div Scale, ImageSearchWindow.Height div Scale);
    ImageResizedReference := CreateImage(ImageReference.Width div Scale, ImageReference.Height div Scale);

    FilterResize1 := TFilterResize.Create;
    FilterResize1.setParameterImage('INIMAGE', ImageSearchWindow);
    FilterResize1.setParameterImage('OUTIMAGE', ImageResizedPreSearch);
    FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
    FilterResize1.Run;
    FilterResize1.Free;

    FilterResize1 := TFilterResize.Create;
    FilterResize1.setParameterImage('INIMAGE', ImageReference);
    FilterResize1.setParameterImage('OUTIMAGE', ImageResizedReference);
    FilterResize1.setParameterInteger('MODE', 1); // apply gaussian blur to image
    FilterResize1.Run;
    FilterResize1.Free;

    // ******************************************************************************
    // rotate image to requested angle

    if TestAngle <> 0 then
    begin
      FilterRotation1 := TFilterRotation.Create; // rotate image
      FilterRotation1.setParameterImage('INIMAGE', ImageResizedPreSearch);
      FilterRotation1.setParameterSingle('ANGLE', TestAngle);
      FilterRotation1.Run;
      ImageResizedSearch := CreateImageFromImage(FilterRotation1.GetOutputParameterImage('OUTIMAGE').Image);
      FilterRotation1.Free;
    end
    else
      ImageResizedSearch := CreateImageFromImage(ImageResizedPreSearch);

    // ******************************************************************************

    if VisionTestMode then
    begin
      ShowImage(ImageResizedSearch, FormVisiontest.ImageSearch);
      ShowImage(ImageResizedReference, FormVisiontest.ImageReference);
      MessageDlg('SINGLE STEP!', mtInformation, [mbOk], 0, mbOk);
    end;

    // ******************************************************************************

    Best.X := 0;
    Best.Y := 0;
    Best.Correlation := 0;
    Best.Scale := Scale; // record scale
    Worst := 1;

    NextBest := Best;
    ThirdBest := Best;
    FourthBest := Best;

    BestFound := Best;
    NextBestFound := Best;
    ThirdBestFound := Best;
    FourthBestFound := Best;

    // *****************************************************************************
    // do first level correlation scan
    // *****************************************************************************
    PosX := 0;
    PosY := 0;

    RangeX := ImageResizedSearch.Width - ImageResizedReference.Width; // search enlargement range differential only
    RangeY := ImageResizedSearch.Height - ImageResizedReference.Height;

    X := Max(RangeX, RangeY);

    Z := X div 8; // do a test every 8 pixels
    for X := -Z to Z do
    begin
      for Y := -Z to Z do
      begin
        PosX := X * 8;
        PosY := Y * 8;
        if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
          DoCorrelation;
      end;
    end;

    BestFound := Best; // best 8 pixels at this scale
    NextBestFound := NextBest;
    ThirdBestFound := ThirdBest;
    FourthBestFound := FourthBest;

    // *****************************************************************************
    // try best locations to determine best result
    // *****************************************************************************
    for X := -7 to 7 do // do a test every pixel
      for Y := -7 to 7 do
      begin
        if (X <> 0) and (Y <> 0) then
        begin
          PosX := BestFound.X + X;
          PosY := BestFound.Y + Y;
          if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
            DoCorrelation;
        end;
      end;

    // *****************************************************************************
    // try next best location to determine best result
    // *****************************************************************************
    if (abs(NextBestFound.X - BestFound.X) > 7) and (abs(NextBestFound.Y - BestFound.Y) > 7) then
    begin // if not within range of best test then
      for X := -7 to 7 do // do a test every pixel
        for Y := -7 to 7 do
        begin
          if (X <> 0) and (Y <> 0) then
          begin
            PosX := NextBestFound.X + X;
            PosY := NextBestFound.Y + Y;
            if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
              DoCorrelation;
          end;
        end;
    end;

    // *****************************************************************************
    // try third best location to determine best result
    // *****************************************************************************
    if (abs(ThirdBestFound.X - BestFound.X) > 7) and (abs(ThirdBestFound.Y - BestFound.Y) > 7) and (abs(ThirdBestFound.X - NextBestFound.X) > 7) and
      (abs(ThirdBestFound.Y - NextBestFound.Y) > 7) then
    begin // if not within range of best test or next best test then
      for X := -7 to 7 do // do a test every pixel
        for Y := -7 to 7 do
        begin
          if (X <> 0) and (Y <> 0) then
          begin
            PosX := ThirdBestFound.X + X;
            PosY := ThirdBestFound.Y + Y;
            if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
              DoCorrelation;
          end;
        end;
    end;

    // *****************************************************************************
    // try fourth best location to determine best result
    // *****************************************************************************
    if (abs(FourthBestFound.X - BestFound.X) > 7) and (abs(FourthBestFound.Y - BestFound.Y) > 7) and (abs(FourthBestFound.X - NextBestFound.X) > 7) and
      (abs(FourthBestFound.Y - NextBestFound.Y) > 7) and (abs(FourthBestFound.X - ThirdBestFound.X) > 7) and (abs(FourthBestFound.Y - ThirdBestFound.Y) > 7)
    then
    begin // if not within range of best test or next best test or third best test then
      for X := -7 to 7 do // do a test every pixel
        for Y := -7 to 7 do
        begin
          if (X <> 0) and (Y <> 0) then
          begin
            PosX := FourthBestFound.X + X;
            PosY := FourthBestFound.Y + Y;
            if (PosX <= RangeX) and (PosX >= -RangeX) and (PosY <= RangeY) and (PosY >= -RangeY) then
              DoCorrelation;
          end;
        end;
    end;

    // *****************************************************************************
    VisionCorrelation := Best.Correlation;
    VisionCentreX := Best.X * Best.Scale;
    VisionCentreY := -Best.Y * Best.Scale; // fix Y axis reversal due to image line order

    // *****************************************************************************
    // dispose of images
    // *****************************************************************************
    FreeImage(ImageResizedSearch);
    FreeImage(ImageResizedPreSearch);
    FreeImage(ImageResizedReference);
    FreeImage(ImageSearchWindow);
  end;

// ******************************************************************************
begin
  if VisionTestMode then
    FormVisiontest.Show;

  // ******************************************************************************
  try // set pixel size in mm
    PixelSize := UplookingViewWidthInMM / ImageUplooking.Width;
  except
    PixelSize := 0.0625; // default
  end;

  X := Max(ImageReference.Width, ImageReference.Height); // find largest dimension

  Scale := Succ(Trunc(X / 50)); // full resolution for smaller images
  if Scale > 6 then
    Scale := 6;

  // ******************************************************************************
  // size the search image to include the enlargement
  Enlargement := Round(EnlargeMM / PixelSize); // enlargement of search area in pixels

  // ******************************************************************************
  X := Max(ImageReference.Width, ImageReference.Height); // find largest dimension

  SearchWidth := X + Enlargement; // search window area enlargement {squared }
  SearchHeight := X + Enlargement;

  // ******************************************************************************
  if (SearchWidth < ImageUplooking.Width) and (SearchHeight < ImageUplooking.Height) then // if window required
  begin
    ImageToSearch := CreateImageLike(ImageUplooking); // create window image

    Bottom := (ImageUplooking.Height div 2) - (SearchHeight div 2);
    Top := Bottom + SearchHeight;
    Left := (ImageUplooking.Width div 2) - (SearchWidth div 2);
    Right := Left + SearchWidth;

    FilterWindow1 := TFilterWindow.Create; // get windowed portion
    FilterWindow1.setParameterImage('INIMAGE', ImageUplooking);
    FilterWindow1.setParameterImage('OUTIMAGE', ImageToSearch);
    FilterWindow1.setParameterInteger('TOP', Top);
    FilterWindow1.setParameterInteger('BOTTOM', Bottom);
    FilterWindow1.setParameterInteger('LEFT', Left);
    FilterWindow1.setParameterInteger('RIGHT', Right);
    FilterWindow1.Run;
    FilterWindow1.Free;
  end
  else
    ImageToSearch := CreateImageFromImage(ImageUplooking); // else use original

  // ******************************************************************************
  Best.Correlation := 0; // resolve best angle by successive approximation
  Best.Angle := 0;
  Best.CentreX := 0;
  Best.CentreY := 0;
  Best1 := Best;

  // ******************************************************************************
  try // determine minimum angle at this resolution
    AngleStep := ArcTan(1 / ((ImageReference.Width / 2) / Scale)) / Pi * 180;
  except
    AngleStep := 1;
  end;

  // ******************************************************************************
  Y := Ceil(UplookingCameraAngleTestLimit / AngleStep); // determine number of iterations

  for X := Y Downto 0 do // try +/- angle test limit
  begin
    AngularCorrelation(Angle + (X * AngleStep), Scale);
    C := VisionCorrelation;

    if C > Best.Correlation then
    begin
      Best.Correlation := C;
      Best.Angle := X * AngleStep;
      Best.CentreX := VisionCentreX;
      Best.CentreY := VisionCentreY;
    end;

    AngularCorrelation(Angle + (-X * AngleStep), Scale);
    C := VisionCorrelation;

    if C > Best.Correlation then
    begin
      Best.Correlation := C;
      Best.Angle := -X * AngleStep;
      Best.CentreX := VisionCentreX;
      Best.CentreY := VisionCentreY;
    end;
  end;

  // ******************************************************************************
  if (Best.Correlation > 0) and (abs(Best.Angle) < UplookingCameraAngleTestLimit) then // if object found
  begin
    Best1 := Best; // use best as start point

    // ******************************************************************************
    X := Max(ImageReference.Width, ImageReference.Height); // find largest dimension

    if Scale > 1 then // if scale is not 1 then do next phase
    begin
      Scale := Succ(Trunc(X / 50)); // full resolution for smaller images
      if Scale > 3 then
        Scale := 3;

      // ******************************************************************************
      OldAngleStep := AngleStep; // preserve old step size

      try // determine minimum angle at this resolution
        AngleStep := ArcTan(1 / ((ImageReference.Width / 2) / Scale)) / Pi * 180;
      except
        AngleStep := 1;
      end;

      // ******************************************************************************
      Y := Ceil(OldAngleStep / AngleStep); // determine number of iterations

      for X := Y Downto 0 do // try +/- old angle step
      begin
        AngularCorrelation(Angle + (Best1.Angle + (X * AngleStep)), Scale);
        C := VisionCorrelation;

        if C > Best.Correlation then
        begin
          Best.Correlation := C;
          Best.Angle := Best1.Angle + (X * AngleStep);
          Best.CentreX := VisionCentreX;
          Best.CentreY := VisionCentreY;
        end;

        AngularCorrelation(Angle + (Best1.Angle - (X * AngleStep)), Scale);
        C := VisionCorrelation;

        if C > Best.Correlation then
        begin
          Best.Correlation := C;
          Best.Angle := Best1.Angle - (X * AngleStep);
          Best.CentreX := VisionCentreX;
          Best.CentreY := VisionCentreY;
        end;
      end;
    end;
  end
  else
  begin
    Best.Correlation := 0; // failure
    Best.Angle := 0;
    Best.CentreX := 0;
    Best.CentreY := 0;
  end;

  // ******************************************************************************
  if (Best.Correlation >= VisionCorrelationLimit) then // VisionCorrelationLimit or better
  begin
    if (Best.Angle <> 0) then // if angle <> 0 then ROTATE result ANTICLOCKWISE to compensate for initial rotation
    begin
      VisionCentreX := (Best.CentreX * Cos(Best.Angle * Pi / 180)) - (Best.CentreY * Sin(Best.Angle * Pi / 180));
      VisionCentreY := (Best.CentreY * Cos(Best.Angle * Pi / 180)) + (Best.CentreX * Sin(Best.Angle * Pi / 180));
    end
    else
    begin
      VisionCentreX := Best.CentreX; // use actual results
      VisionCentreY := Best.CentreY;
    end;

    // ******************************************************************************

    VisionCentreX := -VisionCentreX; // reverse x for uplooking camera

    // ******************************************************************************

    VisionCorrelation := Best.Correlation; // set correlation result
    VisionAngle := Best.Angle;

    VisionCentreX := VisionCentreX * PixelSize; // convert back to mm for CNC
    VisionCentreY := VisionCentreY * PixelSize;

    Result := true; // passed
  end
  else
    Result := false; // failed

  FreeImage(ImageToSearch);

  LabelVisionResult.Caption := 'Correlation = ' + FloatToStrF(VisionCorrelation, ffFixed, 10, 2) + '  Angle = ' + FloatToStrF(VisionAngle, ffFixed, 10, 2) +
    'Deg.  X = ' + FloatToStrF(VisionCentreX, ffFixed, 10, 2) + 'mm  Y = ' + FloatToStrF(VisionCentreY, ffFixed, 10, 2) + 'mm';
  // ******************************************************************************

  if VisionTestMode then
    FormVisiontest.Close;
end;

end.
