unit NewProject;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Vcl.Mask;

type
  TFormNewProject = class(TForm)
    ButtonCancel: TBitBtn;
    ButtonOk: TBitBtn;
    EditProjectName: TLabeledEdit;
    Label1: TLabel;
    procedure EditProjectNameChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditProjectNameKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure UpdateButtons;
  public
    { Public declarations }
  end;

var
  FormNewProject: TFormNewProject;

implementation

{$R *.dfm}

uses
  Main, Settings;

procedure TFormNewProject.EditProjectNameKeyPress(Sender: TObject; var Key: Char);
begin // suppress illegal characters
  if (Key = '/') or (Key = '\') or (Key = '*') or (Key = '?') or (Key = '|') or (Key = '"') or (Key = ':') or (Key = '<') or (Key = '>') or (Key = '$') then
    Key := #0;
end;

procedure TFormNewProject.FormShow(Sender: TObject);
begin
  Enabled := false;
  EditProjectName.Text := ''; // blank name
  Enabled := true;
  UpdateButtons;
end;

procedure TFormNewProject.UpdateButtons;
begin
  ButtonOk.Enabled := EditProjectName.Text <> '';
end;

procedure TFormNewProject.EditProjectNameChange(Sender: TObject);
begin
  if Enabled then
  begin // use project name as both project path and project name
    ProjectPath := IncludeTrailingPathDelimiter(IncludeTrailingPathDelimiter(Data_Directory) + EditProjectName.Text);
    ProjectName := EditProjectName.Text;

    ButtonOk.Enabled := EditProjectName.Text <> '';
  end;
end;

end.
