program PickAndPlace2;

uses
  Windows,
  Dialogs,
  Forms,
  Main in 'Main.pas' {FormMain} ,
  Settings in 'Settings.pas',
  DeskWinApi in 'DeskWinApi.pas',
  DeskWinCNC in 'DeskWinCNC.pas',
  CNCSettings in 'CNCSettings.pas' {FormCNCSettings} ,
  VisionSettings in 'VisionSettings.pas' {FormVisionSettings} ,
  NozzleChanger in 'NozzleChanger.pas' {FormNozzleChanger} ,
  Feeders in 'Feeders.pas' {FormFeeders} ,
  HomeSettings in 'HomeSettings.pas' {FormHomeSettings} ,
  CreateSnap in 'CreateSnap.pas' {FormCreateSnap} ,
  RejectTray in 'RejectTray.pas' {FormRejectTray} ,
  FiducialSettings in 'FiducialSettings.pas' {FormFiducialSettings} ,
  NozzleOffset in 'NozzleOffset.pas' {FormNozzleOffset} ,
  NewProject in 'NewProject.pas' {FormNewProject} ,
  ImportPlaceFile in 'ImportPlaceFile.pas' {FormImportPlaceFile} ,
  ConfirmNozzleSelection in 'ConfirmNozzleSelection.pas' {FormConfirmNozzleSelection} ,
  PanelSettings in 'PanelSettings.pas' {FormPanelSettings} ,
  VisionTest in 'VisionTest.pas' {FormVisionTest} ,
  Vcl.Themes,
  Vcl.Styles;

{$R *.res}

var
  Mutex: THandle;

begin
  Mutex := CreateMutex(nil, True, '{5EFC21A1-0A6B-43F7-A13E-E572F1FD36FF}');
  // use a GUID to be unique
  if (Mutex = 0) or (GetLastError = ERROR_ALREADY_EXISTS) then
  begin
    ShowMessage('You already have a copy of this program running.');
  end
  else
  begin
    Application.Initialize;
    Application.MainFormOnTaskbar := True;
    TStyleManager.TrySetStyle('Amethyst Kamri');
  Application.CreateForm(TFormMain, FormMain);
    Application.CreateForm(TFormCNCSettings, FormCNCSettings);
    Application.CreateForm(TFormVisionSettings, FormVisionSettings);
    Application.CreateForm(TFormNozzleChanger, FormNozzleChanger);
    Application.CreateForm(TFormFeeders, FormFeeders);
    Application.CreateForm(TFormHomeSettings, FormHomeSettings);
    Application.CreateForm(TFormCreateSnap, FormCreateSnap);
    Application.CreateForm(TFormRejectTray, FormRejectTray);
    Application.CreateForm(TFormFiducialSettings, FormFiducialSettings);
    Application.CreateForm(TFormNozzleOffset, FormNozzleOffset);
    Application.CreateForm(TFormNewProject, FormNewProject);
    Application.CreateForm(TFormImportPlaceFile, FormImportPlaceFile);
    Application.CreateForm(TFormConfirmNozzleSelection, FormConfirmNozzleSelection);
    Application.CreateForm(TFormPanelSettings, FormPanelSettings);
    Application.CreateForm(TFormVisionTest, FormVisionTest);
    Application.Run;
  end;

end.
