unit filterImageSaver;
(* ***** BEGIN LICENSE BLOCK *****
  * Copyright (C) 2004 Durand Emmanuel
  * Copyright (C) 2004 Burgel Eric
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Contact :
  *   filters@edurand.com
  *   filters@burgel.com
  *
  * ***** END LICENSE BLOCK ***** *)

{
  edurand (filters@edurand.com)
}

interface

uses
  filter, fparameters, image;

type
  TFilterImageSaver = class(TFilter)
  public
    constructor Create; override;
    destructor Destroy; override;
    procedure Run(); override;
  private
    parameterFileName: TParameterString;
    parameterImageIn: TParameterImage;
  end;

implementation

uses
  imageIO, classes;

constructor TFilterImageSaver.Create;
begin
  inherited;
  parameterFileName := addParameterString('fileName', 'file name to save', '');
  parameterImageIn := addParameterImage('inImage', 'image to save');
end;

destructor TFilterImageSaver.Destroy;
begin
  inherited;
end;

procedure TFilterImageSaver.Run();
var
  filename: String;
  image: PBitmap32;
begin
  filename := parameterFileName.Value;
  image := parameterImageIn.image;
  if image <> nil then
  begin
    imageIO.copyImageToFile(image, filename);
  end;
end;

end.
