unit lacModel;

interface

Type

  TDrip = Record
    Height: Single;
    Speed: Single;
  End;

  TWater = Array [0 .. 0] of TDrip;
  PWater = ^TWater;

  TLac = class
  private
  private
    m_width: Integer; // Largeur du lac
  private
    m_height: Integer; // Hauteur du lac
  private
    m_taille: Integer; // Taille du tableau contenant le lac
  private
    m_amortissement: Single;
  private
    lac1, lac2, lac, newLac: PWater;
  private
    lac_0_m1, Lac_0_0, Lac_0_p1, Lac_m1_0, Lac_p1_0: PWater;
  public
    globalRefringeance: Single;
  public
    constructor create(aWidth, aHeight: Integer);
    destructor done();
    procedure compute();
    procedure setPoint(X, Y: Integer; value: Single);
    function getPoint(X, Y: Integer): Single;
  End;

implementation

// Contructor
constructor TLac.create(aWidth, aHeight: Integer);
Var
  X: Integer;
Begin
  m_width := aWidth;
  m_height := aHeight;
  m_taille := (m_width + 2) * (m_height + 2);

  GetMem(lac1, m_taille * sizeof(TWater));
  GetMem(lac2, m_taille * sizeof(TWater));
  lac := lac1;
  newLac := lac2;

  for X := 0 to m_taille - 1 do
  Begin
    lac1^[X].Height := 0;
    lac1^[X].Speed := 0;
    lac2^[X].Height := 0;
    lac2^[X].Speed := 0;
  End;

  m_amortissement := 0.99;
  globalRefringeance := 1;

  setPoint(m_width div 2, m_height div 2, 250);
End;

// ********* Getters and Setters ****************
procedure TLac.setPoint(X, Y: Integer; value: Single);
var
  position: Integer;
Begin
  position := (Y + 1) * (m_width + 2) + X + 1;
  lac[position].Height := value;
  lac[position].Speed := 0;
End;

function TLac.getPoint(X, Y: Integer): Single;
var
  position: Integer;
Begin
  position := (Y + 1) * (m_width + 2) + X + 1;
  result := lac[position].Height;
End;

// *** Compute a step
procedure TLac.compute();
Var
  i: Integer;
  v: Single;
Begin
  // Initialisation
  lac_0_m1 := lac;
  inc(lac_0_m1);
  Lac_0_0 := lac_0_m1;
  inc(Lac_0_0, m_width + 2);
  Lac_0_p1 := Lac_0_0;
  inc(Lac_0_p1, m_width + 2);
  Lac_m1_0 := Lac_0_0;
  dec(Lac_m1_0, 1);
  Lac_p1_0 := Lac_0_0;
  inc(Lac_p1_0);

  // Update Speeds ;
  for i := m_width * m_height - 1 downto 0 do
  Begin
    v := Lac_0_0[0].Height / 4;
    Lac_0_0[0].Speed := Lac_0_0[0].Speed - v * 4;
    lac_0_m1[0].Speed := lac_0_m1[0].Speed + v;
    Lac_m1_0[0].Speed := Lac_m1_0[0].Speed + v;
    Lac_p1_0[0].Speed := Lac_p1_0[0].Speed + v;
    Lac_0_p1[0].Speed := Lac_0_p1[0].Speed + v;
    inc(lac_0_m1);
    inc(Lac_m1_0);
    inc(Lac_0_0);
    inc(Lac_p1_0);
    inc(Lac_0_p1);
  End;

  // Update Heights
  Lac_0_0 := lac;
  inc(Lac_0_0, m_width + 1);
  for i := m_width * m_height - 1 downto 0 do
  Begin
    Lac_0_0[0].Height := Lac_0_0[0].Height + Lac_0_0[0].Speed;
    inc(Lac_0_0);
  End;

End;

Destructor TLac.done();
Begin
  dispose(lac1);
  dispose(lac2);
End;

end.
